// JavaScript Document
/*使用するイベントハンドラではthisがイベント登録対象になるのでAnimeBalloonであるthisを変数で格納*/
var animeTimer;
var animeBalloon;

AnimeBalloon = function(max, def, w, h, change, capture, remove)
{
	try
	{
		animeBalloon = this;
		
		this.min = 0;
		this.max;
		
		this.def;
		this.prev;
		
		this.speedArray = [0.2, 0.5, 1, 2, 5];
		this.speedIndex = 2;
		
		this.step = [];
		
		this.targetID = "";
		
		this.ss = new createjs.Stage(document.getElementById("balloonCanvas"));
		
		this.scW  = w;
		this.scH = h;
		
		
		
		document.getElementById("balloonCanvas").width = w;
		document.getElementById("balloonCanvas").height = h;
		
		//変更時に呼び出す関数
		this.changeFnc = change;
		
		//キャプチャ時に呼び出す関数
		this.captureFnc = capture;
		
		//キャプチャ削除時に呼び出す関数
		this.removeFnc = remove;
		
		this.pointSpan;
		
		this.marginTB = 5;
		this.marginLR = 5;
		
		this.loopMode = 0;
		//デフォルトで0に進むように設定
		this.loopFlag = false;
		
		//最小から再生ボタンで最大に戻る場合
		this.returnFlag = false;
		
		this.sLine = new createjs.Shape();
		this.ss.addChild(this.sLine);
		
		this.sPoint = new createjs.Shape();
		this.sPoint.graphics.setStrokeStyle(0);
		this.sPoint.graphics.beginStroke("#000000");
		this.sPoint.graphics.beginFill("#000000");
		this.sPoint.graphics.drawCircle(0, 0, 5);
		this.sPoint.graphics.endFill();
		this.sPoint.graphics.endStroke();
		this.ss.addChild(this.sPoint);
		
		/*値を設定*/
		setSliderData(this.min, max, def, def);
		
		initAnimeBalloon();
	}
	catch(e)
	{
		alert("AnimeBalloon setAnimeBalloon:" + e.toString());
	}
};

function initAnimeBalloon()
{
	try
	{
		//最大変更
		document.getElementById("slMax").addEventListener("click", changeLimitHandler);
		document.getElementById("srMax").addEventListener("click", changeLimitHandler);
		
		//再生
		document.getElementById("playBtn").addEventListener("click", playAnimationHandler);
		
		//ループ
		document.getElementById("loopBtn").addEventListener("click", changeLoopHandler);
		
		//速度
		document.getElementById("speedConfig").addEventListener("click", changeSpeedHandler);
		
		//キャプチャ
		document.getElementById("captureBtn").addEventListener("click", captureDataHandler);
		
		//削除
		document.getElementById("removeBtn").addEventListener("click", removeCaptureHandler);
		
	}
	catch(e)
	{
		alert("initAnimeBalloon:" + e.toString());
	}
}

function setSliderData(min, max, def, prev)
{
	try
	{
		animeBalloon.max = max;
		animeBalloon.def = def;
		animeBalloon.prev = prev;
		
		document.getElementById("tMin").innerHTML = min;
		document.getElementById("tMax").innerHTML = max;
			
		$("#tMin").css("margin", "0px 10px");
		$("#tMax").css("margin", "0px 10px");
		
		changeStep(max);
		
		animeBalloon.changeSliderLine();
		animeBalloon.changeSliderPoint();
	}
	catch(e)
	{
		alert("setSliderData:" + e.toString());
	}
}

function changeStep(max)
{
	try
	{
		//1より小さい値でだんだん小さくなるような形で数値を設定
		animeBalloon.step = [0, 0.001, 0.002, 0.004, 0.006, 0.008, 0.02, 0.04, 0.06, 0.08, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.8];
		
		for(var i=1; i<=max; i++)
		{
			animeBalloon.step.push(i);
		}
	}
	catch(e)
	{
		alert("changeStep:" + e.toString());
	}
}

function changeLimitHandler(e)
{
	try
	{

		if(animeFlag == false)
		{
			var f = false;
			
			var maxIndex = animeBalloon.step.indexOf(animeBalloon.max)
				
			//最大値の変更
			//最大値の増加
			if(e.target.id == "srMax")
			{
				//現stepでの最大値の場合
				if(maxIndex == animeBalloon.step.length-1)
				{
					animeBalloon.max = animeBalloon.step[animeBalloon.step.length-1]+1;

					//段階の変更
					changeStep(animeBalloon.max);
				}
				else
				{
					animeBalloon.max = animeBalloon.step[maxIndex+1];
				}

				f = true;
			}
			else
			{
				//現stepでの最大値の場合
				if(animeBalloon.max > 1)
				{
					animeBalloon.max = animeBalloon.step[animeBalloon.step.length-1]-1;
					
					//段階の変更
					changeStep(animeBalloon.max);

					f = true;
				}
			}
			
			if(f)
			{
				var f1 = false;
				
				//コントロールの位置が変わる場合
				if(animeBalloon.prev > animeBalloon.max)
				{
					animeBalloon.prev = animeBalloon.max;
					
					f1 = true;
				}
				
				$("#tMax").html(slider.max);
				
				//現在の値が変わる場合
				if(f1)
				{
					animeBalloon.changeFnc();
				}

				//スライダの状態を変更
				animeBalloon.changeSliderLine();
				animeBalloon.changeSliderPoint();
			}
		}
	}
	catch(e)
	{
		alert("AnimeBalloon changeLimitHandler:" + e.toString());
	}
}

AnimeBalloon.prototype.changeSliderLine = function()
{
	try
	{
		this.sLine.graphics.clear();
		
		this.sLine.graphics.setStrokeStyle(2);
		this.sLine.graphics.beginStroke("#000000");
		this.sLine.graphics.moveTo(this.marginLR, this.scH/2);
		
		this.sLine.graphics.lineTo(this.scW-this.marginLR, this.scH/2);
		
		var minNum = 0;
		var maxNum = this.step[this.step.length-1];
		var leng = this.scW - this.marginLR * 2;

		//末尾の縦線
		this.sLine.graphics.moveTo(this.scW-this.marginLR, animeBalloon.scH/2-animeBalloon.marginTB*2);
		this.sLine.graphics.lineTo(this.scW-this.marginLR, animeBalloon.scH/2+animeBalloon.marginTB*2);

		var f = true;
		
		var i=0;
		var j=this.step.length;
		
		for(i; i<j; i++)
		{
			//線を引く位置
			var rX = this.step[i] * leng/maxNum;
			
			//整数の場合，長い線
			if(i==0 || i==j-1)
			{
				this.sLine.graphics.moveTo(animeBalloon.marginLR+rX, animeBalloon.scH/2-animeBalloon.marginTB*2);
				this.sLine.graphics.lineTo(animeBalloon.marginLR+rX, animeBalloon.scH/2+animeBalloon.marginTB*2);
			}
			//少数の場合，短い線
			else
			{
				this.sLine.graphics.moveTo(animeBalloon.marginLR+rX, animeBalloon.scH/2-animeBalloon.marginTB);
				this.sLine.graphics.lineTo(animeBalloon.marginLR+rX, animeBalloon.scH/2+animeBalloon.marginTB);
			}
		}
		
		animeBalloon.ss.update();
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderLine:" + e.toString());
	}
};


AnimeBalloon.prototype.changeSliderControl = function()
{
	try
	{
		//バルーンでのアニメーション制御では使用しない（スライダーでは矢印で移動）
		return;
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderControl:" + e.toString());
	}
};


AnimeBalloon.prototype.changeSliderPoint = function()
{
	try
	{
		animeBalloon.sPoint.y =animeBalloon.scH/2;
		
		var leng = this.scW - this.marginLR * 2;
			
		animeBalloon.sPoint.x = animeBalloon.marginLR+ leng * this.prev/this.max;
		
		animeBalloon.ss.update();
	}
	catch(e)
	{
		alert("AnimeBalloon changeSliderPoint:" + e.toString());
	}
};

AnimeBalloon.prototype.openAnimeBalloon = function(id)
{
	try
	{
		if(this.targetID != id)
		{
			this.targetID = id;
			
			var eX = $("#"+id).position().left;
			var pX = $("#"+id).parent().position().left;
			
			var eW = $("#"+id).outerWidth();
			
			$("#animeBalloon").css("margin-left", "28px");
			
			$("#animeTriangle").css("margin-left", eX+pX+eW/2+7-28);
			
			document.getElementById("animeBalloon").style.display = "inline-block";
			
		}
		else
		{
			animeBalloon.closeAnimeBalloon();
		}
	}
	catch(e)
	{
		alert("openAnimeBalloon:" + e.toString());
	}
}

AnimeBalloon.prototype.closeAnimeBalloon = function()
{
	try
	{
		this.targetID = "";
			
		document.getElementById("animeBalloon").style.display = "none";
	}
	catch(e)
	{
		alert("closeAnimeBalloon:" + e.toString());
	}
}

function playAnimationHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			document.getElementById("playBtn").src = "./img/stopIcon.png";

			startAnimation();
		}
		else
		{
			clearTimeout(animeTimer);
			document.getElementById("playBtn").src = "./img/playIcon.png";
		}

		animeFlag = !animeFlag;
	}
	catch(e)
	{
		alert("AnimeBalloon playAnimationHandler:" + e.toString());
	}
}


function startAnimation()
{
	try
	{
		//　1/5秒ごとに表示変更
		var sec = 500 / animeBalloon.speedArray[animeBalloon.speedIndex];
		
		//順行で最小の状態の場合
		if(animeBalloon.loopMode == 2 && animeBalloon.step.indexOf(animeBalloon.prev) == 1)
		{
			animeBalloon.returnFlag = true;
		}
		else
		{
			animeBalloon.returnFlag = false;
		}
		
		animeTimer = setTimeout(stopAnimation, sec);
	}
	catch(e)
	{
		alert("startAnimation:" + e.toString());
	}
}

function stopAnimation()
{
	try
	{
		clearTimeout(animeTimer);
		
		//スライド全体でのデフォルト(1x)でのミリ秒数
		var d = 10000;
		var s = 500 / animeBalloon.speedArray[animeBalloon.speedIndex];
		
		
		var pIndex = animeBalloon.step.indexOf(animeBalloon.prev);
		
		if(animeBalloon.returnFlag)
		{
			animeBalloon.prev = animeBalloon.step[animeBalloon.step.length-1];
			pIndex = animeBalloon.step.length-1;
			
			animeBalloon.returnFlag = false;
		}
		else if(animeBalloon.loopFlag && pIndex < animeBalloon.step.length-1)
		{
			animeBalloon.prev = animeBalloon.step[pIndex+1];
		}
		else if(!animeBalloon.loopFlag && pIndex > 1)
		{
			animeBalloon.prev = animeBalloon.step[pIndex-1];
		}
		
		//繰り返し
		if(animeBalloon.loopMode == 0)
		{
			//増加→減少
			if(animeBalloon.loopFlag == true && pIndex+1 >= animeBalloon.step.length-1)
			{
				animeBalloon.loopFlag = false;
			}
			//減少→増加
			else if(animeBalloon.loopFlag == false && pIndex-1 == 1)
			{
				animeBalloon.loopFlag = true;
			}
			
			startAnimation();
		}
		//
		else if(animeBalloon.loopMode == 1)
		{
			//最大に戻る
			if(animeBalloon.loopFlag == false && pIndex == 1)
			{
				animeBalloon.prev = animeBalloon.step[animeBalloon.step.length-1];
				animeBalloon.loopFlag = false;
			}
			
			startAnimation();
		}
		//一順のみ
		else
		{
			//続きを実行
			if(pIndex > 2)
			{
				startAnimation();
			}
			//アニメーション終了
			else
			{
				document.getElementById("playBtn").src = "./img/playIcon.png";
				animeFlag = false;
			}
		}
		
		animeBalloon.changeSliderPoint();
		
		animeBalloon.changeFnc();
		
		animeBalloon.ss.update();
	}
	catch(e)
	{
		alert("AnimeBalloon stopAnimation:" + e.toString());
	}
}

function changeLoopHandler(e)
{
	try
	{
		switch(animeBalloon.loopMode)
		{
			case 0:
				animeBalloon.loopMode = 1;
				animeBalloon.loopFlag = false;
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				$("#loopBtn").css("transform", "scale(-1, 1)");
				break;

			case 1:
				animeBalloon.loopMode = 2;
				document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;

			case 2:
				animeBalloon.loopMode = 0;
				animeBalloon.loopFlag = false;
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				$("#loopBtn").css("transform", "scale(1, 1)");
				break;
		}
	}
	catch(e)
	{
		alert("AnimeBalloon changeLoopHandler:" + e.toString());
	}
}

function changeSpeedHandler(e)
{
	try
	{
		if(animeBalloon.speedIndex+1 < animeBalloon.speedArray.length)
		{
			animeBalloon.speedIndex+=1;
		}
		else
		{
			animeBalloon.speedIndex = 0;
		}
		
		document.getElementById("speedConfig").src = "./img/s"+animeBalloon.speedArray[animeBalloon.speedIndex]+".png";
	}
	catch(e)
	{
		alert("changeSpeedHandler:" + e.toString());
	}
}

function captureDataHandler(e)
{
	try
	{
		animeBalloon.captureFnc();
	}
	catch(e)
	{
		alert(e.toString());
	}
}

function removeCaptureHandler(e)
{
	try
	{
		animeBalloon.removeFnc();
	}
	catch(e)
	{
		alert(e.toString());
	}
}


