// JavaScript Document

//	===========================================
//	  No 028 ： a_2_P103_001.js
//	  p.103　応用例題8　領域における最大・最小
//	===========================================

//	+------+
//	| 変数 |
//	+------+

// キャンバス、ステージ
var cc;
var cs;

// キャンバスの幅、高さ
var bW;
var bH;
var cW;
var cH;
var adjW;			// 調整値
var adjH;			// 調整値

// 中心位置
var centerX;
var centerY;

// Ｘ軸、Ｙ軸
var axisX;
var axisY;

// Ｘ軸、Ｙ軸、原点テキスト
var tx;
var ty;
var t0;

// 軸線
var base;

// 方眼
var grid;

// 刻み幅
var stepSize;

// １目盛りのピクセル数
var span;

// １周期のピクセル
var baseCycle;

// グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

// 軌跡を制御する場合
var recCont;
var recData;

// アニメーション制御用スライダー
var slider;
var animeFlag;

// ドラッグ関連
var prevX;
var prevY;
var dFlag;

// 既定値関連
var defMin;
var defMax;
var defNum;

// 図形用
var shp;						// 線、破線、円など
var SHAPE_LINE_1	=	0;		// 線１
var SHAPE_LINE_2	=	1;		// 線２
var SHAPE_LINE_3	=	2;		// 領域１
var SHAPE_LINE_4	=	3;		// 領域２
var SHAPE_LINE_5	=	4;		// 領域３
var SHAPE_LINE_6	=	5;		// 領域４
var SHAPE_LINE_K	=	6;		// 線Ｋ
var SHAPE_DOT_1		=	7;		// 点
var SHAPE_DOT_2		=	8;		// 点
var SHAPE_DOT_3		=	9;		// 点
var SHAPE_MAX		=	10;		// 図形の数
var nameTbl = [ "line1", "line2", "line3", "line4", "line5", "line6", "lineK", "dot1", "dot2", "dot3" ];

// キャンバスに表示するテキスト
var txt;
var TEXT_K			=	0;		// Ｋ
var TEXT_A			=	1;		// 交点１
var TEXT_B			=	2;		// 交点２
var TEXT_C			=	3;		// 交点３
var TEXT_X			=	4;		// 座標値
var TEXT_Y			=	5;		// 座標値
var TEXT_MAX		=	6;		// テキストの数

var frm0;			// 式表示用
var frm1;			// 式表示用


// 値保存用
var f1a;						// 式の係数
var f1b;						// 式の係数
var f1c;						// 式の係数
var f2a;						// 式の係数
var f2b;						// 式の係数
var f2c;						// 式の係数
var f3a;						// 式の係数
var f3b;						// 式の係数
var f3c;						// 式の係数
var f4a;						// 式の係数
var f4b;						// 式の係数
var f4c;						// 式の係数
var cka;						// 式の係数
var ckb;						// 式の係数
var ckc;						// 式の係数
var t1x;						// テキスト表示位置Ｘ
var t1y;						// テキスト表示位置Ｙ
var k1;							// 直線１の傾き
var k2;							// 直線２の傾き
var fillType;					// 塗りつぶしタイプ
var btnType;					// チェックボタンの押下パターン

var crsPnt;
var pointA;
var pointB;
var pointC;
var pointD;
var optName;
var kNum;

var pattern;
var a1, b1, c1, a1, b1, c1;
var x1, x2, x3, x4, x5, x6;
var y1, y2, y3, y4, y5, y6;
var minXm, maxX, minY, maxY;



//	+----------------+
//	| ロード時の処理 |
//	+----------------+
function loadContentHandler()
{
	try
	{
		// ----------
		// 初期値設定
		// ----------
		
		// １周期のピクセル
		baseCycle = 300;
		
		// 軸の1目盛当たりのピクセル数
		span = 30;
		
		// 刻み幅
		stepSize = 1;
		
		// キャンバス位置調整
		adjW = 30;
		adjH = 30;
		
		// キャンバスサイズ設定
		bW = pageWidth-52;
		bH = pageHeight;
		cW = bW * 3;
		cH = bH * 3;
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphCanvas").style.left = (-bW + adjW) + "px";
		document.getElementById("graphCanvas").style.top = (-bH + adjH) + "px";
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		document.getElementById("graphCanvas").style.position = "absolute";
		
		// 中心位置
		centerX = cW/2;
		centerY = cH/2;
		
		// 値の上限、下限、既定値
		defMin = -2;
		defMax = 7;
		defNum = 0;
		
		// ドラッグ関連
		dFlag = true;
		animeFlag = false;
		
		// 状態の記録エリア
		recData = [];
		
		f1a = 3;
		f1b = 1;
		f1c = -9;
		
		f2a = 1;
		f2b = 2;
		f2c = -8;
		
		f3a = 1;
		f3b = 0;
		f3c = 0;
		
		f4a = 0;
		f4b = 1;
		f4c = 0;
		
		fKa = 0;
		fKb = 1;
		fKc = 0;
		
		t1x = 0;
		t1y = 0;
		
		crsPnt = [];
		pointA = [ { x:0, y:0 } ];
		pointB = [ { x:0, y:0 } ];
		pointC = [ { x:0, y:0 } ];
		pointD = [ { x:0, y:0 } ];
		optName = "";
		kNum = defNum;
		
		// ------------
		// 画面関連設定
		// ------------
		
		// アニメーションスライダを吹き出しで使用する場合
		slider = new AnimeBalloon( defMin, defMax, defNum, 250, 40, false, stepSize, changeAnimeGraph, captureData, resetCapture );
		
		// ステージの作成
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		// 背景の作成
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		cs.addChild(bg);
		
		// 方眼の作成
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		// 軸と矢印の作成
		base = new createjs.Shape();
		cs.addChild(base);
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		
		// Ｘ軸、Ｙ軸、原点のテキスト作成
		tx = new createjs.Text("x", "italic 20px Times New Roman", "#000000");
		cs.addChild(tx);
		ty = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
		cs.addChild(ty);
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		cs.addChild(t0);
		
		// 状態記録のコンテナ作成
		recCont = new createjs.Container();
		cs.addChild(recCont);
		
		// キャンパスに表示する図形
		shp = [];
		for ( var i=0; i<SHAPE_MAX; i++ )	{
			shp[i] = new createjs.Shape();
			shp[i].name = nameTbl[i];
			cs.addChild(shp[i]);
		}
		
		// キャンバスに表示するテキスト
		txt = [];
		for ( var i=0; i<TEXT_MAX; i++ )	{
			if ( i < 3 )	{	txt[i] = new createjs.Text("", "18px Times New Roman", "#000000");	}
			else			{	txt[i] = new createjs.Text("", "18px Times New Roman", "#000000");			}
			txt[i].textAlign = "left";
			cs.addChild(txt[i]);
		}
		
		// 式表示用
		frm0 = new createjs.Container();
		frm0.name = "frm0";
		cs.addChild(frm0);
		frm1 = new createjs.Container();
		frm1.name = "frm1";
		cs.addChild(frm1);
		
		$(".lineText").focus(function(){$(this).blur();});
		
		$(".configText").css("display", "inline-block");
		$(".configText").css("width", "40px");
		
		// 入力欄の設定
		document.getElementById("kNum").style.textAlign = "center";
		document.getElementById("kNum").style.width = "60px";
		document.getElementById("kNum").style.display = "inline-block";
		
		// 設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		setGraphConfig();
		
		// チェックボックス
		document.getElementById("check0").checked = false;
		document.getElementById("check1").checked = false;
		document.getElementById("check2").checked = false;
		document.getElementById("check3").checked = false;
		document.getElementById("check4").checked = false;
		
		//-------------
		// リスナー定義
		//-------------
		// リセット
		document.getElementById('resetBtn').addEventListener('click', resetHandler);
		// 刻み幅
		document.getElementById("stepText").addEventListener("click", openMenuBalloonHandler);
		// チェックボックス
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		document.getElementById("check4").addEventListener("change", changeCheckHandler);
		// 線のドラッグ
		shp[SHAPE_LINE_K].addEventListener("mousedown", lineDragStart);
		// ドットのドラッグ
//		shp[SHAPE_DOT_A].addEventListener("mousedown", dotDragStart);
		// キャンバスのドラッグ
		cs.addEventListener("mousedown", canvasDragStart);
		// オプションボタン（数式の設定画面）
		document.getElementById('optionBtn0').addEventListener('click', openOptionHandler);
		document.getElementById('optionBtn1').addEventListener('click', openOptionHandler);
		document.getElementById('optionClose0').addEventListener('click', closeOptionHandler);
		// 数式の設定
		document.getElementById("upBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_2").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_2").addEventListener("click", changeFormulaHandler);
		// 値の設定
		document.getElementById("upBtn0").addEventListener("click", changeDataHandler);
		document.getElementById("downBtn0").addEventListener("click", changeDataHandler);
		
		//-------------
		// 画面初期表示
		//-------------
		
		// 使用しないバルーン・非表示
		document.getElementById("selectBalloon_menu").style.display = "none";			// 刻み幅
		document.getElementById("selectBalloon_config").style.display = "none";			// 設定画面
		//document.getElementById("animeBalloon").style.display = "none";				// アニメ
		
		// スライダー設定
		document.getElementById("loopBtn").src = "./img/loopIcon.png";
		document.getElementById('speedConfig').src = "./img/s1.png";
		slider.min = defMin;
		slider.max = defMax;
		slider.prev = defNum;
		slider.loopFlag = true;
		slider.loopMode = 0;
		slider.speedIndex = 2;
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
		
		// 刻み幅
		document.getElementById("stepText").innerHTML = stepSize;
		
		// 軸表示
		drawBaseLine();
		changeAxisPositionHandler();
		
		// 計算処理
		calcData();
		
		// 式の表示
		drawFormula();
		
		// 図形の表示
		drawShape();
		
		// テキストの表示
		drawText();
		
		// オプションメニュー画面
		setModal('optionBlock');
		setModal('spanChange');
		setMenuMode(0, 320);
		$("#controlBlock").css("overflow-x", "hidden");		// 横スクロールバーは非表示
		
		// ステージ更新
		slider.ss.update();
		cs.update();
		
		// バージョンチェック
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

//	+------------------------------------+
//	| 以下は必要なので削除してはいけない |
//	+------------------------------------+

//	+--------------------------+
//	| アニメ制御画面のオープン |
//	+--------------------------+
function setAnimeBalloonPosition()
{
	slider.openAnimeBalloon("kNum");
	document.getElementById("animeTriangle").style = "position:relative;left:116px";
}

//	+----------------+
//	| アニメーション |
//	+----------------+
function changeAnimeGraph()
{
	kNum = slider.prev;
	document.getElementById("kNum").innerHTML = Math.round( kNum * 100 ) / 100;
	calcData();
	drawFormula();
	drawShape();
	drawText();
	slider.ss.update();
	cs.update();
}

//	+--------------+
//	|  |
//	+--------------+
function changeFormulaPositionHandler(num)
{
	return;
}
//	+--------------+
//	|  キャプチャ  |
//	+--------------+
function captureData()
{
	try
	{
		if ( document.getElementById("check4").checked )
		{
			createcaptureData();
			cs.update();
		}
	}
	catch(e)
	{
		alert("captureData:" + e.toString());
	}
}

//	+------------------+
//	|  キャプチャ記録  |
//	+------------------+
function createcaptureData(n)
{
	try
	{
		var s = new createjs.Shape();
		s.name = "s" + recData.length;
		cs.addChild(s);
		
		s.x = cW/2;
		s.y = cH/2;
		s.alpha = 0.25;
		
		drawLine_1( s, 1, 1, -slider.prev, "blue", s.alpha );
		cs.update();
		
		recCont.addChild(s);
		recData.push(n);
	}
	catch(e)
	{
		alert("createcaptureData:" + e.toString());
	}
		
}

//	+------------------+
//	|  キャプチャ消去  |
//	+------------------+
function resetCapture()
{
	try
	{
		var leng = recData.length;
		//オブジェクトを削除
		recCont.removeAllChildren();
		//データの削除
		recData = [];
		cs.update();
	}
	catch(e)
	{
		alert("resetCapture:" + e.toString());
	}
}
//	+----------------------------------------+
//	| ここまでは必要なので削除してはいけない |
//	+----------------------------------------+

//	+--------------------+
//	| ベースラインの描画 |
//	+--------------------+
function drawBaseLine()
{
	try
	{
		// 軸と矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		// Ｘ軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		// Ｙ軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		// Ｘ軸の矢印
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		// Ｙ軸の矢印
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		// Ｘ軸、Ｙ軸の位置
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		axisX.x = numX + bW;
		axisX.y = centerY;
		axisY.x = centerX;
		axisY.y = numY;
		// Ｘ軸、Ｙ軸、原点のテキスト
		tx.x = numX + bW -tx.getBounds().width-5;
		tx.y = cH/2+5;
		ty.x = cW/2+10;
		ty.y = numY + 2;
		t0.x = cW/2+5;
		t0.y = cH/2+5;
	}
	catch(e)
	{
		alert("drawBase:"+e.toString());
	}
}

//	+----------+
//	| 軸の表示 |
//	+----------+
function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}

//	+----------+
//	| 計算処理 |
//	+----------+
function calcData()
{
	try
	{
		crsPnt = cpt( f1a, f1b, f1c, f2a, f2b, f2c );
		pointA.y = f3c;
		pointA.x = Math.round( getX( f2a, f2b, f2c, pointA.y ) * 100 ) / 100;
		pointB.x = crsPnt[0].x;
		pointB.y = crsPnt[0].y;
		pointC.x = f4c;
		pointC.y = Math.round( getY( f1a, f1b, f1c, pointC.x ) * 100 ) / 100;
		pointD.x = f3c;
		pointD.y = f4c;
	}
	catch(e)
	{
		alert("calcData:" + e.toString());
	}
}

//	+------------+
//	| 図形の表示 |
//	+------------+
function drawShape()
{
	try
	{
	
		for ( var i=0; i<SHAPE_MAX; i++ )		{	shp[i].graphics.clear();	}
		
		drawLine_1( shp[SHAPE_LINE_1], f1a, f1b, f1c, "black", 1 );
		drawLine_1( shp[SHAPE_LINE_2], f2a, f2b, f2c, "black", 1 );
		if ( document.getElementById("check4").checked )
		{
			drawLine_1( shp[SHAPE_LINE_K], 1, 1, -slider.prev, "blue", 1 );
		}
		
		drawDot( shp[SHAPE_DOT_1], pointA.x, pointA.y, "black", 0.5 ); 
		drawDot( shp[SHAPE_DOT_2], pointB.x, pointB.y, "black", 0.5 ); 
		drawDot( shp[SHAPE_DOT_3], pointC.x, pointC.y, "black", 0.5 ); 
		
		var pos = getFillPosition();
		switch( pos.num )
		{
			case 3:
				drawTriangle( shp[SHAPE_LINE_3], pos.x1, pos.y1, pos.x2, pos.y2, pos.x3, pos.y3, "blue", 0.25, true );
				break;
			case 4:
				drawBox( shp[SHAPE_LINE_3], pos.x1, pos.y1, pos.x2, pos.y2, pos.x3, pos.y3, pos.x4, pos.y4, "blue", 0.25, true );
				break;
			case 5:
				drawPentagon( shp[SHAPE_LINE_3], pos.x1, pos.y1, pos.x2, pos.y2, pos.x3, pos.y3, pos.x4, pos.y4, pos.x5, pos.y5, "blue", 0.25, true );
				break;
			case 6:
				drawHexagon( shp[SHAPE_LINE_3], pos.x1, pos.y1, pos.x2, pos.y2, pos.x3, pos.y3, pos.x4, pos.y4, pos.x5, pos.y5, pos.x6, pos.y6, "blue", 0.25, true );
				break;
		}
		
	}
	catch(e)
	{
		alert("drawShape:" + e.toString());
	}
}

//	+--------------------+
//	| 図形の表示情報設定 |
//	+--------------------+
function getFillPosition()
{
	var type1 = 0;
	var type2 = 0;
	if ( document.getElementById("check0").checked  )	{	type1 += 1;	}
	if ( document.getElementById("check1").checked  )	{	type1 += 2;	}
	if ( document.getElementById("check2").checked  )	{	type2 += 1;	}
	if ( document.getElementById("check3").checked  )	{	type2 += 2;	}
	
	x1   =  0;
	x2   =  0;
	x3   =  0;
	x4   =  0;
	x5   =  0;
	x6   =  0;
	y1   =  0;
	y2   =  0;
	y3   =  0;
	y4   =  0;
	y5   =  0;
	y6   =  0;
	minX = -100;
	maxX =  100;
	minY = -100;
	maxY =  100;
	
	pattern = getPattern(type1);
	
	switch( type1 )
	{
		case 1:
			a1 = f1a;
			b1 = f1b;
			c1 = f1c;
			break;
		case 2:
			a1 = f2a;
			b1 = f2b;
			c1 = f2c;
			break;
		case 3:
			switch ( pattern )
			{
				// 以下は式１と式２の逆転パターン
				case 31:
				case 32:
				case 41:
				case 42:
				case 43:
				case 51:
				case 52:
				case 53:
				case 54:
				case 61:
				case 62:
				case 63:
				case 64:
				case 65:
				case 71:
				case 72:
				case 73:
				case 74:
				case 75:
				case 76:
				case 81:
				case 82:
				case 83:
				case 84:
				case 85:
				case 86:
				case 87:
					// 式を入れ替える
					a1 = f1a;
					b1 = f1b;
					c1 = f1c;
					a2 = f2a;
					b2 = f2b;
					c2 = f2c;
					break;
				
				// 以外は通常パターン
				default:
					a1 = f2a;
					b1 = f2b;
					c1 = f2c;
					a2 = f1a;
					b2 = f1b;
					c2 = f1c;
					break;
			}
			break;
	}
	
	// 条件のチェックボックスが押されたら下限を０に設定
	switch( type2 )
	{
		case 1:
			minX = 0;
			break;
		case 2:
			minY = 0;
			break;
		case 3:
			minX = 0;
			minY = 0;
			break;
	}
	
	// パターン別に図形表示する
	switch( pattern )
	{
		//------------------------------//
		// 直線１または直線２を表示する //
		//------------------------------//
		case 0:
			// 表示物なし。条件がある場合だけ表示する
			if ( type2 > 0 )
			{
				x1 = minX;
				y1 = minY;
				x2 = maxX;
				y2 = minY;
				x3 = maxX;
				y3 = maxY;
				x4 = minX;
				y4 = maxY;
				return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			}
			break;
			
		case 1:		// ======== 水平線・上方向が範囲 ======== //
			return getDrawArea(1);
			break;
			
		case 2:		// ======== 水平線・下方向が範囲 ======== //
			return getDrawArea(2);
			break;
			
		case 3:		// ======== 垂直線・右方向が範囲 ======== //
			return getDrawArea(3);
			break;
		
		case 4:		// ======== 垂直線・左方向が範囲 ======== //
			return getDrawArea(4);
			break;
		
		case 5:		// ======== 左上がりの斜線・右上方向が範囲 ======== //
			return getDrawArea(5);
			break;
		
		case 6:		// ======== 右上がりの斜線・右下方向が範囲 ======== //
			return getDrawArea(6);
			break;
			
		case 7:		// ======== 右上がりの斜線・左上方向が範囲 ======== //
			return getDrawArea(7);
			break;
		
		case 8:		// ======== 左上がりの斜線・左下方向が範囲 ======== //
			return getDrawArea(8);
			break;
		
		//------------------------------//
		// 直線１と直線２を複合表示する //
		//------------------------------//
		case 11:
		case 12:
		case 21:
		case 22:
		case 33:
		case 34:
		case 43:
		case 44:
			return { num:0 };		// 入力禁止のパターン
			
		case 13:
		case 31:
			var y = getY( a2, b2, c2, maxX );
			if ( y >= minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(3);
			break;
		
		case 14:
		case 41:
			var y = getY( a2, b2, c2, maxX );
			if ( y >= minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(4);
			break;
			
		
		case 15:
		case 51:
			var y = getY( a2, b2, c2, maxX );
			if ( y >= minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(5);
			break;
		
		case 16:
		case 61:
			var y = getY( a2, b2, c2, minX );
			if ( y > minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(6);
			break;
			
		case 17:
		case 71:
			var y = getY( a2, b2, c2, maxX );
			if ( y >= minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(7);
			break;
		
		case 18:
		case 81:
			var y = getY( a2, b2, c2, maxX );
			if ( y >= minY )	{	minY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(8);
			break;
		
		case 23:
		case 32:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(3);
			break;
		
		case 24:
		case 42:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(4);
			break;
		
		case 25:
		case 52:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(5);
			break;
		
		case 26:
		case 62:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(6);
			break;
		
		case 27:
		case 72:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(7);
			break;
		
		case 28:
		case 82:
			var y = getY( a2, b2, c2, maxX );
			if ( y <= maxY )	{	maxY = y;	}
			if ( minY >= maxY )		return { num:0 };
			return getDrawArea(8);
			break;
		
		case 36:
		case 63:
			var x = getY( a2, b2, c2, minY );
			if ( x > minX )	{	minX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(6);
			break;
		
		case 35:
		case 53:
			var x = getY( a2, b2, c2, minY );
			if ( x > minX )	{	minX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(5);
			break;
		
		case 37:
		case 73:
			var x = getY( a2, b2, c2, minY );
			if ( x > minX )	{	minX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(7);
			break;
		
		case 38:
		case 83:
			var x = getY( a2, b2, c2, minY );
			if ( x > minX )	{	minX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(8);
			break;
		
		case 45:
		case 54:
			var x = getY( a2, b2, c2, maxY );
			if ( x < maxX )	{	maxX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(5);
			break;
		
		case 46:
		case 64:
			var x = getY( a2, b2, c2, maxY );
			if ( x < maxX )	{	maxX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(6);
			break;
		
		case 47:
		case 74:
			var x = getY( a2, b2, c2, maxY );
			if ( x < maxX )	{	maxX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(7);
			break;
		
		case 48:
		case 84:
			var x = getY( a2, b2, c2, maxY );
			if ( x < maxX )	{	maxX = x;	}
			if ( minX >= maxX )		return { num:0 };
			return getDrawArea(8);
			break;
		
		case 55:
			if ( crsPnt[0].y >= minY && crsPnt[0].x >= minX )
			{
				x1 = crsPnt[0].x;
				y1 = crsPnt[0].y;
				x2 = minX;
				y2 = getEvaluateFormula( minX, "Y", "H" );
				if ( y2 > maxY )
				{
					x2 = getEvaluateFormula( maxY, "X", "H" );
					y2 = maxY;
					x3 = maxX;
					y3 = maxY;
					x4 = maxX;
					y4 = getEvaluateFormula( maxX, "Y", "H" );
					if ( y4 > minY )
					{	return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };	}
					y4 = minY;
					x5 = getEvaluateFormula( minY, "X", "H" );
					y5 = minY;
					return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
				}
				x3 = minX;
				y3 = maxY;
				x4 = maxX;
				y4 = maxY;
				x5 = maxX;
				y5 = getEvaluateFormula( maxX, "Y", "H" );
				if ( y5 > minY )
				{	return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };	}
				y5 = minY;
				x6 = getEvaluateFormula( minY, "X", "H" );
				y6 = minY;
				return { num:6, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5, x6:x6, y6:y6 };
			}
			x1 = minX;
			y1 = getEvaluateFormula( minX, "Y", "H" );
			if ( y1 < minY )	{	y1 = minY;	}
			x2 = minX;
			y2 = maxY;
			x3 = maxX;
			y3 = maxY;
			x4 = maxX;
			y4 = getEvaluateFormula( maxX, "Y", "H" );
			if ( y4 > minY )
			{	return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };	}
			y4 = minY;
			x5 = getEvaluateFormula( minY, "X", "H" );
			y5 = minY;
			return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
			break;
		
		case 56:
		case 65:
			var hy = getEvaluateFormula( maxX, "Y", "H" );
			var ly = getEvaluateFormula( maxX, "Y", "L" );
			switch( type2 )
			{
				case 0:
					x1 = maxX;
					y1 = ly;
					x2 = maxX;
					y2 = hy;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
				
				case 1:
					if ( crsPnt[0].x < minX )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "H" );
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = maxX;
						y3 = ly;
						x4 = maxX;
						y4 = hy;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					
					x1 = maxX;
					y1 = ly;
					x2 = maxX;
					y2 = hy;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					if ( ly < minY )
					{
						x1 = maxX;
						y1 = minY;
						x2 = maxY;
						y2 = hy;
						if ( crsPnt[0].y >= minY )
						{
							x3 = crsPnt[0].x;
							y3 = crsPnt[0].y;
							x4 = getEvaluateFormula( minY, "X", "H" );
							y4 = minY;
							return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
						}
						x3 = getEvaluateFormula( minY, "X", "H" );
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					break;
					
				case 3:
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY )
					{
						x1 = crsPnt[0].x;
						y1 = crsPnt[0].y;
						x2 = maxX;
						y2 = hy;
						if ( ly >= minY )
						{
							x3 = maxX;
							y3 = ly;
							return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
						}
						x3 = maxX;
						y3 = minY;
						x4 = getEvaluateFormula( minY, "X", "H" );
						y4 = minY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					if ( crsPnt[0].x >= minX )
					{
						x1 = getEvaluateFormula( minY, "X", "H" );
						y1 = minY;
						x2 = maxX;
						y2 = hy;
						x3 = maxX;
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "H" );
					if ( y1 < minY )
					{
						y1 = minY;
						x1 = getEvaluateFormula( minY, "X", "H" );
						x2 = maxX;
						y2 = hy;
						x3 = maxX;
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					x2 = maxX;
					y2 = hy;
					if ( ly > minY )
					{
						x3 = maxX;
						y3 = ly;
						x4 = minX; 
						y4 = getEvaluateFormula( minX, "Y", "L" );
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					x3 = maxX;
					y3 = minY;
					x4 = getEvaluateFormula( minY, "X", "H" );
					if ( x4 < minX )
					{
						x4 = minX;
						y4 = minY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					y4 = minY;
					x5 = minX;
					y5 = getEvaluateFormula( minX, "Y", "L" );
					return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
			}
			break;
		
		case 57:
		case 75:
			var hx = getEvaluateFormula( maxY, "X", "H" );
			var lx = getEvaluateFormula( maxY, "X", "L" );
			switch( type2 )
			{
				case 0:
					x1 = lx;
					y1 = maxY;
					x2 = hx;
					y2 = maxY;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
				
				case 1:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "H" );
					x2 = minX;
					y2 = maxY;
					x3 = hx;
					y3 = maxY;
					if ( crsPnt[0].x >= minX )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					x1 = lx;
					y1 = maxY;
					x2 = hx;
					y2 = maxY;
					if ( crsPnt[0].y <= minY )
					{
						x3 = getEvaluateFormula( minY, "X", "H" );
						y3 = minY;
						x4 = getEvaluateFormula( minY, "X", "L" );
						y4 = minY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "H" );
					if ( y1 < minY )	y1 = minY;
					x2 = minX;
					y2 = maxY;
					x3 = hx;
					y3 = maxY;
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY  )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					x4 = getEvaluateFormula( minY, "X", "H" );
					y4 = minY;
					if ( y1 > minY )
					{
						x5 = getEvaluateFormula( minY, "X", "L" );
						y5 = minY;
						return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
					}
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			}
			break;
		
		case 58:
		case 85:
			var m = ( b1 / a1 ) - ( b2 / a2 );
			switch( type2 )
			{
				case 0:
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x2 = getEvaluateFormula( maxY, "X", "H" );
						y2 = maxY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
					}
					else
					{
						x2 = getEvaluateFormula( minY, "X", "H" );
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 1:
					if ( crsPnt[0].x < minX )
					{
						if ( m >= 0 )
						{
							x1 = minX;
							y1 = getEvaluateFormula( minX, "Y", "H" );
							x2 = minX;
							y2 = getEvaluateFormula( minX, "Y", "L" );
							x3 = getEvaluateFormula( minY, "X", "L" );
							y3 = minY;
							x4 = getEvaluateFormula( minY, "X", "H" );
							y4 = minY;
							return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
						}
						return { num:0 };
					}
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = minX;
						y3 = getEvaluateFormula( minX, "Y", "H" );
					}
					else
					{
						x2 = getEvaluateFormula( minY, "X", "H" );
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					if ( crsPnt[0].y >= minY )
					{
						if ( m < 0 )
						{
							x1 = crsPnt[0].x;
							y1 = crsPnt[0].y;
							x2 = getEvaluateFormula( maxY, "X", "H" );
							y2 = maxY;
							x3 = getEvaluateFormula( maxY, "X", "L" );
							y3 = maxY;
						}
						else
						{
							x1 = getEvaluateFormula( minY, "X", "H" );
							y1 = minY;
							x2 = getEvaluateFormula( minY, "X", "L" );
							y2 = minY;
							x3 = crsPnt[0].x;
							y3 = crsPnt[0].y;
						}
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x1 = getEvaluateFormula( minY, "X", "H" );
						y1 = minY;
						x2 = getEvaluateFormula( minY, "X", "L" );
						y2 = minY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
						x4 = getEvaluateFormula( maxY, "X", "H" );
						y4 = maxY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					if ( crsPnt[0].y < minY )	return { num:0 };
					x2 = getEvaluateFormula( minY, "X", "L" );
					y2 = minY;
					x3 = getEvaluateFormula( minY, "X", "H" );
					y3 = minY;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY )
					{
						x1 = crsPnt[0].x;
						y1 = crsPnt[0].y;
						if ( m < 0 )
						{
							x2 = minX;
							y2 = getEvaluateFormula( minX, "Y", "H" );
							x3 = minX;
							y3 = getEvaluateFormula( minX, "Y", "L" );
							return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
						}
						x2 = getEvaluateFormula( minY, "X", "L" );
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "H" );
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					
					if ( m >= 0 )
					{
						if ( crsPnt[0].y < minY )	return { num:0 };
					}
					
					x1 = getEvaluateFormula( minY, "X", "H" );
					if ( x1 < minX )		return { num:0 };
					y1 = minY;
					x2 = getEvaluateFormula( minY, "X", "L" );
					if ( x2 <= minX )
					{
						x2 = minX;
						y2 = minY;
						x3 = minX;
						y3 = getEvaluateFormula( minX, "Y", "H" );
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					y2 = minY;
					x3 = minX;
					y3 = getEvaluateFormula( minX, "Y", "L" );
					x4 = minX;
					y4 = getEvaluateFormula( minX, "Y", "H" );
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			}
			break;
		
		case 66:
			switch( type2 )
			{
				case 0:
					x1 = getEvaluateFormula( minY, "X", "H" );
					y1 = minY;
					x2 = maxX;
					y2 = minY;
					x3 = getEvaluateFormula( maxY, "X", "H" );
					y3 = maxY;
					x4 = crsPnt[0].x;
					y4 = crsPnt[0].y;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
				case 1:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					x2 = minX;
					y2 = minY;
					x3 = maxX;
					y3 = minY;
					x4 = getEvaluateFormula( maxY, "X", "H" );
					y4 = maxY;
					if ( crsPnt[0].x >= minX )
					{
						x5 = crsPnt[0].x;
						y5 = crsPnt[0].y;
						return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
					}
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
				case 2:
					x1 = getEvaluateFormula( minY, "X", "H" );
					y1 = minY;
					x2 = maxX;
					y2 = minY;
					x3 = maxX;
					y3 = getEvaluateFormula( maxX, "Y", "L" );
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					x1 = getEvaluateFormula( minY, "X", "H" );
					y1 = minY;
					if ( x1 < minX )	x1 = minX;
					x2 = maxX;
					y2 = minY;
					x3 = maxX;
					y3 = getEvaluateFormula( maxX, "Y", "L" );
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY  )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						if ( x1 == minX )
						{
							x5 = minX;
							y5 = getEvaluateFormula( minX, "Y", "L" );
							return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
						}
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					if ( x1 > minX )	return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					x4 = minX;
					y4 = getEvaluateFormula( minX, "Y", "L" );
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
			}
			break;
		
		case 67:
		case 76:
			var m = ( b1 / a1 ) - ( b2 / a2 );
			switch( type2 )
			{
				case 0:
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x2 = getEvaluateFormula( maxY, "X", "H" );
						y2 = maxY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
					}
					else
					{
						x2 = getEvaluateFormula( minY, "X", "H" );
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 1:
					if ( crsPnt[0].x < minX )
					{
						if ( m < 0 )
						{
							x1 = minX;
							y1 = getEvaluateFormula( minX, "Y", "L" );
							x2 = minX;
							y2 = getEvaluateFormula( minX, "Y", "H" );
							x3 = getEvaluateFormula( maxY, "X", "L" );
							y3 = maxY;
							x4 = getEvaluateFormula( maxY, "X", "H" );
							y4 = maxY;
							return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
						}
						return { num:0 };
					}
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x2 = getEvaluateFormula( maxY, "X", "H" );
						y2 = maxY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
					}
					else
					{
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = minX;
						y3 = getEvaluateFormula( minX, "Y", "H" );
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					if ( crsPnt[0].y < minY )
					{
						if ( m < 0 )
						{
							x1 = getEvaluateFormula( minY, "X", "H" );
							y1 = minY;
							x2 = getEvaluateFormula( minY, "X", "L" );
							y2 = minY;
							x3 = getEvaluateFormula( maxY, "X", "L" );
							y3 = maxY;
							x4 = getEvaluateFormula( maxY, "X", "H" );
							y4 = maxY;
							return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
						}
						return { num:0 };
					}
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					if ( m < 0 )
					{
						x2 = getEvaluateFormula( maxY, "X", "H" );
						y2 = maxY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
					}
					else
					{
						x2 = getEvaluateFormula( minY, "X", "L" );
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "H" );
						y3 = minY;
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY )
					{
						x1 = crsPnt[0].x;
						y1 = crsPnt[0].y;
						if ( m < 0 )
						{
							x2 = getEvaluateFormula( maxY, "X", "H" );
							y2 = maxY;
							x3 = getEvaluateFormula( maxY, "X", "L" );
							y3 = maxY;
							return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
						}
						else
						{
							var hx = getEvaluateFormula( minY, "X", "H" );
							var lx = getEvaluateFormula( minY, "X", "L" );
							if ( hx < minX )
							{
								x2 = minX;
								y2 = getEvaluateFormula( maxY, "X", "H" );
								x3 = minX;
								y3 = getEvaluateFormula( maxY, "X", "L" );
								return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
							}
							else
							{
								if ( lx >= minX )
								{
									x2 = lx;
									y2 = minY;
									x3 = hx;
									y3 = minY;
									return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
								}
								else
								{
									x2 = minX;
									y2 = getEvaluateFormula( minX, "Y", "H" );
									x3 = minX;
									y3 = minY;
									x4 = hx;
									y4 = minY;
									return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
								}
							}
							y2 = minY;
							x3 = getEvaluateFormula( minY, "X", "L" );
							y3 = minY;
							return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
						}
					}
					if ( m < 0 )
					{
						x1 = getEvaluateFormula( minY, "X", "L" );
						if ( x1 < minX )
						{
							x1 = minX;
							y1 = getEvaluateFormula( minX, "Y", "H" );
							x2 = getEvaluateFormula( minY, "X", "H" );
							if ( x2 < minX )
							{
								x2 = minX;
								y2 = getEvaluateFormula( minX, "Y", "L" );
								x3 = getEvaluateFormula( maxY, "X", "H" );
								y3 = maxY;
								x4 = getEvaluateFormula( maxY, "X", "L" );
								y4 = maxY;
								return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
							}
							x2 = minX;
							y2 = minY;
							x3 = getEvaluateFormula( minY, "X", "H" );
							y3 = minY;
							x4 = getEvaluateFormula( maxY, "X", "H" );
							y4 = maxY;
							x5 = getEvaluateFormula( maxY, "X", "L" );
							y5 = maxY;
							return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
						}
						y1 = minY;
						x2 = getEvaluateFormula( minY, "X", "H" );
						y2 = minY;
						x3 = getEvaluateFormula( maxY, "X", "H" );
						y3 = maxY;
						x4 = getEvaluateFormula( maxY, "X", "L" );
						y4 = maxY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:0 };
			}
			break;
		
		case 68:
		case 86:
			switch( type2 )
			{
				case 0:
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					x2 = getEvaluateFormula( minY, "X", "H" );
					y2 = minY;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
				
				case 1:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					x2 = minX;
					y2 = minY;
					x3 = getEvaluateFormula( minY, "X", "H" );
					y3 = minY;
					if ( crsPnt[0].x >= minX )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					if ( crsPnt[0].y <= minY )		return { num:0 };
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					x2 = getEvaluateFormula( minY, "X", "H" );
					y2 = minY;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					if ( y1 < minY )
					{
						x1 = getEvaluateFormula( minY, "X", "L" );
						y1 = minY;
					}
					x2 = minX;
					y2 = minY;
					x3 = getEvaluateFormula( minY, "X", "H" );
					y3 = minY;
					if ( crsPnt[0].x >= minX )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
			}
			break;
		
		case 77:
			switch( type2 )
			{
				case 0:
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					x2 = minX;
					y2 = maxY;
					x3 = getEvaluateFormula( maxY, "X", "L" );
					y3 = maxY;
					x4 = crsPnt[0].x;
					y4 = crsPnt[0].y;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
				case 1:
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "H" );
					x2 = minX;
					y2 = maxY;
					x3 = getEvaluateFormula( maxY, "X", "L" );
					y3 = maxY;
					if ( crsPnt[0].x >= minX )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					x2 = minX;
					y2 = minY;
					x3 = minX;
					y3 = maxY;
					x4 = getEvaluateFormula( maxY, "X", "L" );
					y4 = maxY;
					if ( crsPnt[0].y >= minY )
					{
						x5 = crsPnt[0].x;
						y5 = crsPnt[0].y;
						return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
					}
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
				case 3:
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					if ( x1 < minX )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "H" );
						x2 = minX;
						y2 = maxY;
						x3 = getEvaluateFormula( maxY, "X", "L" );
						y3 = maxY;
						if ( crsPnt[0].y >= minY )
						{
							x4 = crsPnt[0].x;
							y4 = crsPnt[0].y;
							return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
						}
					}
					x2 = minX;
					y2 = minY;
					x3 = minX;
					y3 = maxY;
					x4 = getEvaluateFormula( maxY, "X", "L" );
					y4 = maxY;
					if ( crsPnt[0].y >= minY )
					{
						x5 = crsPnt[0].x;
						y5 = crsPnt[0].y;
						return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
					}
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;

					
			}
			break;
			
		case 78:
		case 87:
			switch( type2 )
			{
				case 0:
					x1 = getEvaluateFormula( maxY, "X", "L" );
					y1 = maxY;
					x2 = getEvaluateFormula( minY, "X", "L" );
					y2 = minY;
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
				
				case 1:
					if ( crsPnt[0].x < minX )	return { num:0 };
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					x2 = minX;
					y2 = getEvaluateFormula( minX, "Y", "H" );
					x3 = crsPnt[0].x;
					y3 = crsPnt[0].y;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					x1 = getEvaluateFormula( minY, "X", "L" );
					y1 = minY;
					x2 = minX;
					y2 = minY;
					x3 = minX;
					y3 = getEvaluateFormula( minX, "Y", "H" );
					if ( crsPnt[0].y >= minY )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					if ( crsPnt[0].x < minX )		return { num:0 };
					if ( crsPnt[0].y < minY )
					{
						if ( getEvaluateFormula( minX, "Y", "H" ) < minY )		return { num:0 };
					}
					
					if ( crsPnt[0].y < minY )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "H" );
						x2 = minX;
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					
					x1 = getEvaluateFormula( minY, "X", "L" );
					if ( x1 < minX )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "H" );
						if ( y1 < minY )		return { num:0 }
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = crsPnt[0].x;
						y3 = crsPnt[0].y;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					
					y1 = minY;
					x2 = minX;
					y2 = minY;
					x3 = minX;
					y3 = getEvaluateFormula( minX, "Y", "H" );
					if ( crsPnt[0].x >= minX && crsPnt[0].y >= minY )
					{
						x4 = crsPnt[0].x;
						y4 = crsPnt[0].y;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					break;
			}
			break;
		
		case 88:
			switch( type2 )
			{
				case 0:
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					x2 = minX;
					y2 = getEvaluateFormula( minX, "Y", "L" );
					x3 = minX;
					y3 = minY;
					x4 = getEvaluateFormula( minY, "X", "L" );
					y4 = minY;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
					
				case 1:
					if ( crsPnt[0].x >= minX )
					{
						x1 = crsPnt[0].x;
						y1 = crsPnt[0].y;
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = minX;
						y3 = minY;
						x4 = getEvaluateFormula( minY, "X", "L" );
						y4 = minY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					x2 = minX;
					y2 = minY;
					x3 = getEvaluateFormula( minY, "X", "L" );
					y3 = minY;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 2:
					if ( crsPnt[0].y >= minY )
					{
						x1 = crsPnt[0].x;
						y1 = crsPnt[0].y;
						x2 = minX;
						y2 = getEvaluateFormula( minX, "Y", "L" );
						x3 = minX;
						y3 = minY;
						x4 = getEvaluateFormula( minY, "X", "L" );
						y4 = minY;
						return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					}
					x1 = minX;
					y1 = getEvaluateFormula( minX, "Y", "L" );
					x2 = minX;
					y2 = minY;
					x3 = getEvaluateFormula( minY, "X", "L" );
					y3 = minY;
					return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					break;
					
				case 3:
					if ( crsPnt[0].x < minX && crsPnt[0].y < minY )		return { num:0 };
					if ( crsPnt[0].y < minY )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "L" );
						if ( y1 < minY )		return { num:0 };
						x2 = minX;
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					if ( crsPnt[0].x < minX )
					{
						x1 = minX;
						y1 = getEvaluateFormula( minX, "Y", "L" );
						if ( y1 < minY )		return { num:0 };
						x2 = minX;
						y2 = minY;
						x3 = getEvaluateFormula( minY, "X", "L" );
						y3 = minY;
						return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
					}
					x1 = crsPnt[0].x;
					y1 = crsPnt[0].y;
					x2 = minX;
					y2 = getEvaluateFormula( minX, "Y", "L" );
					x3 = minX;
					y3 = minY;
					x4 = getEvaluateFormula( minY, "X", "L" );
					y4 = minY;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
					break;
			}
			break;
		
	}
	
	return { num:0 };
	
}

// パターン番号の取得
function getPattern(n)
{

	if ( n == 0 )	return 0;

	var pat1;
	var pat2;
	var pat;
	
	if ( f1a == 0 )
	{
		if ( f1b == 0 )		pat1 = 0;
		if ( f1b < 0 )		pat1 = 1;
		if ( f1b > 0 )		pat1 = 2;
	}
	else
	{
		if ( f1a < 0 )
		{
			if ( f1b == 0 )		pat1 = 3;
			if ( f1b < 0 )		pat1 = 5;
			if ( f1b > 0 )		pat1 = 6;
		}
		else
		{
			if ( f1b == 0 )		pat1 = 4;
			if ( f1b < 0 )		pat1 = 7;
			if ( f1b > 0 )		pat1 = 8;
		}
	}
	if ( n == 1 )	return pat1;
	
	if ( f2a == 0 )
	{
		if ( f2b == 0 )		pat2 = 0;
		if ( f2b < 0 )		pat2 = 1;
		if ( f2b > 0 )		pat2 = 2;
	}
	else
	{
		if ( f2a < 0 )
		{
			if ( f2b == 0 )		pat2 = 3;
			if ( f2b < 0 )		pat2 = 5;
			if ( f2b > 0 )		pat2 = 6;
		}
		else
		{
			if ( f2b == 0 )		pat2 = 4;
			if ( f2b < 0 )		pat2 = 7;
			if ( f2b > 0 )		pat2 = 8;
		}
	}
	if ( n == 2 )	return pat2;
	
	pat = pat1 * 10 + pat2;
	return pat;

}

// +----------------------+
// | 塗りつぶし領域の取得 |
// +----------------------+
function getDrawArea(p)
{
	switch( p )
	{
		case 1:		// ======== 水平線・上方向が範囲 ======== //
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			if ( y1 < minY )	{	y1 = minY;	}
			x2 = maxX;
			y2 = y1;
			x3 = maxX;
			y3 = maxY;
			x4 = minX;
			y4 = maxY;
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
		case 2:		// ======== 水平線・下方向が範囲 ======== //
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			if ( y1 < minY )	{	y1 = minY;	}
			x2 = maxX;
			y2 = y1;
			x3 = maxX;
			y3 = minY;
			x4 = minX;
			y4 = minY;
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
		case 3:		// ======== 垂直線・右方向が範囲 ======== //
			x1 = getX( a1, b1, c1, minY );
			if ( x1 < minX )	{	x1 = minX;	}
			y1 = minY;
			x2 = x1;
			y2 = maxY;
			x3 = maxX;
			y3 = maxY;
			x4 = maxX;
			y4 = minY;
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
		case 4:		// ======== 垂直線・左方向が範囲 ======== //
			x1 = getX( a1, b1, c1, 0 );
			if ( x1 < minX )	return	{ num:0 };
			y1 = minY;
			x2 = x1;
			y2 = maxY;
			x3 = minX;
			y3 = maxY;
			x4 = minX;
			y4 = minY;
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
		case 5:		// ======== 左上がりの斜線・右上方向が範囲 ======== //
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			if ( y1 > maxY )
			{
				x1 = getX( a1, b1, c1, maxY );
				y1 = maxY;
				x2 = maxX;
				y2 = maxY;
				x3 = maxX;
				y3 = getY( a1, b1, c1, maxX );
				if ( y3 <= minY )
				{
					y3 = minY;
					x4 = getX( a1, b1, c1, minY );
					y4 = minY;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
				}
				return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
			}
			x2 = minX;
			y2 = maxY;
			x3 = maxX;
			y3 = maxY;
			if ( y1 > minY )
			{
				x4 = maxX;
				y4 = getY( a1, b1, c1, maxX );
				if ( y4 < minY )
				{
					y4 = minY;
					x5 = getX( a1, b1, c1, minY );
					y5 = minY;
					return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
				}
				return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			}
			y1 = minY;
			x4 = maxX;
			y4 = getY( a1, b1, c1, maxX );
			if ( y4 < minY )	{	y4 = minY;	}
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
		
		case 6:		// ======== 右上がりの斜線・右下方向が範囲 ======== //
			x1 = getX( a1, b1, c1, minY );
			y1 = minY;
			if ( x1 >= minX )
			{
				x2 = maxX;
				y2 = minY;
				x3 = maxX;
				y3 = getY( a1, b1, c1, maxX );
				if ( y3 > maxY )
				{
					y3 = maxY;
					x4 = getX( a1, b1, c1, maxY );
					y4 = maxY;
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
				}
				return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
			}
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			x2 = minX;
			y2 = minY;
			x3 = maxX;
			y3 = minY;
			x4 = maxX;
			y4 = getY( a1, b1, c1, maxX );
			if ( y4 < minY )
			{
				y4 = minY;
				x5 = maxX;
				y5 = getY( a1, b1, c1, maxX );
				return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
			}
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
		case 7:		// ======== 右上がりの斜線・左上方向が範囲 ======== //
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			if ( y1 >= minY )
			{
				x2 = minX;
				y2 = maxY;
				x3 = maxX;
				y3 = getY( a1, b1, c1, maxX );
				if ( y3 > maxY )
				{
					y3 = maxY;
					x4 = maxX;
					y4 = getY( a1, b1, c1, maxX );
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
				}
				return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
			}
			x1 = getX( a1, b1, c1, minY );
			y1 = minY;
			x2 = minX;
			y2 = minY;
			x3 = minX;
			y3 = maxY;
			x4 = getX( a1, b1, c1, maxY );
			y4 = maxY;
			if ( y4 > maxX )
			{
				x4 = maxX;
				x5 = maxX;
				y5 = getY( a1, b1, c1, maxX );
				return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
			}
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
		
		case 8:		// ======== 左上がりの斜線・左下方向が範囲 ======== //
			x1 = minX;
			y1 = getY( a1, b1, c1, minX );
			if ( y1 < minY )	return { num:0 };
			if ( y1 < maxY )
			{
				x2 = minX;
				y2 = minY;
				x3 = getX( a1, b1, c1, minY );
				y3 = minY;
				if ( x3 > maxX )
				{
					y3 = maxX;
					x4 = maxX;
					y4 = getY( a1, b1, c1, maxX );
					return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
				}
				return { num:3, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3 };
			}
			x1 = getX( a1, b1, c1, maxY );
			y1 = maxY;
			x2 = minX;
			y2 = maxY;
			x3 = minX;
			y3 = minY;
			x4 = getX( a1, b1, c1, minY );
			y4 = minY;
			if ( x4 > maxX )
			{
				x4 = maxX;
				x5 = maxX;
				y5 = getY( a1, b1, c1, maxX );
				return { num:5, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4, x5:x5, y5:y5 };
			}
			return { num:4, x1:x1, y1:y1, x2:x2, y2:y2, x3:x3, y3:y3, x4:x4, y4:y4 };
			break;
			
	}
	return { num:0 };
}


// 座標の取得
function getEvaluateFormula(n,axis,level)
{
	if ( axis == "X" || axis == "x" )
	{
		var x1 = getX( f1a, f1b, f1c, n );
		var x2 = getX( f2a, f2b, f2c, n );
		if ( level == "H" || level == "H" )
		{
			if ( x1 > x2 )		return x1;
		}
		else
		{
			if ( x1 < x2 )		return x1;
			return x2;
		}
		return x2;
	}
	else
	{
		var y1 = getY( f1a, f1b, f1c, n );
		var y2 = getY( f2a, f2b, f2c, n );
		if ( level == "H" || level == "H" )
		{
			if ( y1 > y2 )		return y1;
		}
		else
		{
			if ( y1 < y2 )		return y1;
		}
		return y2;
	}
}

//	+----------------+
//	| テキストの表示 |
//	+----------------+
function drawText()
{
	try
	{
		for ( var i=0; i<TEXT_MAX; i++ )	{	txt[i].visible = false;	}
		
		var str;
		
		txt[TEXT_A].text = editCordinate(pointA.x,pointA.y);
		txt[TEXT_A].x = centerX + pointA.x * span + 4;
		txt[TEXT_A].y = centerY - pointA.y * span;
		txt[TEXT_A].visible = true;
		
		txt[TEXT_B].text = editCordinate(pointB.x,pointB.y);
		txt[TEXT_B].x = centerX + pointB.x * span + 4;
		txt[TEXT_B].y = centerY - pointB.y * span;
		txt[TEXT_B].visible = true;
		
		txt[TEXT_C].text = editCordinate(pointC.x,pointC.y);
		txt[TEXT_C].x = centerX + pointC.x * span + 4;
		txt[TEXT_C].y = centerY - pointC.y * span - 20;
		txt[TEXT_C].visible = true;
		
		if ( document.getElementById("check4").checked )
		{
			txt[TEXT_K].text = "k=" + slider.prev;
			txt[TEXT_K].x = centerX + slider.prev * span + 20;
			txt[TEXT_K].y = centerY + span;
			txt[TEXT_K].color = "#00A5C7";
			txt[TEXT_K].visible = true;
		}
		
		var y = Math.round( getY( f2a, f2b, f2c, 0 ) * 100 ) / 100;
		var x = Math.round( getX( f1a, f1b, f1c, 0 ) * 100 ) / 100;
		txt[TEXT_X].text = x;
		txt[TEXT_Y].text = y;
		drawPosText( txt[TEXT_X], txt[TEXT_Y] );
		
		if ( f2b == 0 )	{
			txt[TEXT_Y].x = centerX + y * span - 8;
			txt[TEXT_Y].y = centerY;
		}
		if ( f1a == 0 )	{
			txt[TEXT_X].x = centerX - 16;
			txt[TEXT_X].y = centerY - x * span;
		}
		
		txt[TEXT_X].visible = true;
		txt[TEXT_Y].visible = true;
		
		// 直線の式
		frm0.visible = false;
		var str = editForm2( f1a, f1b, f1c );
		var pos = getFormulaPosition( f1a, f1b, f1c, "R" );
		changeFormulaContainer( frm0, str, centerX + pos.x * span, centerY - pos.y * span - 20 );
		frm0.visible = true;
		
		frm1.visible = false;
		var str = editForm2( f2a, f2b, f2c );
		var pos = getFormulaPosition( f2a, f2b, f2c, "L" );
		changeFormulaContainer( frm1, str, centerX + pos.x * span, centerY - pos.y * span - 20 );
		frm1.visible = true;
		
	}
	catch(e)
	{
		alert("drawText:" + e.toString());
	}
}

function editCordinate(x, y)
{
	var strX;
	var strY;
	var str;
	
	if ( x == 0 )	{	strX = ""						}
	else			{	strX = Math.round(x*100)/100;	}
	if ( y == 0 )	{	strY = ""						}
	else			{	strY = Math.round(y*100)/100;	}
	if ( strX == "" )
	{
		if ( strY == "" )
		{
			str = "";
		}
		else
		{
			str = strY;
		}
	}
	else
	{
		if ( strY == "" )
		{
			str = strX;
		}
		else
		{
			str = "(" + strX + "," + strY + ")";
		}
	}
	return str;
}

// +------------+
// | 数式の編集 |
// +------------+
function changeFormulaContainer(frm, str, x, y)
{
	if ( str == "" )	{	return;		}
	
	array = [ "x", "y", "k" ];			// 斜体にしたい文字をここにセットする
	
	changeFormulaStringContainer(frm, str, array, 18, "");
	frm.x = x;
	frm.y = y;
	frm.visible = true;

}

// +------------------------+
// | テキストの表示位置計算 |
// +------------------------+
function getFormulaPosition(a,b,c,pos)
{
	var x;
	var y;
	var k;
	var cx = ( -adjW + 120 ) / span;
	var cy = adjH / span;
	var size = 0.1;
	var minX = -5;
	var maxX = 6.5;
	var minY = -6;
	var maxY = 7;
	
	// 垂直の場合
	if ( b == 0 )
	{
		if ( pos == "L" )		{	y = minY;	}
		else					{	y = maxY;	}
		x = getX( a, b, c, y );	
		return { x:x, y:y };
	}
	
	// 水平の場合
	if ( a == 0 )
	{
		if ( pos == "L" )		{	x = minX;	}
		else					{	x = maxX;	}
		y = getY( a, b, c, x );	
		return { x:x, y:y };
	}
	
	// 傾き
	var k = a / b;
	
	// 垂直方向に近い
	if ( Math.abs(k) > 1 )
	{
		// 左側に表示
		if ( pos == "L" )
		{
			// 左下がり
			if ( k <= 0 )
			{
				for ( y=minY; y<=maxY; y+=size )
				{
					x = getX( a, b, c, y );	
					if ( x >= minX )	{	break;	}
				}
				y -= size;
			}
			// 左上がり
			else
			{
				for ( y=maxY; y>=minY; y-=size )
				{
					x = getX( a, b, c, y );	
					if ( x >= minX )	{	break;	}
				}
				y += size;
			}
		}
		// 右側に表示
		else
		{
			// 右上がり
			if ( k <= 0 )
			{
				for ( y=maxY; y>=minY; y-=size )
				{
					x = getX( a, b, c, y );	
					if ( x <= maxX )	{	break;	}
				}
				y += size;
			}
			// 右下がり
			else
			{
				for ( y=minY; y<=maxY; y+=size )
				{
					x = getX( a, b, c, y );	
					if ( x <= maxX )	{	break;	}
				}
				y -= size;
			}
		}
	}
	// 水平方向に近い
	else
	{
		// 左側に表示
		if ( pos == "L" )
		{
			// 左下がり
			if ( k <= 0 )
			{
				for ( x=minX; x<=maxX; x+=size )
				{
					y = getY( a, b, c, x );	
					if ( y >= minY )	{	break;	}
				}
				x -= size;
			}
			// 左上がり
			else
			{
				for ( x=minX; x<=maxX; x+=size )
				{
					y = getY( a, b, c, x );	
					if ( y <= maxY )	{	break;	}
				}
				x -= size;
			}
		}
		// 右側に表示
		else
		{
			// 右上がり
			if ( k <= 0 )
			{
				for ( x=maxX; x>=minX; x-=size )
				{
					y = getY( a, b, c, x );	
					if ( y <= maxY )	{	break;	}
				}
				x += size;
			}
			// 右下がり
			else
			{
				for ( x=maxX; x>=minX; x-=size )
				{
					y = getY( a, b, c, x );	
					if ( y >= minY )	{	break;	}
				}
				x += size;
			}
		}
	}
	return { x:x, y:y };
}

//	+--------------+
//	| 式や値の表示 |
//	+--------------+
function drawFormula()
{
	try
	{
		var str;
		str = editForm3( f1a, f1b, -f1c, "≦" );
		//document.getElementById("form0").innerHTML = str;
		changeMathJax( "form0", "\\small{" + str + "}", false );
		
		str = editForm3( f2a, f2b, -f2c, "≦" );
		//document.getElementById("form1").innerHTML = str;
		changeMathJax( "form1", "\\small{" + str + "}", false );
		
		str = editForm3( f3a, f3b, -f3c, "≧" );
		//document.getElementById("form2").innerHTML = str;
		changeMathJax( "form2", "\\small{" + str + "}", false );
		
		str = editForm3( f4a, f4b, -f4c, "≧" );
		//document.getElementById("form3").innerHTML = str;
		changeMathJax( "form3", "\\small{" + str + "}", false );
		
	}
	catch(e)
	{
		alert("drawFormula:" + e.toString());
	}
}

//	+----------+
//	| 式の編集 |
//	+----------+
function editForm(a,b,c,f)
{
	try
	{
		var str = "";
		switch( a )
		{
			case 0:
				break;
			case -1:
				str += "<span class='uTimes'>-</span><span class='times'>x</span>";
				break;
			case 1:
				str += "<span class='times'>x</span>";
				break;
			default:
				str += "</span><span class='uTimes'>" + a + "</span><span class='times'>x</span>";
				break;
		}
		
		switch( b )
		{
			case 0:
				break;
			case -1:
				if ( a == 0 )	{	str += "<span class='times'>y</span>";											}
				else			{	str += "<span class='uTimes'> - </span><span class='times'>y</span>";		}
				break;
			case 1:
				if ( a == 0 )	{	str += "<span class='times'>y</span>";											}
				else			{	str += "<span class='uTimes'> + </span><span class='times'>y</span>";		}
				break;
			default:
				if ( a == 0 )
				{
					str += "<span class='uTimes'>" + b + "</span><span class='times'>y</span>";
				}
				else
				{
					if ( b > 0 )	{	str += "<span class='uTimes'> + " + Math.abs(b) + "</span><span class='times'>y</span>";	}
					else			{	str += "<span class='uTimes'> - " + Math.abs(b) + "</span><span class='times'>y</span>";	}
				}
				break;
		}
		switch( f )
		{
			case "0":
				break;
			case "1":
				if ( c > 0 )	{	str += "<span class='uTimes'> + " + Math.abs(c) + "</span>";	}
				if ( c < 0 )	{	str += "<span class='uTimes'> - " + Math.abs(c) + "</span>";	}
				break;
			default:
				str += "</span><span class='uTimes'> " + f + " " + -c + "</span>";
				break;
		}
		return str;
	}
	catch(e)
	{
		alert("editForm:" + e.toString());
	}
}

//	+------------+
//	| 式の編集２ |
//	+------------+
function editForm2(a,b,c)
{
	try
	{
		var str = "y=";
		if ( a == 0 )
		{
			str = "y=" + -( c / b );
		}
		else
		{
			if ( b == 0 )
			{
				str = "x=" + -( c / a );
			}
			else
			{
				if ( b >= 0 )
				{
					var ab = Math.round( -a / b * 100 ) / 100;
					var cb = Math.round( -c / b * 100 ) / 100;
					if ( ab == 1 || ab == -1 )
					{
						if ( ab == 1 )	{	str += "x";		}
						else			{	str += "-x";	}
					}
					else
					{
						str += ab + "x";
					}
					if ( cb > 0 )	{	str += "+" + Math.abs( cb );	}
					if ( cb < 0 )	{	str += "-" + Math.abs( cb );	}
				}
				else
				{
					var ab = Math.round( a / -b * 100 ) / 100;
					var cb = Math.round( c / -b * 100 ) / 100;
					if ( ab == 1 || ab == -1 )
					{
						if ( ab == 1 )	{	str += "x";		}
						else			{	str += "-x";	}
					}
					else
					{
						str += ab + "x";
					}
					if ( cb > 0 )	{	str += "+" + Math.abs( cb );	}
					if ( cb < 0 )	{	str += "-" + Math.abs( cb );	}
				}
			}
		}
		return str;
	}
	catch(e)
	{
		alert("editForm2:" + e.toString());
	}
}

//	+------------+
//	| 式の編集３ |
//	+------------+
function editForm3(a,b,c,f)
{
	try
	{
		var str = "";
		switch( a )
		{
			case 0:
				break;
			case -1:
				str += "-x";
				break;
			case 1:
				str += "x";
				break;
			default:
				str += a + "x";
				break;
		}
		
		switch( b )
		{
			case 0:
				break;
			case -1:
				str += "-y";
				break;
			case 1:
				str += "+y";
				break;
			default:
				if ( b >= 0 )	{	str += "+" + b + "y";	}
				else			{	str += b + "y";			}
				break;
		}
		
		if ( str.indexOf("+") == 0 )	{	str = str.substr(1);	}
		
		switch( f )
		{
			case "none":
				break;
			case "=0":
			case ">0":
			case "<0":
			case "≧0":
			case "≦0":
				if ( c > 0 )	{	str += "+" + Math.abs(c) + f;	}
				if ( c < 0 )	{	str += "-" + Math.abs(c) + f;	}
				if ( c == 0 )	{	str += f;	}
				break;
			case "1":
				if ( c > 0 )	{	str += "+" + Math.abs(c);	}
				if ( c < 0 )	{	str += "-" + Math.abs(c);	}
				break;
			default:
				if ( c >= 0 )	{	str += f + Math.abs(c);			}
				else			{	str += f + "-" + Math.abs(c);	}
				break;
		}
		return str;
	}
	catch(e)
	{
		alert("editForm3:" + e.toString());
	}
}

//	+--------------+
//	| ドットの表示 |
//	+--------------+
function drawDot(dot,x,y,color,alpha)
{
	try
	{
		var col = "rgba(0,0,0," + alpha + ")";
		switch( color )
		{
			case "gray":
				col = "rgba(32,32,32," + alpha + ")";
				break;
			case "blue":
				col = "rgba(0,124,197," + alpha + ")";
				break;
			case "red":
				col = "rgba(255,0,0," + alpha + ")";
				break;
			case "orange":
				col = "rgba(255,127,0," + alpha + ")";
				break;
		}
		
		var x = centerX + x * span;
		var y = centerY - y * span;
		dot.graphics.setStrokeStyle(1);
		dot.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		dot.graphics.beginFill(col);
		dot.graphics.drawCircle(x, y, 5);
		dot.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		dot.graphics.drawCircle(x, y, 15);
		dot.graphics.endFill();
		dot.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawDot:" + e.toString());
	}
}

//	+----------+
//	| 円の表示 |
//	+----------+
function drawRing(circle, x, y, r, col, alpha, fill)
{
	try
	{
		circle.graphics.setStrokeStyle(1);
		// 色
		var color;
		switch( col )
		{
			case "white":
				color = "rgba( 255, 255, 255, " + alpha + " )";
				break;
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		circle.graphics.beginStroke( color );
		if ( fill )		{	circle.graphics.beginFill( color );		}
		circle.graphics.drawCircle( centerX + x * span, centerY - y * span, r * span );
		if ( fill )		{	circle.graphics.endFill();		}
		circle.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawRing:" + e.toString());
	}
}


//	+------------+
//	| 円の表示２ |
//	+------------+
function drawRing2(circle, x, y, r, col1, col2, alpha, fill)
{
	try
	{
		circle.graphics.setStrokeStyle(1);
		// 色
		var color;
		switch( col1 )
		{
			case "white":
				color = "rgba( 255, 255, 255, " + alpha + " )";
				break;
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		var fillColor;
		switch( col2 )
		{
			case "white":
				fillColor = "rgba( 255, 255, 255, " + alpha + " )";
				break;
			case "blue":
				fillColor = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				fillColor = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				fillColor = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		circle.graphics.beginStroke( color );
		if ( fill )		{	circle.graphics.beginFill( fillColor );		}
		circle.graphics.drawCircle( centerX + x * span, centerY - y * span, r * span );
		if ( fill )		{	circle.graphics.endFill();		}
		circle.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawRing2:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示１ |
//	+--------------+
function drawLine_1(line, a, b, c, col, alpha)
{
	try
	{
		// 傾き(軸の方向注意)
		var pA = a / b;
		
		// 切片(軸の方向注意)
		var pB = c / b;
		
		line.graphics.setStrokeStyle(1);
		
		// 色
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 124, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		
		// 縦の線
		if ( b == 0 )
		{
			line.graphics.moveTo(0, -cH);
			line.graphics.lineTo(0, cH);
			line.x = cW/2 + (-c/a) * span;
			line.y = cH/2;
			line.graphics.endStroke();
			line.graphics.setStrokeStyle(20);
			line.graphics.beginStroke("rgba( 255, 255, 255, 0.02 )");
			line.graphics.beginFill("rgba( 255, 255, 255, 0.02 )");
			line.x = cW/2 + (-c/a) * span;
			line.y = cH/2;
			line.graphics.endFill();
		}
		// 横の線
		else if ( a == 0 )
		{
			line.graphics.moveTo(-cW, 0);
			line.graphics.lineTo(cW, 0);
			line.x = cW/2;
			line.y = cH/2 + pB * span;
			line.graphics.endStroke();
			line.graphics.setStrokeStyle(20);
			line.graphics.beginStroke("rgba( 255, 255, 255, 0.02 )");
			line.graphics.beginFill("rgba( 255, 255, 255, 0.02 )");
			line.graphics.moveTo(-cW, 0);
			line.graphics.lineTo(cW, 0);
			line.graphics.endFill();
		}
		else
		{
			line.graphics.moveTo(-cH/ pA, -cH);
			line.graphics.lineTo(cH/ pA, cH);
			line.x = cW/2;
			line.y = cH/2 + pB  * span;
			line.graphics.endStroke();
			line.graphics.setStrokeStyle(20);
			line.graphics.beginStroke("rgba( 255, 255, 255, 0.02 )");
			line.graphics.beginFill("rgba( 255, 255, 255, 0.02 )");
			line.graphics.moveTo(-cH/ pA, -cH);
			line.graphics.lineTo(cH/ pA, cH);
			line.graphics.endFill();
			
		}
		
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLine_1:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示２ |
//	+--------------+
function drawLine_2(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		var k = ( x2 - x1 ) / ( y2 - y1 ) * 2000;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 124, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span + k, centerY - yy1 * span + 2000);
		line.graphics.lineTo( centerX + xx2 * span - k, centerY - yy2 * span - 2000);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLine_2:" + e.toString());
	}
}

//	+--------------+
//	| 直線の表示３ |
//	+--------------+
function drawLine_3(line,xx1,yy1,xx2,yy2,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 124, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		line.graphics.moveTo( centerX + xx1 * span, centerY - yy1 * span);
		line.graphics.lineTo( centerX + xx2 * span, centerY - yy2 * span);
		line.graphics.endStroke();
		
	}
	catch(e)
	{
		alert("drawLine_3:" + e.toString());
	}
}

//	+----------------+
//	| 座標破線の表示 |
//	+----------------+
function drawDotLine(line,x,y,col,alpha)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		line.graphics.setStrokeDash([5, 5], 0);
		line.graphics.moveTo( centerX + x * span, centerY );
		line.graphics.lineTo( centerX + x * span, centerY - y * span );
		line.graphics.lineTo( centerX, centerY - y * span );
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawDotLine:" + e.toString());
	}
}

//	+--------------+
//	| 四角形の表示 |
//	+--------------+
function drawSquare(line,x1,y1,x2,y2,col,alpha,fill)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		if ( fill )		{	line.graphics.beginFill( color );		}
		line.graphics.moveTo( centerX + x1 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y1 * span );
		if ( fill )		{	line.graphics.endFill();		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawSquare:" + e.toString());
	}
}

//	+------------+
//	| 矩形の表示 |
//	+------------+
function drawBox(line,x1,y1,x2,y2,x3,y3,x4,y4,col,alpha,fill)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		if ( fill )		{	line.graphics.beginFill( color );		}
		line.graphics.moveTo( centerX + x1 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x3 * span, centerY - y3 * span );
		line.graphics.lineTo( centerX + x4 * span, centerY - y4 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y1 * span );
		if ( fill )		{	line.graphics.endFill();		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawBox:" + e.toString());
	}
}

//	+--------------+
//	| ５角形の表示 |
//	+--------------+
function drawPentagon(line,x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,col,alpha,fill)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		if ( fill )		{	line.graphics.beginFill( color );		}
		line.graphics.moveTo( centerX + x1 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x3 * span, centerY - y3 * span );
		line.graphics.lineTo( centerX + x4 * span, centerY - y4 * span );
		line.graphics.lineTo( centerX + x5 * span, centerY - y5 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y1 * span );
		if ( fill )		{	line.graphics.endFill();		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawPentagon:" + e.toString());
	}
}

//	+--------------+
//	| ６角形の表示 |
//	+--------------+
function drawHexagon(line,x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,x6,y6,col,alpha,fill)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		if ( fill )		{	line.graphics.beginFill( color );		}
		line.graphics.moveTo( centerX + x1 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x3 * span, centerY - y3 * span );
		line.graphics.lineTo( centerX + x4 * span, centerY - y4 * span );
		line.graphics.lineTo( centerX + x5 * span, centerY - y5 * span );
		line.graphics.lineTo( centerX + x6 * span, centerY - y6 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y1 * span );
		if ( fill )		{	line.graphics.endFill();		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawHexagon:" + e.toString());
	}
}

//	+--------------+
//	| 三角形の表示 |
//	+--------------+
function drawTriangle(line,x1,y1,x2,y2,x3,y3,col,alpha,fill)
{
	try
	{
		line.graphics.setStrokeStyle(1);
		var color;
		switch( col )
		{
			case "blue":
				color = "rgba( 0, 124, 197, " + alpha + " )";
				break;
			case "red":
				color = "rgba( 255, 0, 0, " + alpha + " )";
				break;
			default:
				color = "rgba( 0, 0, 0, " + alpha + " )";
				break;
		}
		line.graphics.beginStroke( color );
		if ( fill )		{	line.graphics.beginFill( color );		}
		line.graphics.moveTo( centerX + x1 * span, centerY - y1 * span );
		line.graphics.lineTo( centerX + x2 * span, centerY - y2 * span );
		line.graphics.lineTo( centerX + x3 * span, centerY - y3 * span );
		line.graphics.lineTo( centerX + x1 * span, centerY - y1 * span );
		if ( fill )		{	line.graphics.endFill();		}
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawTriangle:" + e.toString());
	}
}

//	+--------------+
//	| 等長線の表示 |
//	+--------------+
function drawEqlenLine(line,x1,y1,x2,y2,pos,col,alpha)
{
	try
	{
		x1 = centerX + x1 * span;
		y1 = centerY - y1 * span;
		x2 = centerX + x2 * span;
		y2 = centerY - y2 * span;
		var t =  Math.atan2( ( x2 - x1 ) , ( y2 - y1 ) );
		var xx = Math.cos(t) * 5;
		var yy = Math.sin(t) * 5;
		line.graphics.setStrokeStyle(1);
		switch( col )
		{
			case "blue":
				line.graphics.beginStroke("rgba( 0, 124, 197, " + alpha + ")");
				break;
			case "red":
				line.graphics.beginStroke("rgba( 255, 0, 0, " + alpha + ")");
				break;
			default:
				line.graphics.beginStroke("rgba( 0, 0, 0, " + alpha + ")");
				break;
		}
		var bX1 = x2 + ( x1 - x2 ) * pos;
		var bY1 = y2 + ( y1 - y2 ) * pos;
		line.graphics.moveTo( bX1 + xx, bY1 - yy );
		line.graphics.lineTo( bX1 - xx, bY1 + yy );
		line.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawEqlenLine:" + e.toString());
	}
}

//	+----------+
//	| 座標表示 |
//	+----------+
function drawPosText(text1,text2)
{
	var x = text1.text;
	var y = text2.text;
	text1.x = centerX + x * span - 4;
	if ( y >= 0 )
	{
		text1.y = centerY;
	}
	else
	{
		text1.y = centerY - 20;
	}
	if ( x >= 0 )
	{
		text2.textAlign = "right";
		text2.x = centerX - 4;
	}
	else
	{
		text2.textAlign = "left";
		text2.x = centerX + 4;
	}
	text2.y = centerY - y * span - 10;
}

//	+------------+
//	| 座標表示２ |
//	+------------+
function drawPosText2(text1,text2)
{
	var x = text1.text;
	var y = text2.text;
	if ( x >= 0 )
	{
		text1.x = centerX + x * span + 4;
	}
	else
	{
		text1.x = centerX + x * span - 18;
	}
	text1.y = centerY;
	
	text2.textAlign = "right";
	text2.x = centerX - 4;
	if ( y >= 0 )
	{
		text2.y = centerY - y * span - 20;
	}
	else
	{
		text2.y = centerY - y * span;
	}
}

//	+--------------+
//	| 計算処理サブ |
//	+--------------+
function calcLine(x1,y1,x2,y2)
{
	
	var a = ( x2-x1 ) / ( y2-y1 );
	var b = 1;
	var c = y2;
	return [ {a:a,b:b,c:c} ];
}

function getX(a,b,c,y)
{
	if ( a == 0 )	{	return	-( c / b );	}
	return -( y * b + c ) / a;
}

function getY(a,b,c,x)
{
	if ( b == 0 )	{	return	-( c / a );	}
	return -( x * a + c ) / b;
}

function calcFormula(a,b,c,x,y)
{
	var ans = a * x + b * y + c;
	return ans;
}

// ２直線の交点
function cpt(a1,b1,c1,a2,b2,c2)
{
	if ( b1 == 0 )
	{
		x = -c1 / a1;
		y = getY(a2,b2,c2,x);
	}
	else if ( b2 == 0 )
	{
		x = -c2 / a2;
		y = getY(a1,b1,c1,x);
	}
	else
	{
		var a = a1 / b1;
		var b = c1 / b1;
		var c = a2 / b2;
		var d = c2 / b2;
		var x = ( d - b ) / ( a - c );
		var y = -( a * d - b * c ) / ( a - c );
		x = Math.round( x * 100 ) / 100;
		y = Math.round( y * 100 ) / 100;
	}
	return [{x:x,y:y}];
}

// 円と直線の交点
function cli(a,b,c,x1,y1,r)
{
	var l = a*a+b*b;
	var k = a*x1+b*y1+c;
	var d = l*r*r-k*k;
	if(d>0){
		var ds = Math.sqrt(d);
		var apl = a/l;
		var bpl = b/l;
		var xc = x1-apl*k;
		var yc = y1-bpl*k;
		var xd = bpl*ds;
		var yd = apl*ds;
		return [
			{x:xc-xd,y:yc+yd},
			{x:xc+xd,y:yc-yd}
		];
	}else if(d==0){
		return [{x:x1-a*k/l,y:y1-b*k/l}];
	}else{
		return [];
	}
}
// 円と円の交点
function cci(x1,y1,r1,x2,y2,r2)
{
	var a = x1-x2;
	var b = y1-y2;
	return cli(a,b,0.5*((r1-r2)*(r1+r2)-a*(x1+x2)-b*(y1+y2)),x1,y1,r1);
}

// 円の半径
function calcRad(x,y,l,m,n)
{
	var xx = x + l / 2;
	var yy = y + m / 2;
	var rad = ( l * l + m * m ) / 4 + n;
	var r = Math.sqrt( rad );
	return	[ {x:xx,y:yy,rad:rad,r:r} ];
}

//	+----------+
//	| 値の入力 |
//	+----------+
function changeDataHandler(e)
{
	try
	{
		switch( e.currentTarget.id )
		{
			case "upBtn0":
				var num = slider.prev + stepSize;
				if ( num > slider.max )		{	var num = slider.prev;	}
				kNum = Math.round( num * 100 ) / 100;
				slider.prev = kNum;
				document.getElementById('kNum').innerHTML = kNum;
				break;
			case "downBtn0":
				var num = slider.prev - stepSize;
				if ( num < slider.min )		{	var num = slider.prev;	}
				kNum = Math.round( num * 100 ) / 100;
				slider.prev = kNum;
				document.getElementById('kNum').innerHTML = kNum;
				break;
		}
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面オープン |
// +----------------------------+
function openOptionHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			//式の値を設定
			document.getElementById('optionBlock0').style.display = "none";
			optName = e.currentTarget.id;
			switch ( optName )
			{
				case "optionBtn0":
					document.getElementById('text0_0').value = f1a;
					document.getElementById('text0_1').value = f1b;
					document.getElementById('text0_2').value = -f1c;
					cka = f2a;
					ckb = f2b;
					ckc = f2c;
					document.getElementById('optionBlock0').style.display = "";
					break;
				case "optionBtn1":
					document.getElementById('text0_0').value = f2a;
					document.getElementById('text0_1').value = f2b;
					document.getElementById('text0_2').value = -f2c;
					document.getElementById('optionBlock0').style.display = "";
					cka = f1a;
					ckb = f1b;
					ckc = f1c;
					break;
			}
			showModal('optionBlock');
		}
	}
	catch(e)
	{
		alert('openOptionHandler:' + e.toString());
	}
}

// +----------------+
// | 式の値変更入力 |
// +----------------+
function changeFormulaHandler(e)
{
	try
	{
		var num;
		var a = parseFloat(document.getElementById("text0_0").value);
		var b = parseFloat(document.getElementById("text0_1").value);
		var k = cka / ckb;
		switch(e.target.id)
		{
			case "upBtn0_0":
				num = parseFloat(document.getElementById("text0_0").value);
				num += stepSize;
				if ( num == 0 )
				{
					if ( b == 0 || cka == 0 )	{	num += stepSize;	}
				}
				else
				{
					if ( ( num / b ) == ( k ) )	{	num += stepSize;	}
				}
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_0").value = num;
				break;
			case "upBtn0_1":
				num = parseFloat(document.getElementById("text0_1").value);
				num += stepSize;
				if ( num == 0 )
				{
					if ( a == 0 || ckb == 0 )	{	num += stepSize;	}
				}
				else
				{
					if ( ( a / num ) == ( k ) )	{	num += stepSize;	}
				}
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_1").value = num;
				break;
			case "upBtn0_2":
				num = parseFloat(document.getElementById("text0_2").value);
				num += stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_2").value = num;
				break;
			
			case "downBtn0_0":
				num = parseFloat(document.getElementById("text0_0").value);
				num -= stepSize;
				if ( num == 0 )
				{
					if ( b == 0 || cka == 0 )	{	num -= stepSize;	}
				}
				else
				{
					if ( ( num / b ) == ( k ) )	{	num -= stepSize;	}
				}
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_0").value = num;
				break;
			case "downBtn0_1":
				num = parseFloat(document.getElementById("text0_1").value);
				num -= stepSize;
				if ( num == 0 )
				{
					if ( a == 0 || ckb == 0 )	{	num -= stepSize;	}
				}
				else
				{
					if ( ( a / num ) == ( k ) )	{	num -= stepSize;	}
				}
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_1").value = num;
				break;
			case "downBtn0_2":
				num = parseFloat(document.getElementById("text0_2").value);
				num -= stepSize;
				num = Math.round( num * 100 ) / 100;
				document.getElementById("text0_2").value = num;
				break;
			
		}
	}
	catch(e)
	{
		alert("changeFormulaHandler:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面クローズ |
// +----------------------------+
function closeOptionHandler(e)
{
	try
	{
		switch ( optName )
		{
			case "optionBtn0":
				f1a = parseFloat(document.getElementById("text0_0").value);
				f1b = parseFloat(document.getElementById("text0_1").value);
				f1c = -parseFloat(document.getElementById("text0_2").value);
				break;
			case "optionBtn1":
				f2a = parseFloat(document.getElementById("text0_0").value);
				f2b = parseFloat(document.getElementById("text0_1").value);
				f2c = -parseFloat(document.getElementById("text0_2").value);
				break;
		}
		optName = "";
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		closeModal();
	}
	catch(e)
	{
		alert("closeOptionHandler:" + e.toString());
	}
}

//	+------------------------------+
//	| チェックボックスのオン・オフ |
//	+------------------------------+
function changeCheckHandler(e)
{
	try
	{
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

//	+----------------------+
//	| 刻み幅の設定画面表示 |
//	+----------------------+
function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		if ( e.currentTarget.id == "stepText" )
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize);
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}
//	+--------------+
//	| 刻み幅の変更 |
//	+--------------+
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
		var n;
		
		// 設定した刻み幅の倍数に変更
		n = kNum;
		n = Math.round( n / num ) * num;
		n = Math.round( n * 100 ) / 100;
		document.getElementById("kNum").innerHTML = n;
		kNum = n;
		slider.prev = n;
		slider.span = num;
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ開始 |
//	+------------------+
function dotDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			
			e.currentTarget.addEventListener("pressmove", dotDragMove);
			e.currentTarget.addEventListener("pressup", dotDragStop);
			e.currentTarget.addEventListener("mouseup", dotDragStop);
			e.currentTarget.addEventListener("mouseout", dotDragStop);
		}
	}
	catch(e)
	{
		alert("dotDragStart:" + e.toString());
	}
}

//	+--------------+
//	| 点のドラッグ |
//	+--------------+
function dotDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.01;
		
		if ( Math.abs( x ) > 1 || Math.abs( y ) > 1 )
		{
			prevX = e.stageX;
			prevY = e.stageY;
			var numX = ( e.stageX - centerX ) / span;
			var numY = -( e.stageY - centerY ) / span;
			numX = Math.round( numX / size ) * size;
			numY = Math.round( numY / size ) * size;
			numX = Math.round( numX * 10 ) / 10;
			numY = Math.round( numY * 10 ) / 10;
			switch( e.currentTarget.name )
			{
				case "dotA":
					ax = numX;
					ay = numY;
					break;
				case "dotP":
					break;
			}
		}
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
	}
	catch(e)
	{
		alert("dotDragMove:" + e.toString());
	}
}

//	+------------------+
//	| 点のドラッグ終了 |
//	+------------------+
function dotDragStop(e)
{
	try
	{
		dFlag = true;
		
		calcData();
		drawFormula();
		drawShape();
		drawText();
		cs.update();
		
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("dotDragStop:" + e.toString());
	}
}

//	+------------------+
//	| 線のドラッグ開始 |
//	+------------------+
function lineDragStart(e)
{
	try
	{
		if ( dFlag )
		{
			dFlag = false;
			prevX = e.stageX;
			prevY = e.stageY;
			
			shp[SHAPE_LINE_K].graphics.clear();
			drawLine_1( shp[SHAPE_LINE_K], 1, 1, -slider.prev, "red", 1 );
			cs.update();
			
			e.currentTarget.addEventListener("pressmove", lineDragMove);
			e.currentTarget.addEventListener("pressup",lineDragStop);
			e.currentTarget.addEventListener("mouseup", lineDragStop);
			e.currentTarget.addEventListener("mouseout", lineDragStop);
		}
	}
	catch(e)
	{
		alert("lineDragStart:" + e.toString());
	}
}

//	+--------------+
//	| 線のドラッグ |
//	+--------------+
function lineDragMove(e)
{
	try
	{
		var x = e.stageX - prevX;
		var y = e.stageY - prevY;
		var size = 0.1;
		
		if ( Math.abs( x ) > 1 )
		{
			prevX = e.stageX;
			prevY = e.stageY;
			if ( x > 0 )	{	slider.prev += size;	}
			if ( x < 0 )	{	slider.prev -= size;	}
			slider.prev = Math.round( slider.prev * 100 ) / 100;
			shp[SHAPE_LINE_K].graphics.clear();
			drawLine_1( shp[SHAPE_LINE_K], 1, 1, -slider.prev, "red", 1 );
			txt[TEXT_K].text = "k=" + slider.prev;
			txt[TEXT_K].x = centerX + slider.prev * span + 20;
			txt[TEXT_K].y = centerY + span;
			txt[TEXT_K].color = "#00A5C7";
			cs.update();
		}
		
	}
	catch(e)
	{
		alert("lineDragMove:" + e.toString());
	}
}
//	+------------------+
//	| 線のドラッグ終了 |
//	+------------------+
function lineDragStop(e)
{
	try
	{
	
		shp[SHAPE_LINE_K].graphics.clear();
		drawLine_1( shp[SHAPE_LINE_K], 1, 1, -slider.prev, "blue", 1 );
		cs.update();
		dFlag = true;
		
		e.currentTarget.removeEventListener("pressmove", dotDragMove);
		e.currentTarget.removeEventListener("pressup", dotDragMove);
		e.currentTarget.removeEventListener("mouseup", dotDragMove);
		e.currentTarget.removeEventListener("mouseout", dotDragMove);
	}
	catch(e)
	{
		alert("lineDragStop:" + e.toString());
	}
}

//	+--------------------------+
//	| キャンバスのドラッグ開始 |
//	+--------------------------+
function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

//	+----------------------+
//	| キャンバスのドラッグ |
//	+----------------------+
function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		//座標の変化量
		var sX;
		var sY;
		
		if(cScale >= 1)
		{
			sX = e.stageX - prevX;
			sY = e.stageY - prevY;
		}
		else
		{
			sX = (e.stageX - prevX) * cScale;
			sY = (e.stageY - prevY) * cScale;
		}
		
		//移動限界
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		changeGraphScale(configArray[1][0], configArray[1][1]);
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}
	
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function dragStop(e)
{
	try
	{
		if(ictMode)
		{
			$(window).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}

//	+----------------+
//	| グラフ目盛変更 |
//	+----------------+
function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//弧度法
		if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
				
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str, "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

//	+----------------------------+
//	| オプション画面のスクロール |
//	+----------------------------+
function closeInnerBalloonHandler(e)
{
	try
	{
		// 刻み幅入力画面が開かれていたら閉じる
		if ( document.getElementById("selectBalloon_menu").style.display != "none" )
		{
			closeSelectBalloon();
		}
	}
	catch(e)
	{
		alert("closeInnerBalloonHandler:" + e.toString());
	}
}

//	+--------------+
//	| スケール変更 |
//	+--------------+
function changeGraphScale(sX, sY)
{
	try
	{
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の目盛
		if(sX != null)
		{
			var spanX = span * sX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
		}
		
		
		//y軸の目盛
		if(sY != null)
		{
			spanY = span * sY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

//	+--------------+
//	| グリッド変更 |
//	+--------------+
function changeGraphGrid(gX, gY)
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の線
		if(gX != null)
		{
			var spanX = span * gX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
		}
		
		
		//y軸の線
		if(gY != null)
		{
			spanY = span * gY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

//	+----------+
//	| 状態保存 |
//	+----------+
function saveContent()
{
	try
	{
//		var array = [];
//		array[0] = stepSize;
//		array[1] = configArray.slice();
//		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

//	+----------+
//	| 状態読込 |
//	+----------+
function loadContent(array)
{
	try
	{
	
	
	
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

// +----------+
// | リセット |
// +----------+
function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			// 刻み値
			stepSize = 1;
			
			//設定吹き出し
			configArray = [];
			configArray[0] = [-30, 360, -10, 10];
			configArray[1] = [null, null];
			configArray[2] = [null, null];
			
			f1a = 3;
			f1b = 1;
			f1c = -9;
			
			f2a = 1;
			f2b = 2;
			f2c = -8;
			
			f3a = 1;
			f3b = 0;
			f3c = 0;
			
			f4a = 0;
			f4b = 1;
			f4c = 0;
			
			t1x = 0;
			t1y = 0;
			
			$("#kNum").html(defNum);
			$("#tMin").html(defMin);
			$("#tMax").html(defMax);
			
			slider.prev = defNum;
			slider.min = defMin;
			slider.max = defMax;
			slider.span = stepSize;
			
			slider.changeSliderLine();
			slider.changeSliderPoint();
			slider.changeSliderControl();
			
			crossPoint = [ { x:0, y:0 } ];
			pointA = [ { x:0, y:0 } ];
			pointB = [ { x:0, y:0 } ];
			pointC = [ { x:0, y:0 } ];


			optName = "";
			
			// ドラッグ関連
			dFlag = true;
			animeFlag = false;
			
			// 状態の記録エリア
			recData = [];
			
			// チェックボックス
			document.getElementById("check0").checked = false;
			document.getElementById("check1").checked = false;
			document.getElementById("check2").checked = false;
			document.getElementById("check3").checked = false;
			document.getElementById("check4").checked = false;
			
			// ドラッグ関連
			dFlag = true;
			
			// 初期表示に戻す
			changeGraphScale(null, null);
			changeGraphGrid(null, null);
			
			// 刻み幅
			document.getElementById("stepText").innerHTML = stepSize;
			
			// 軸表示
			drawBaseLine();
			changeAxisPositionHandler();
			
			// 計算処理
			calcData();
			
			// 式の表示
			drawFormula();
			
			// 図形の表示
			drawShape();
			
			// テキストの表示
			drawText();
			
			// ステージ更新
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
