// JavaScript Document

//	===============================
//    No 039 ： a_2_P127_001.js
//	===============================

// +------------+
// | 共通の変数 |
// +------------+

// キャンバス、ステージ
var cc;
var cs;
var ctx;

// キャンバスの幅、高さ
var bW;
var bH;
var cW;
var cH;

// Ｘ軸、Ｙ軸、原点テキスト
var tx;
var ty;
var t0;

var numX;
var numY;

// 軸線
var base;

// 方眼
var grid;

// 背景
var bg;

// 刻み幅
var stepSize;

// グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

var addRad;

// 状態記録
var recCont;
var recData;

// アニメーション制御用スライダー
var slider;

// 中心位置
var centerX;
var centerY;

// １周期のピクセル
var baseCycle;

// １目盛りあたりのピクセル
var span;

// Ｘ軸、Ｙ軸
var axisX;
var axisY;

// ドラッグ中のフラグ、マウス位置
var dFlag;
var prevX;
var prevY;
var dragNum;

// +------------+
// | 個別の変数 |
// +------------+

// グラフ
var dotLine;
var dotLine1;
var line0;
var dotRed;

var dotLine2;

var tanLine;

// 上限値、下限値、既定値
var defMin;
var defMax;
var defNum;

var recData;


// 左側の円と表示バー
var circleCont;
var circle;
var circleAxisX;
var circleAxisY;
var circleRad;
var circleCenterX;
var circleCenterH;
var circleGraph;
var dragPoint;

// キャンバスに表示するテキスト
var txt;

var leftLimit;


var thetaTxt;

var dispFlag;

var checkShape;

var crossText;

var gTheta;

var tx0;
var tx1;
var tx2;
var ty0;
var ty1;
var ty2;


//空白のための矩形
var spaceSp;

var unitTxt;

var timer;

//	+----------------+
//	| ロード時の処理 |
//	+----------------+
function loadContentHandler()
{
	try
	{
		//------------
		// 初期値設定
		//------------
		
		// １周期のピクセル
		baseCycle = 300;
		
		// 軸の１目盛当たりのピクセル
		span = baseCycle/Math.PI;
		
		// 刻み値
		stepSize = 1;
		
		leftLimit = 100;
		
		// キャンバスサイズ
		bW = pageWidth-52;
		bH = pageHeight;
		cW = bW * 3;
		cH = bH * 3;
		
		// 中央位置
		centerX = cW/2;
		centerY = cH/2;
		
		// グラフ描画域の設定
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphCanvas").style.left = (-bW) + "px";
		document.getElementById("graphCanvas").style.top = (-bH-90) + "px";
		document.getElementById("graphCanvas").style.position = "absolute";
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		
		// 値の上限、下限、既定値
		defMin = 0;
		defMax = 360;
		defNum = 0;
		
		//角度変更で変わる際の値
		radArray = [];
		for(var i=0; i<=360; i+=15)
		{
			radArray.push(i);
		}
		
		//θに加える値
		addRad = [0, 30, 45, 60, 90, 120, 135, 150, 180, 210, 225, 240, 270, 300, 315, 330, 360];
		
		//式の右辺
		resultArray = [0.5, 1/Math.sqrt(3), 1/Math.sqrt(2), Math.sqrt(3)/2, 1, Math.sqrt(3)];
		
		// 状態の記録
		recData = [];
		
		// θの表示設定
		document.getElementById("theta").style.textAlign = "center";
		document.getElementById("theta").style.width = "60px";
		document.getElementById("theta").style.display = "inline-block";
		
		// チェックボックス初期化
		document.getElementById("check1").checked = true;
		document.getElementById("check2").checked = false;
		document.getElementById("check3").checked = false;
		
		//--------------
		// 画面描画関連
		//--------------
		// アニメーションスライダを吹き出しで使用する場合
		slider = new AnimeBalloon( defMin, defMax, defNum, 250, 40, true, 30, changeAnimeGraph, captureData, resetCapture );
		slider.min = defMin;
		slider.max = defMax;
		slider.prev = defNum;
		slider.loopMode = 0;
		
		// ステージ作成
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		ctx = cc.getContext("2d");
		
		// 状態記録のコンテナ作成
		recCont = new createjs.Container();
		cs.addChild(recCont);
		
		// 背景の作成
		bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		cs.addChild(bg);
		
		// グリッドの作成
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		// 軸描画域の作成
		base = new createjs.Shape();
		cs.addChild(base);
		
		// Ｘ軸、Ｙ軸の作成
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		// Ｘ軸、Ｙ軸の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		// Ｘ軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		// Ｙ軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		// Ｘ軸の矢印
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		// Ｙ軸の矢印
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		
		
		//空白の矩形
		spaceSp = new createjs.Shape();
		spaceSp.graphics.setStrokeStyle("#FFFFFF");
		spaceSp.graphics.beginStroke("#FFFFFF");
		spaceSp.graphics.beginFill("#FFFFFF");
		spaceSp.graphics.drawRect(0, 0, 20, 10);
		spaceSp.graphics.endFill();
		spaceSp.graphics.endStroke();
		cs.addChild(spaceSp);
		spaceSp.x = cW/2-100;
		spaceSp.y = cH/2-5;
		
		
		// 軸の位置
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		axisX.x = numX + bW;
		axisX.y = centerY;
		axisY.x = centerX;
		axisY.y = numY;
		// 軸のテキスト作成
		tx = new createjs.Text("θ", "italic 20px Times New Roman", "#000000");
		tx.x = numX + bW -tx.getBounds().width-5;
		tx.y = cH/2+5;
		ty = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
		ty.x = cW/2+10;
		ty.y = numY + 2;
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		t0.x = cW/2+5;
		t0.y = cH/2+5;
		cs.addChild(tx);
		cs.addChild(ty);
		cs.addChild(t0);
		
		// グラフ用
		line0 = new createjs.Shape();
		line0.name = "line0";
		cs.addChild(line0);
		line0.x = cW/2;
		line0.y = cH/2;
		line0.visible = false;

		// １/２破線用
		dotLine = new createjs.Shape();
		dotLine.name = "dotLine";
		cs.addChild(dotLine);
		dotLine.x = cW/2;
		dotLine.y = cH/2;
		dotLine.visible = false;
		
		dotLine1 = new createjs.Shape();
		dotLine1.name = "dotLine1";
		cs.addChild(dotLine1);
		dotLine1.x = cW/2;
		dotLine1.y = cH/2;
		dotLine1.visible = false;
		
		dotLine2 = new createjs.Shape();
		dotLine2.name = "dotLine2";
		cs.addChild(dotLine2);
		
		// 移動アニメ用ドット
		dotRed = new createjs.Shape();
		dotRed.graphics.setStrokeStyle(0);
		dotRed.graphics.beginStroke("#007AC5");
		dotRed.graphics.beginFill("#007AC5");
		dotRed.graphics.drawCircle(0, 0, 5);
		dotRed.graphics.endFill();
		dotRed.graphics.endStroke();
		dotRed.name = "dotRed";
		cs.addChild(dotRed);
		dotRed.visible = false;
		
		// 操作卓の円
		circleCont = new createjs.Container();
		circle = new createjs.Shape();
		circleAxisX = new createjs.Shape();
		circleAxisY = new createjs.Shape();
		circleCont.addChild(circle);
		circleCont.addChild(circleAxisX);
		circleCont.addChild(circleAxisY);
		
		circleRad = Math.sin(Math.PI/2)*span;
		circleCenterX = centerX - circleRad * 3;
		circleCenterH = circleRad * 2;
		
		circleGraph = new createjs.Shape();
		circleCont.addChild(circleGraph);
		
		
		//単位円のテキスト
		tx0 = createUnitText("x", 16, "#000000", true);
		tx1 = createUnitText("1", 16, "#000000", false);
		tx2 = createUnitText("-1", 16, "#000000", false);
		
		ty0 = createUnitText("y", 16, "#000000", true);
		ty1 = createUnitText("1", 16, "#000000", false);
		ty2 = createUnitText("-1", 16, "#000000", false);
		
		circleCont.addChild(tx0);
		circleCont.addChild(tx1);
		circleCont.addChild(tx2);
		
		circleCont.addChild(ty0);
		circleCont.addChild(ty1);
		circleCont.addChild(ty2);
		
		changeUnitText();
		
		//tangent用の線
		tanLine = new createjs.Shape();
		tanLine.graphics.setStrokeStyle(1);
		tanLine.graphics.beginStroke("#000000");
		tanLine.graphics.moveTo(0, -cH/2);
		tanLine.graphics.lineTo(0, cH/2);
		tanLine.graphics.endStroke();
		circleCont.addChild(tanLine);
		tanLine.x = circleRad;
		
		//単位円上のyの値
		unitTxt = new createjs.Container();
		//ルートの記号
		var uSp0 = new createjs.Shape();
		uSp0.name = "sp0";
		uSp0.graphics.setStrokeStyle(1);
		uSp0.graphics.beginStroke(1);
		uSp0.graphics.moveTo(-9, -5);
		uSp0.graphics.lineTo(-7, -8);
		uSp0.graphics.lineTo(-4, -3);
		uSp0.graphics.lineTo(0, -18);
		uSp0.graphics.lineTo(15, -18);
		uSp0.graphics.endStroke();
		//分数の線
		var uSp1 = new createjs.Shape();
		uSp1.name = "sp1";
		//符号
		var ut0 = new createjs.Text("", "16px Times New Roman", "#000000");
		ut0.name = "ut0";
		//分子，数値
		var ut1 = new createjs.Text("", "16px Times New Roman", "#000000");
		ut1.name = "ut1";
		//分母
		var ut2 = new createjs.Text("", "16px Times New Roman", "#000000");
		ut2.name = "ut2";
		unitTxt.addChild(uSp0);
		unitTxt.addChild(uSp1);
		unitTxt.addChild(ut0);
		unitTxt.addChild(ut1);
		unitTxt.addChild(ut2);
		circleCont.addChild(unitTxt);
		
		
		//ドラッグ用の点
		dragPoint = new createjs.Shape();
		dragPoint.graphics.setStrokeStyle(0);
		dragPoint.graphics.beginStroke("#007AC5");
		dragPoint.graphics.beginFill("#007AC5");
		dragPoint.graphics.drawCircle(0, 0, 5);
		dragPoint.graphics.endFill();
		dragPoint.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		dragPoint.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		dragPoint.graphics.drawCircle(0, 0, 15);
		dragPoint.graphics.endFill();
		dragPoint.graphics.endStroke();
		
		circleCont.addChild(dragPoint);
		
		circleCont.x = circleCenterX;
		circleCont.y = cH/2;
		
		cs.addChild(circleCont);
		
		checkShape = new createjs.Shape();
		cs.addChild(checkShape);
		
		//単位円の角度記号
		thetaTxt = new createjs.Container();
		var t = new createjs.Text("θ", "Italic 16px Times New Roman", "#007AC5")
		t.x = -t.getBounds().width/2;
		t.y = -t.getBounds().height/2;
		thetaTxt.addChild(t);
		cs.addChild(thetaTxt);
		
		//
		gTheta = createUnitText("θ", 16, "#000000", true);
		cs.addChild(gTheta);
		gTheta.visible = false;
		
		// アニメ中フラグ
		animeFlag = false;
		
		// ドラッグ中フラグ
		dFlag = true;
		
		//表示
		dispFlag = true;
		
		// 弧度法・度数法の切り替え
		document.getElementById("methodText").innerHTML = "弧度法";
		
		$(".lineText").focus(function(){$(this).blur();});
		
		$(".configText").css("display", "inline-block");
		$(".configText").css("width", "40px");
		
		//数式変更の初期設定
		initDropBalloon(0, true, 3, true, 0);
		
		//設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [90, 1];
		configArray[2] = [null, null];
		
		setGraphConfig(true);
		
		
		//ドラッグの点の位置
		dragPoint.x = circleRad * Math.cos(0);
		dragPoint.y = circleRad * Math.sin(0);
		
		//-------------
		// リスナー設定
		//-------------
		// オプション画面
//		document.getElementById("controlBlock").addEventListener("scroll", closeInnerBalloonHandler);
//		document.getElementById("menuClose").addEventListener("click", closeInnerBalloonHandler);
		// 弧度法・度数法の切り替え
		document.getElementById("methodText").addEventListener("click", changeMethodHandler);
		// キャンバスのドラッグ
		cs.addEventListener("mousedown", canvasDragStart);
		// チェックボックス
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		// θの値変更ボタン
		document.getElementById("upDataBtn").addEventListener('click', changeDataHandler);
		document.getElementById("downDataBtn").addEventListener('click', changeDataHandler);
		// リセットボタン
		document.getElementById("resetBtn").addEventListener('click', resetHandler);
		// 式の設定画面
		document.getElementById("optionBtn0").addEventListener("click", openOptionHandler);
		
		//　値を加えた範囲の表示
		document.getElementById("optionBtn1").addEventListener("click", dspfomula2Handler);
		
		//　グラフとy=1/2の交点の角度の表示
		document.getElementById("optionBtn2").addEventListener("click", crossPointRadiusDisplay);
		
		
		// 操作卓のドラッグ
		dragPoint.addEventListener("mousedown", pointDragStart);
		
		//数式の変更(イベントの関数はdropBalloon.jsに記述)
		document.getElementById("fPart0").addEventListener("click", openDropBalloonHandler);
		document.getElementById("fPart1").addEventListener("click", changeOperatorHandler);
		document.getElementById("fPart2").addEventListener("click", openDropBalloonHandler);
		document.getElementById("fPart3").addEventListener("click", changeOperatorHandler);
		document.getElementById("fPart4").addEventListener("click", openDropBalloonHandler);
		
		document.getElementById("okBtn").addEventListener("click", changeFormulaDataHandler);
		
		$("#captureBtn").css("display", "none");
		$("#removeBtn").css("display", "none");
		
		$("#formula1").css("display", "block");
		
		$("#result2").css("display", "none");
		
		//-------------
		// 図形初期表示
		//-------------
		// 操作卓の円描画
		draw_Circle();
		
		// グラフ描画
		drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true );
		
		setRadiusNumber(document.getElementById("theta"), slider.prev);
		
		changeDotRed();
		
		crossText = [];
		
		//dragPointの位置修正と表示切替
		changeDragPointPosition();
		changeDragPointDisplay();
			
		// ドットの描画
		changeAxisPositionHandler();
		
		changeCircleGraph();
		
		changeCrossPoint();
		
		changeDotLine();
		
		timer = setTimeout(function()
			{
				$("#graphCanvas").css("left", -cW/2+120);
				$("#graphCanvas").css("top", -cH/2-40);
				
				nScale = 1.0;
				changeScaleHandler(1.0);
				
				changeAxisPositionHandler();
				
				changeAreaFormula();
				changeAddAreaFormula();
				changeYFormula();
				
				clearTimeout(timer);
			}, 1000);
		
		setModal('spanChange');
		setMenuMode(2, 220);
		
		// ステージ更新
		slider.ss.update();
		cs.update();
		
		setModal("formConfig");
		
		
		// バージョンチェック
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function changeUnitDotLineText()
{
	try
	{
		var op = formArray[3];
		var num = formArray[4];
		
		//op = false;
		//num = 1;
		
		var sp0 = unitTxt.getChildByName("sp0");
		var sp1 = unitTxt.getChildByName("sp1");
		var t0 = unitTxt.getChildByName("ut0");
		var t1 = unitTxt.getChildByName("ut1");
		var t2 = unitTxt.getChildByName("ut2");
		
		sp1.graphics.clear();
		sp1.graphics.setStrokeStyle(1);
		sp1.graphics.beginStroke("#000000");
		
		//1, -1の場合は単位円上のテキストがあるのでそちらでテキスト表示
		
		switch(num)
		{
			// 1/2
			case 0:
				t1.text = "1";
				t2.text = "2";
				sp0.visible = false;
				break;
			
			// 1/√3
			case 1:
				t1.text = "1";
				t2.text = "3";
				sp0.visible = true;
				break;
			
			// 1/√2
			case 2:
				t1.text = "1";
				t2.text = "2";
				sp0.visible = true;
				break;
			
			// √3/2
			case 3:
				t1.text = "3";
				t2.text = "2";
				sp0.visible = true;
				break;
			
			// 1
			case 4:
				t1.text = "";
				t2.text = "";
				sp0.visible = false;
				break;
			
			// √3
			case 5:
				t1.text = "3";
				t2.text = "";
				sp0.visible = true;
				break;
		}
		
		//数値・記号のyの位置と描画
		//分数でない場合
		if(num == 4 || num == 5)
		{
			t1.y = -8;
			t2.y = -8;
			
			if(num == 5)
			{
				sp0.y = 8;
			}
		}
		//分数の場合
		else
		{
			 if(num == 0)
			 {
				sp1.graphics.moveTo(0, 0);
				sp1.graphics.lineTo(14, 0);
			}
			else if(num == 1 || num == 2 || num == 3)
			{
				sp1.graphics.moveTo(0, 0);
				sp1.graphics.lineTo(26, 0);
			}
			
			t1.y = -17;
			
			//分母が平方根の場合
			if(num == 1 || num == 2)
			{
				t2.y = 4;
				sp0.y = 21;
			}
			else
			{
				t2.y = 1;
				sp0.y = 0;
			}
		}
		
		sp1.graphics.endStroke();
		
		t1.x = -5;
		t2.x = -5;
		
		//テキスト・符号・平方根などの記号の位置
		if(op || num == 4)
		{
			t0.text = "";
		}
		else
		{
			t0.text = "-";
			
			t0.y = -8;
			
			// 分数
			if(num == 0)
			{
				t0.x = -18;
			}
			//平方根のある分数
			else if(num == 1 || num == 2 || num == 3)
			{
				t0.x = -26;
			}
			//　√3
			else
			{
				t0.x = -28;
			}
		}
		
		//分数
		if(num == 0)
		{
			sp1.x = -7;
		}
		//平方根のある分数
		else if(num == 1 || num == 2 || num == 3 || num == 5)
		{
			sp0.x = -8;
			sp1.x = -16;
		}
		
		if(!$("#check2").prop("checked"))
		{
			unitTxt.visible = false;
		}
		else
		{
			unitTxt.visible = true;
			
			var yData = resultArray[formArray[4]];
		
			if(formArray[3] == false)
			{
				yData = -yData;
			}
			
			//単位円のxの位置
			//cosの場合
			if(formArray[0] == 1)
			{
				var px = circleRad * yData;
				
				unitTxt.x = px;
				
				//回転
				if($("#check3").prop("checked"))
				{
					unitTxt.rotation = 90;
					
					if(num == 0 || num == 1 || num == 2)
					{
						unitTxt.x = px-18;
					}
					else if(num == 3)
					{
						unitTxt.x = px-26;
					}
					else
					{
						unitTxt.x = px-14;
					}

					if(op)
					{
						if(num == 0)
						{
							unitTxt.y = 10;
						}
						else
						{
							unitTxt.y = 22;
						}
					}
					else
					{
						if(num == 0)
						{
							unitTxt.y = 20;
						}
						else
						{
							unitTxt.y = 32;
						}
					}
				}
				else
				{
					unitTxt.rotation = 0;
					
					if(num == 0 || num == 1 || num == 2)
					{
						unitTxt.y = 20;
					}
					else if(num == 3)
					{
						unitTxt.y = 26;
					}
					else
					{
						unitTxt.y = 14;
					}
					
					if(num == 0 || num == 1 || num == 2 || num == 3)
					{
						unitTxt.x = px-18;
					}
					else
					{
						unitTxt.x = px-14;
					}
					
				}
			}
			else
			{
				unitTxt.rotation = 0;
				
				var py = -circleRad * yData;
				
				if(num == 0 || num == 1 || num == 2)
				{
					unitTxt.y = py+18;
				}
				else if(num == 3)
				{
					unitTxt.y = py+26;
				}
				else
				{
					unitTxt.y = py+14;
				}
				
				if(op)
				{
					if(num == 0)
					{
						unitTxt.x = 10;
					}
					else
					{
						unitTxt.x = 22;
					}
				}
				else
				{
					if(num == 0)
					{
						unitTxt.x = 20;
					}
					else
					{
						unitTxt.x = 32;
					}
				}
			}
		}
	}
	catch(e)
	{
		alert("changeUnitDotLineText:" + e.toString());
	}
}

function createUnitText(str, size, color, f)
{
	var c = new createjs.Container();
	var inner = new createjs.Container();
	inner.name = "inner";
	c.addChild(inner);
	var t;
	
	if(f)
	{
		t = new createjs.Text(str, "Italic "+size+"px Times New Roman", color);
	}
	else
	{
		t = new createjs.Text(str, size+"px Times New Roman", color);
	}
	
	inner.addChild(t);
	t.x = -t.getBounds().width/2;
	t.y = -t.getBounds().height/2;
	
	return c;
}


function changeUnitText()
{
	try
	{
		tx0.x = span * 1.9;
		tx0.y = 13;
		
		tx1.x = span + 9;
		tx1.y = 9;
		
		tx2.x = -span + -9;
		tx2.y = 9;
		
		
		ty0.x = 13;
		ty0.y = -span * 1.9;
		
		ty1.x = 9;
		ty1.y = -span-9;
		
		ty2.x = 9;
		ty2.y = span+9;
		
		if(circleCont.rotation == 0)
		{
			tx0.getChildByName("inner").rotation = 0;
			tx1.getChildByName("inner").rotation = 0;
			tx2.getChildByName("inner").rotation = 0;
			ty0.getChildByName("inner").rotation = 0;
			ty1.getChildByName("inner").rotation = 0;
			ty2.getChildByName("inner").rotation = 0;
		}
		else
		{
			tx0.getChildByName("inner").rotation = 90;
			tx1.getChildByName("inner").rotation = 90;
			tx2.getChildByName("inner").rotation = 90;
			ty0.getChildByName("inner").rotation = 90;
			ty1.getChildByName("inner").rotation = 90;
			ty2.getChildByName("inner").rotation = 90;
		}
	}
	catch(e)
	{
		alert("changeUnitText:" + e.toString());
	}
}

//	+--------------------------+
//	| アニメ制御画面のオープン |
//	+--------------------------+
function setAnimeBalloonPosition()
{
	slider.openAnimeBalloon("theta");
	
	$("#animeBalloon").css("margin-left", 30);
	var pX = $("#animeTriangle").css("margin-left");
	pX = parseInt(pX.substring(0, pX.length-2));
	
	$("#animeTriangle").css("margin-left", (pX-33));
	
}

//	+----------------+
//	| アニメーション |
//	+----------------+
function changeAnimeGraph()
{
	changeMenuRadiusDisplay();
	changeDragPointPosition();
	changeDragPointDisplay();
	changeCircleGraph();
	
	changeDotRed();
	
	slider.ss.update();
	cs.update();
}

//	+----------------------+
//	| 円形操作パネルの描画 |
//	+----------------------+
function draw_Circle()
{
	try
	{
		circle.graphics.setStrokeStyle(1);
		circle.graphics.beginStroke('glay').drawCircle(0, 0, circleRad);
		circle.graphics.endStroke();
		// Ｙ軸
		circleAxisY.graphics.beginStroke('glay');
		circleAxisY.graphics.moveTo(0, -circleCenterH);
		circleAxisY.graphics.lineTo(0, circleCenterH);
		circleAxisY.graphics.endStroke();
		circleAxisY.graphics.beginFill('glay');
		circleAxisY.graphics.moveTo(0, -circleCenterH);
		circleAxisY.graphics.lineTo(-5, -circleCenterH+15);
		circleAxisY.graphics.lineTo(5, -circleCenterH+15);
		circleAxisY.graphics.lineTo(0, -circleCenterH);
		circleAxisY.graphics.endFill();
		// Ｘ軸
		circleAxisY.graphics.beginStroke('glay');
		circleAxisY.graphics.moveTo(-circleCenterH, 0);
		circleAxisY.graphics.lineTo(circleCenterH, 0);
		circleAxisY.graphics.endStroke();
		circleAxisY.graphics.beginFill('glay');
		circleAxisY.graphics.moveTo(circleCenterH, 0);
		circleAxisY.graphics.lineTo(circleCenterH-15, -5);
		circleAxisY.graphics.lineTo(circleCenterH-15, 5);
		circleAxisY.graphics.lineTo(circleCenterH, 0);
		circleAxisY.graphics.endFill();
	}
	catch(e)
	{
		alert("draw_Circle:" + e.toString());
	}
}
		
//	+-----------------+
//	| １/２の破線表示 |
//	+-----------------+
function changeDotLine()
{
	try
	{
		dotLine.graphics.clear();
		dotLine.graphics.setStrokeStyle(1);
		dotLine.graphics.setStrokeDash([5, 5], 0);
		dotLine.graphics.beginStroke("#888888");
		
		var fData = [1/2, 1/Math.sqrt(3), 1/Math.sqrt(2), Math.sqrt(3)/2, 1, Math.sqrt(3)];
		
		var yData = fData[formArray[4]];
		
		if(formArray[3] == false)
		{
			yData = -yData;
		}
		
		var py = -circleRad * yData;
		
		//cosのグラフ表示の場合
		if(formArray[0] == 1 && $("#check2").prop("checked") && !$("#check3").prop("checked"))
		{
			dotLine.graphics.moveTo((circleCenterX-cW/2) - py, -cH/2);
			dotLine.graphics.lineTo((circleCenterX-cW/2) - py, cH/2);
			dotLine.graphics.endStroke();
		}
		//それ以外
		else
		{
			dotLine.graphics.moveTo( -cW/2, py );
			dotLine.graphics.lineTo(  cW/2, py );
			dotLine.graphics.endStroke();
		}
		
		changeUnitDotLineText();
	}
	catch(e)
	{
		alert("changeDotLine:" + e.toString());
	}
}

//	+------------+
//	| グラフ描画 |
//	+------------+
function drawTriangleLine(line, color, cycle, min, max, clear)
{
	try
	{
		if ( clear )	{	line.graphics.clear();	}
		
		if ( line.visible )
		{
			line.graphics.setStrokeStyle(1);
			line.graphics.beginStroke(color);
			
			var adj = Math.PI * formDataArray[1][formArray[2]]/180;
			
			if(formArray[1] == false)
			{
				adj = -adj;
			}
			
			line.graphics.setStrokeDash([5,5], 0);
			
			//タンジェントで正負の入替判別
			var prevY;
			
			var pY;
			
			//サイン
			if(formArray[0] == 0)
			{
				pY = -Math.sin( Math.PI * 2 * ( ( min % cycle ) / cycle ) + adj ) * circleRad;
			}
			//コサイン
			else if(formArray[0] == 1)
			{
				pY = -Math.cos( Math.PI * 2 * ( ( min % cycle ) / cycle ) + adj ) * circleRad;
			}
			//タンジェント
			else
			{
				pY = -Math.tan( Math.PI * 2 * ( ( min % cycle ) / cycle ) + adj ) * circleRad;
				prevY = pY;
			}
			
			line.graphics.moveTo( min, pY );
			
			for ( var m = min+1; m<=max; m++ )
			{
				if ( Math.round(m) == 0 )
				{
					line.graphics.setStrokeDash( [], 0);
				}
				if ( Math.round(m) == baseCycle )
				{
					line.graphics.setStrokeDash( [5,5], 0);
				}
				
				//サイン
				if(formArray[0] == 0)
				{
					pY = -Math.sin( Math.PI * 2 * ( (   m % cycle ) / cycle ) + adj ) * circleRad;
				}
				//コサイン
				else if(formArray[0] == 1)
				{
					pY = -Math.cos( Math.PI * 2 * ( (   m % cycle ) / cycle ) + adj ) * circleRad;
				}
				//タンジェント
				else
				{
					pY = -Math.tan( Math.PI * 2 * ( (   m % cycle ) / cycle ) + adj ) * circleRad;
				}
				
				//サイン・コサインの場合
				if(formArray[0] <= 1)
				{
					line.graphics.lineTo( m, pY );
				}
				//タンジェントの場合
				else
				{
					//前の点との間隔が極めて大きな値となった場合は符号の入れ替わりと判別
					if(Math.abs(pY-prevY) > 1000)
					{
						line.graphics.moveTo( m, pY );
					}
					else
					{
						line.graphics.lineTo( m, pY );
					}
					
					prevY = pY;
				}
				
			}
			
			line.graphics.endStroke();
		}
	}
	catch(e)
	{
		alert("drawTriangleLine:" + e.toString());
	}
}

//	+------------------------+
//	| チェックボタン変更処理 |
//	+------------------------+
function changeCheckHandler(e)
{
	try
	{
		switch ( e.currentTarget.id )
		{
			case "check1":
				changeCircleGraph();
				break;
			
			case "check2":
				dotLine.visible = document.getElementById("check2").checked;
				changeDragPointDisplay();
				changeDotPointLine();
				changeDotLine();
				break;
			
			case "check3":
				line0.visible = document.getElementById("check3").checked;
				drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true );
				changeMenuRadiusDisplay();
				changeCrossPoint();
				changeCircleGraph();
				changeDotRed();
				changeDotLine();
				
				changeYFormula();
				break;
		}
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

// 式の入力ボタン押された
function openOptionHandler(e)
{
	try
	{
		setFormData();
		showModal("formConfig");
	}
	catch(e)
	{
		alert('openOptionHandler:' + e.toString());
	}
}

function changeFormulaDataHandler(e)
{
	try
	{
		//ポップアップ内の吹き出しを隠す
		$("#dropBalloon").css("display", "none");
		
		//データを設定
		formArray = prevArray.slice();
		
		//最上段の式変形
		changeFormula();
		
		//グラフの変更
		drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true);
		
		//yの式変形
		changeYFormula();
		
		//値を加えた範囲の表示変更
		changeAddAreaFormula();
		
		changeDragPointPosition();
		changeCircleGraph();
		changeCrossPoint();
		
		changeDotLine();
		changeDragPointDisplay();
		changeDotRed();
		
		//ポップアップを閉じる
		closeModal("formConfig");
		
		cs.update();
	}
	catch(e)
	{
		alert("changeFormulaDataHandler:" + e.toString());
	}
}

function changeFormula()
{
	try
	{
		var str = "";
		str += formDataArray[0][formArray[0]];
		
		if(formArray[2] == 0)
		{
			str += "\\theta=";
		}
		else
		{
			str += "(\\theta";
			
			if(formArray[1])
			{
				str += "+";
			}
			else
			{
				str += "-";
			}
			
			var r;
			
			if($("#methodText").html() == "弧度法")
			{
				r = getRadiusTex(formDataArray[1][formArray[2]], true);
			}
			else
			{
				r = getRadiusTex(formDataArray[1][formArray[2]], false);
			}
			
			str += r+")=";
		}
		
		if(formArray[3] == false)
		{
			str += "-"
		}
		
		str += formDataArray[2][formArray[4]];
		
		//str = "\\Large{" + str + "}";
		
		//メニューの数式変更
		changeMathJax("label0", str, false);
	}
	catch(e)
	{
		alert("changeFormula:" + e.toString());
	}
}

function changeAreaFormula()
{
	try
	{
		var f=false;
		if($("#methodText").html() == "弧度法")
		{
			f = true;
		}
		
		var minStr = getRadiusTex(0, f);
		var maxStr = getRadiusTex(360, f);
		
		var str = minStr + "≦\\theta＜"+maxStr;
		
		changeMathJax("formula0", str, false);
	}
	catch(e)
	{
		alert("changeAreaFormula:"+e.toString());
	}
}

function changeAddAreaFormula()
{
	try
	{
		var f=false;
		if($("#methodText").html() == "弧度法")
		{
			f = true;
		}
		
		var addNum = formDataArray[1][formArray[2]];
		var addStr = getRadiusTex(addNum, f);

		if(formArray[1])
		{
			addStr = "+" + addStr;
		}
		else
		{
			addStr = "-" + addStr;
		}

		minStr = getRadiusTex(0+addNum, f);
		maxStr = getRadiusTex(360+addNum, f);

		str = minStr + "≦\\theta" + addStr + "<" + maxStr;

		changeMathJax("formula1", str, false);
	}
	catch(e)
	{
		alert("changeAddAreaFormula:" + e.toString());
	}
}

function changeYFormula()
{
	try
	{
		var str;
		
		if(formArray[0] == 1 && !$("#check3").prop("checked"))
		{
			str = "x=";
		}
		else
		{
			str	= "y=";
		}
		
		if(!formArray[3])
		{
			str += "-";
		}
		
		var num;
		
		switch(formArray[4])
		{
			case 0:
				num = "\\frac{1}{2}";
				break;
			case 1:
				num = "\\frac{1}{\\sqrt{3}}";
				break;
			case 2:
				num = "\\frac{1}{\\sqrt{2}}";
				break;
			case 3:
				num = "\\frac{\\sqrt{3}}{2}";
				break;
			case 4:
				num = "1";
				break;
			case 5:
				num = "\\sqrt{3}";
				break;
		}
		
		str = str + num;
		
		changeMathJax("formula2", str, false);
	}
	catch(e)
	{
		alert("changeYFormula:" + e.toString());
	}
}

//	+------------------------+
//	| 範囲のオプションボタン |
//	+------------------------+
function dspfomula2Handler(e)
{
	try
	{
		dispFlag = !dispFlag;
		
		if(!dispFlag)
		{
			$("#formula1").css("display", "none");
		}
		else
		{
			$("#formula1").css("display", "block");
			
			changeAreaFormula();
		}
		
		slider.changeAnimeRadiusDisplay();
		changeMenuRadiusDisplay();
		
		
		changeDragPointPosition();
		changeDragPointDisplay();
		
		changeCircleGraph();
		
		slider.ss.update();
		cs.update();
	}
	catch(e)
	{
		alert('dspfomula2Handler:' + e.toString());
	}
}

//	+------------------------+
//	| 刻み幅入力画面オープン |
//	+------------------------+
function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		if ( e.currentTarget.id == "stepText" )
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize);
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}

//	+--------------+
//	| 刻み幅の変更 |
//	+--------------+
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}

//	+------------+
//	| θ値の変更 |
//	+------------+
function changeDataHandler(e)
{
	try
	{
		var str;
		var f = false;
		var pIndex = radArray.indexOf(slider.prev);
		var minIndex = radArray.indexOf(defMin);
		var maxIndex = radArray.indexOf(defMax);
		
		switch( e.currentTarget.id )
		{
			case "upDataBtn":
				if ( pIndex < maxIndex )
				{
					if ( radArray[pIndex+1] <= slider.max )
					{
						pIndex++;
						f = true
					}
				}
				break;
			
			case "downDataBtn":
				if ( pIndex > minIndex )
				{
					if ( radArray[pIndex-1] >= slider.min )
					{
						pIndex--;
						f = true
					}
				}
				break;
		}
		
		
		if ( f )
		{
			slider.prev = radArray[pIndex];
			slider.changeSliderPoint();
			
			changeMenuRadiusDisplay();
			
			changeDragPointPosition();
			changeCircleGraph();
			
			changeDragPointDisplay();
			changeDotRed();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeDataHandler:" + e.toString());
	}
}

//	+----------------------+
//	| θ値の変更に伴う表示 |
//	+----------------------+
function changeMenuRadiusDisplay()
{
	try
	{
		//範囲の表示
		changeAreaFormula();
		changeAddAreaFormula();
		
		//θの表示
		setRadiusNumber(document.getElementById("theta"), slider.prev);
		
		//アニメバルーンの数値の表示
		setRadiusNumber(document.getElementById("tMin"), slider.min);
		setRadiusNumber(document.getElementById("tMax"), slider.max);
	}
	catch(e)
	{
		alert("changeMenuRadiusDisplay:" + e.toString());
	}
}

//	+------------------------------------+
//	| キャンバスに表示するテキストの編集 |
//	+------------------------------------+
function editPointText(c, str)
{
	try
	{
		// 子供を削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		// 弧度法
		if(str.indexOf("π") != -1)
		{
			// 頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length-1), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str.substring(0, str.length-1), "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
				
				c.addChild(t0_1);
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("editPointText:" + str + "-" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
function captureData()
{
	try
	{
		createCaptureLine(slider.prev);
		
		cs.update();
	}
	catch(e)
	{
		alert("captureData:" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
function createCaptureLine(n)
{
	try
	{
		var s = new createjs.Shape();
		s.name = "s" + recData.length;
		
		s.x = cW/2;
		s.y = cH/2;
		
//		drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true );
		
		s.alpha = 0.25;
		
		recCont.addChild(s);
		
		recData.push(n);
	}
	catch(e)
	{
		alert("createCaptureLine:" + e.toString());
	}
		
}

//	+--------------+
//	|  |
//	+--------------+
function resetCapture()
{
	try
	{
		var leng = recData.length;
		
		//オブジェクトを削除
		recCont.removeAllChildren();
		
		//データの削除
		recData = [];
		
		cs.update();
	}
	catch(e)
	{
		alert("resetCapture:" + e.toString());
	}
}


//	+--------------+
//	|  |
//	+--------------+
/*	=====================================================================
function closeModalHandler(e)
{
	try
	{
		//オプションを閉じる
		if(e.target.id == "optionClose" || e.target.id == "optionCancel")
		{
			
			closeModal();
		}
		//きざみ幅を閉じる
		else
		{
			showModal('optionBlock');
		}
	}
	catch(e)
	{
		alert('closeModalHandler:' + e.toString());
	}
}
*/

//	+--------------+
//	|  |
//	+--------------+
/*	=====================================================================
function openAnimeBalloonHandler(e)
{
	try
	{
		slider.openAnimeBalloon(e.target.id);
	}
	catch(e)
	{
		alert("openAnimeBalloonHandler:" + e.toString());
	}
}
*/

//	+------------------------+
//	| オプション画面を閉じる |
//	+------------------------+
function closeInnerBalloonHandler(e)
{
	try
	{
		if(document.getElementById("selectBalloon_menu").style.display != "none")
		{
			closeSelectBalloon();
		}
	}
	catch(e)
	{
		alert("closeInnerBalloonHandler:" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
/*	=====================================================================
function setSpanHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert('setSpanHandler:' + e.toString());
	}
}
*/

//	+--------------+
//	|  |
//	+--------------+
/*	=====================================================================
function spanNumberChangeHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert('spanNumberChangeHandler:' + e.toString());
	}
}
*/

//	+--------------+
//	|  |
//	+--------------+
/*	=====================================================================
function changeModeHandler(e)
{
	try
	{
		
	}
	catch(e)
	{
		alert("changeModeHandler:" + e.toString());
	}
}
*/

//	+--------------+
//	|  |
//	+--------------+
function drawGridHandler()
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		var gSpan;
		
		
		grid.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawGridHandler:" + e.toString());
	}
}

//	+--------------------------+
//	| キャンバスのドラッグ開始 |
//	+--------------------------+
function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

//	+------------------+
//  | キャンバスの移動 |
//	+------------------+
function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		//座標の変化量
		var sX;
		var sY;
		
		if(cScale >= 1)
		{
			sX = e.stageX - prevX;
			sY = e.stageY - prevY;
		}
		else
		{
			sX = (e.stageX - prevX) * cScale;
			sY = (e.stageY - prevY) * cScale;
		}
		
		//移動限界
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}		
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function dragStop(e)
{
	try
	{
		if(ictMode)
		{
			$(window).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}

//	+----------+
//	| 軸の表示 |
//	+----------+
function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		/*
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		*/
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}


//	+----------------------------+
//	| 操作卓のバー・ドラッグ開始 |
//	+----------------------------+
function pointDragStart(e)
{
	try
	{
		if ( dFlag && animeFlag == false )
		{
			dFlag = false;
			animeFlag = true;
			prevX = e.stageX;
			prevY = e.stageY;
			e.currentTarget.addEventListener("pressmove", pointDragMove);
			e.currentTarget.addEventListener("pressup", pointDragStop);
			e.currentTarget.addEventListener("mouseup", pointDragStop);
			e.currentTarget.addEventListener("mouseout", pointDragStop);
			cs.update();
		}
	}
	catch(e)
	{
		alert("pointDragStart:" + e.toString());
	}
}

//	+------------------------+
//	| 操作卓のバー・ドラッグ |
//	+------------------------+
function pointDragMove(e)
{
	try
	{
		var rad;
		
		var f = true;
		
		//
		if($("#check3").prop("checked") && formArray[0] == 1)
		{
			f = false;
		}
		
		var p = circleCont.globalToLocal(e.stageX, e.stageY);
		
		var rad = Math.atan2(p.y, p.x);
		
		rad = -rad * 180/Math.PI;
		
		var addNum = addRad[formArray[2]];
		
		if(formArray[1] == false)
		{
			addNum = -addNum;
		}
		
		if(dispFlag)
		{
			rad -= addNum;
		}
		
		if(rad >= 0 && rad <= 7.5)
		{
			rad = 0;
		}
		else if((rad < 0 && rad >= -7.5) || rad >= 352.5)
		{
			rad = 360;
		}
		else
		{
			rad = Math.round(rad/15) * 15;
			
			if(rad < 0)
			{
				rad = 360+rad;
			}
		}
		
		if(rad < slider.min)
		{
			rad = slider.min;
		}
		else if(rad > slider.max)
		{
			rad = slider.max;
		}
		
		if(rad != slider.prev)
		{
			if(dispFlag)
			{
				dragPoint.x = circleRad * Math.cos((rad+addNum)*Math.PI/180);
				dragPoint.y = -circleRad * Math.sin((rad+addNum)*Math.PI/180);
			}
			else
			{
				dragPoint.x = circleRad * Math.cos(rad*Math.PI/180);
				dragPoint.y = -circleRad * Math.sin(rad*Math.PI/180);
			}
			
			slider.prev = rad;
			
			slider.changeSliderControl();
			
			changeDragPointDisplay();
			
			changeCircleGraph();
			setRadiusNumber(document.getElementById("theta"), slider.prev);
			
			changeDotRed();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("pointDragMove:" + e.toString());
	}
}

function changeDragPointPosition()
{
	try
	{
		var r = slider.prev;
		
		if(dispFlag)
		{
			if(formArray[1])
			{
				r += addRad[formArray[2]];
			}
			else
			{
				r -= addRad[formArray[2]];
			}
		}
		
		r = r * Math.PI/180;
		
		dragPoint.x = circleRad * Math.cos(r);
		dragPoint.y = -circleRad * Math.sin(r);
	}
	catch(e)
	{
		alert("changeDragPointPosition:" + e.toString());
	}
}

function changeDragPointDisplay()
{
	try
	{
		var f0=false;
		var f1=false;
		
		var yData = resultArray[formArray[4]];
		
		if(formArray[3] == false)
		{
			yData = -yData;
		}
		
		if($("#check2").prop("checked"))
		{
			var px = circleCont.x+circleRad * yData;
			var py = cH/2-circleRad * yData;

			var dPnt = circleCont.localToGlobal(dragPoint.x, dragPoint.y);

			dx = dPnt.x;
			dy = dPnt.y;

			px = Math.round(px * 10000)/10000;
			py = Math.round(py * 10000)/10000;
			dx = Math.round(dx * 10000)/10000;
			dy = Math.round(dy * 10000)/10000;
			
			//サイン，コサインの場合
			if(formArray[0] != 2)
			{
				if(formArray[0] == 1 && !$("#check3").prop("checked"))
				{
					if(px == dx)
					{
						f0 = true;
					}
				}
				else if(py == dy)
				{
					f0 = true;
				}
			}
			else
			{
				if($("#check2").prop("checked"))
				{
					yData = Math.round(yData * 10000);
					
					var rad = slider.prev;
					
					if(formArray[1])
					{
						rad += formDataArray[1][formArray[2]];
					}
					else
					{
						rad -= formDataArray[1][formArray[2]];
					}
					
					tData = Math.round(Math.tan(rad * Math.PI/180) * 10000);
					
					if(yData == tData)
					{
						f0 = true;
					}
				}
			}
		}
		
		//dragPointの色を変更
		dragPoint.graphics.clear();
		dragPoint.graphics.setStrokeStyle(0);
		
		dotRed.graphics.clear();
		dotRed.graphics.setStrokeStyle(0);
		
		if(f0 && slider.prev < 360)
		{
			dragPoint.graphics.beginStroke("#FF0000");
			dragPoint.graphics.beginFill("#FF0000");
		}
		else
		{
			dragPoint.graphics.beginStroke("#007AC5");
			dragPoint.graphics.beginFill("#007AC5");
		}
		
		dragPoint.graphics.drawCircle(0, 0, 5);
		dragPoint.graphics.endFill();
		dragPoint.graphics.beginStroke("rgba(255, 255, 255, 0.02)");
		dragPoint.graphics.beginFill("rgba(255, 255, 255, 0.02)");
		dragPoint.graphics.drawCircle(0, 0, 15);
		dragPoint.graphics.endFill();
		dragPoint.graphics.endStroke();
	}
	catch(e)
	{
		alert("changeDragPoint:" + e.toString());
	}
}

function changeCircleGraph()
{
	try
	{
		circleGraph.graphics.clear();
		circleGraph.graphics.setStrokeStyle(2);
		circleGraph.graphics.beginStroke("#007AC5");
		
		//追加角度
		var addR = addRad[formArray[2]] * Math.PI/180;
		
		if(formArray[0] == 2)
		{
			tanLine.visible = true;
		}
		else
		{
			tanLine.visible = false;
		}
		
		if(formArray[1] == false)
		{
			addR = -addR;
		}
		
		
		//角度追加状態の場合
		if(dispFlag)
		{
			var addX = circleRad * Math.cos(addR);
			var addY = -circleRad * Math.sin(addR);
			circleGraph.graphics.moveTo(0, 0);
			circleGraph.graphics.lineTo(addX, addY);
		}
		
		//原点からdragPointまでの線
		circleGraph.graphics.moveTo(0, 0);
		circleGraph.graphics.lineTo(dragPoint.x, dragPoint.y);
		circleGraph.graphics.endStroke();
		
		if($("#check1").prop("checked"))
		{
			var leng = 20;

			circleGraph.graphics.setStrokeStyle(0);
			circleGraph.graphics.beginStroke("rgba(0, 122, 197, 0)");
			circleGraph.graphics.beginFill("rgba(0, 122, 197, 0.25)");
			circleGraph.graphics.moveTo(0, 0);

			var p;
			var r2;

			//範囲の表示
			if(dispFlag)
			{
				if(formArray[1])
				{
					circleGraph.graphics.arc(0, 0, leng, -addR, -((slider.prev*Math.PI/180)+addR), true);
					r2 = (slider.prev*Math.PI/180)/2+addR;
				}
				else
				{
					circleGraph.graphics.arc(0, 0, leng, -addR, -((slider.prev*Math.PI/180)+addR), true);
					r2 = (slider.prev*Math.PI/180)/2+addR;
				}
			}
			else
			{
				circleGraph.graphics.arc(0, 0, leng, 0, -slider.prev*Math.PI/180, true);
				r2 = (slider.prev*Math.PI/180)/2;
			}

			circleGraph.graphics.endFill();
			circleGraph.graphics.endStroke();
			
			thetaTxt.visible = true;
		}
		else
		{
			thetaTxt.visible = false;
		}
		
		//cosの式でグラフを表示している場合
		if(formArray[0] == 1 && $("#check3").prop("checked"))
		{
			circleCont.rotation = -90;
		}
		else
		{
			circleCont.rotation = 0;
		}
		
		changeUnitText();
		
		p = circleCont.localToGlobal(leng*1.5*Math.cos(r2), -leng*1.5*Math.sin(r2));

		thetaTxt.x = p.x;
		thetaTxt.y = p.y;
	}
	catch(e)
	{
		alert("chnageCircleGraph:" + e.toString());
	}
}

function changeDotPointLine()
{
	try
	{
		dotLine2.graphics.clear();
		
		if($("#check3").prop("checked"))
		{
			var pArray=[];
			
			if(formArray[0] == 2)
			{
				var rad = slider.prev
		
				if(formArray[1])
				{
					rad += addRad[formArray[2]];
				}
				else
				{
					rad -= addRad[formArray[2]];
				}

				if(rad == 90 || rad == 270)
				{
					return;
				}
			}
			
			if(formArray[0] <= 1)
			{
				pArray[0] = circleCont.localToGlobal(dragPoint.x, dragPoint.y);
				pArray[1] = {x:dotRed.x, y:dotRed.y};
				pArray[2] = {x:dotRed.x, y:cH/2};
			}
			else
			{
				pArray[0] = circleCont.localToGlobal(dragPoint.x, dragPoint.y);
				pArray[1] = {x:circleCont.x+circleRad, y:dotRed.y};
				pArray[2] = {x:dotRed.x, y:dotRed.y};
				pArray[3] = {x:dotRed.x, y:cH/2};
			}


			dotLine2.graphics.setStrokeStyle(1);
			dotLine2.graphics.setStrokeDash([5, 5], 0);
			dotLine2.graphics.beginStroke("#888888");

			j = pArray.length;
			for(var i=0; i<j; i++)
			{
				if(i == 0)
				{
					dotLine2.graphics.moveTo(pArray[i].x, pArray[i].y);
				}
				else
				{
					dotLine2.graphics.lineTo(pArray[i].x, pArray[i].y);
				}
			}
			
			dotLine2.graphics.endStroke();
		}
		//タンジェントの場合
		else if(formArray[0] == 2)
		{
			dotLine2.graphics.setStrokeStyle(1);
			dotLine2.graphics.setStrokeDash([5, 5], 0);
			dotLine2.graphics.beginStroke("#888888");
			
			var rad = slider.prev
		
			if(formArray[1])
			{
				rad += addRad[formArray[2]];
			}
			else
			{
				rad -= addRad[formArray[2]];
			}
			
			if(rad == 90 || rad == 270)
			{
				return;
			}
			
			rad = rad * Math.PI/180;
			
			var pt0 = circleCont.localToGlobal(dragPoint.x, dragPoint.y);
			var pt1 = {x:circleCont.x+circleRad, y:cH/2-Math.tan(rad) * circleRad};
			
			dotLine2.graphics.moveTo(pt0.x, pt0.y);
			dotLine2.graphics.lineTo(pt1.x, pt1.y);
			
			dotLine2.graphics.endStroke();
		}
	}
	catch(e)
	{
		alert("changeDotPointLine:" + e.toString());
	}
}

function changeDotRed()
{
	try
	{
		var ansX = 0;
		var ansY = 0;
		
		var rad = slider.prev
		
		if(formArray[1])
		{
			rad += addRad[formArray[2]];
		}
		else
		{
			rad -= addRad[formArray[2]];
		}
		
		rad = rad * Math.PI/180;
		
		switch(formArray[0])
		{
			case 0:
				ansY = cH/2-Math.sin(rad) * circleRad;
				break;
			case 1:
				ansY = cH/2-Math.cos(rad) * circleRad;
				break;
			case 2:
				ansY = cH/2-Math.tan(rad) * circleRad;
				break;
		}
		
		ansX += (slider.prev/360) * baseCycle;
		
		//グラフの基準に合わせる
		ansX += cW/2;
		
		//左の表示限界
		if(ansX >= cW/2-leftLimit)
		{
			//グラフ表示時
			if($("#check3").prop("checked"))
			{
				dotRed.visible = true;
				gTheta.visible = true;
			}
			else
			{
				dotRed.visible = false;
				gTheta.visible = false;
			}
		}
		else
		{
			dotRed.visible = false;
			gTheta.visible = false;
		}
		
		if(dotRed.visible)
		{
			dotRed.x = ansX;
			dotRed.y = ansY;
			
			gTheta.x = dotRed.x;
			gTheta.y = cH/2 + 12;
			
			
			var yData = resultArray[formArray[4]];
		
			if(formArray[3] == false)
			{
				yData = -yData;
			}

			var py = Math.round(cH/2-circleRad * yData);
		
			var ry = Math.round(dotRed.y);
			
			dotRed.graphics.clear();
			dotRed.graphics.setStrokeStyle(0);
			
			if($("#check1").prop("checked") && $("#check2").prop("checked") && py == ry && slider.prev < 360)
			{
				dotRed.graphics.beginStroke("#FF0000");
				dotRed.graphics.beginFill("#FF0000");
			}
			else
			{
				dotRed.graphics.beginStroke("#007AC5");
				dotRed.graphics.beginFill("#007AC5");
			}

			dotRed.graphics.drawCircle(0, 0, 5);
			dotRed.graphics.endFill();
			dotRed.graphics.endStroke();
		}
		
		changeDotPointLine();
	}
	catch(e)
	{
		alert("changeDotRed:" + e.toString());
	}
}

//	+----------------------------+
//	| 操作卓のバー・ドラッグ終了 |
//	+----------------------------+
function pointDragStop(e)
{
	try
	{
		dFlag = true;
		animeFlag = false;
		
		e.currentTarget.removeEventListener("pressmove", pointDragMove);
		e.currentTarget.removeEventListener("pressup", pointDragStop);
		e.currentTarget.removeEventListener("mouseup", pointDragStop);
		e.currentTarget.removeEventListener("mouseout", pointDragStop);
		
		cs.update();
	}
	catch(e)
	{
		alert("pointDragStop:" + e.toString());
	}
}

function crossPointRadiusDisplay(e)
{
	try
	{
		if($("#result2").css("display") == "none")
		{
			$("#result2").css("display", "block");
			
		}
		else
		{
			$("#result2").css("display", "none");
		}
		
		changeCrossPoint();
		
		cs.update();
	}
	catch(e)
	{
		alert("crossPointRadiusDisplay:" + e.toString());
	}
}

function changeCrossPoint()
{
	try
	{
		var rArray = getCrossPointRadius();
		
		while(crossText.length > 0)
		{
			cs.removeChild(crossText[0]);
			crossText.shift();
		}
		
		var result = resultArray[formArray[4]];
		
		if(formArray[3] == false)
		{
			result = -result;
		}
		
		dotLine1.graphics.clear();
		dotLine1.graphics.setStrokeStyle(1);
		dotLine1.graphics.setStrokeDash([5, 5], 0);
		dotLine1.graphics.beginStroke("#888888");
		
		//交点の解答用の文字列
		var graphResult = "\\theta=";
		
		for(i=0; i<rArray.length; i++)
		{
			var tc = new createjs.Container();
			
			var str;
			
			if(i > 0)
			{
				graphResult += ",\\ ";
			}
			
			
			if($("#methodText").html() == "弧度法")
			{
				str = getPointDataString(rArray[i], 1);
				graphResult += getRadiusTex(rArray[i], true);
			}
			else
			{
				str = getPointDataString(rArray[i], 2);
				graphResult += getRadiusTex(rArray[i], false);
			}
			
			
			changePointText(tc, str);
			
			cs.addChild(tc);
			crossText.push(tc);
			
			var pX = rArray[i]*baseCycle/360;
			var pY = -result*circleRad;
			
			dotLine1.graphics.moveTo(pX, 0);
			dotLine1.graphics.lineTo(pX, pY);
			
			tc.x = cW/2+ pX;
			
			if(pY<0)
			{
				tc.y = cH/2+10;
			}
			else
			{
				tc.y = cH/2-tc.getBounds().height-5;
			}
			
			if($("#result2").css("display") == "block")
			{
				tc.visible = true;
			}
			else
			{
				tc.visible = false;
			}
		}
		
		changeMathJax("result2", graphResult, false);
		
		if($("#result2").css("display") == "block" && $("#check3").prop("checked") == true)
		{
			dotLine1.visible = true;
		}
		else
		{
			dotLine1.visible = false;
		}
	}
	catch(e)
	{
		alert("changeCrossPoint:" + e.toString());
	}
}

function getCrossPointRadius()
{
	try
	{
		var rArray = [];
		
		//値に応じて必要な数値を入れる
		//サイン
		if(formArray[0] == 0)
		{
			//＋の値
			if(formArray[3] == true)
			{
				if(formArray[4] == 0)
				{
					rArray.push(30);
					rArray.push(150);
				}
				else if(formArray[4] == 1)
				{
					rArray.push(35);
					rArray.push(145);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(45);
					rArray.push(135);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(60);
					rArray.push(120);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(90);
				}
			}
			else
			{
				if(formArray[4] == 0)
				{
					rArray.push(330);
					rArray.push(210);
			
				}
				else if(formArray[4] == 1)
				{
					rArray.push(325);
					rArray.push(215);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(315);
					rArray.push(225);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(300);
					rArray.push(240);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(270);
				}
			}
		}
		//コサイン
		else if(formArray[0] == 1)
		{
			//＋の値
			if(formArray[3] == true)
			{
				if(formArray[4] == 0)
				{
					rArray.push(60);
					rArray.push(300);
				}
				else if(formArray[4] == 1)
				{
					rArray.push(55);
					rArray.push(305);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(45);
					rArray.push(315);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(30);
					rArray.push(330);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(0);
				}
			}
			else
			{
				if(formArray[4] == 0)
				{
					rArray.push(120);
					rArray.push(240);
			
				}
				else if(formArray[4] == 1)
				{
					rArray.push(125);
					rArray.push(235);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(135);
					rArray.push(225);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(150);
					rArray.push(220);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(180);
				}
			}
		}
		else
		{
			//＋の値
			if(formArray[3] == true)
			{
				if(formArray[4] == 0)
				{
					rArray.push(27);
					rArray.push(207);
				}
				else if(formArray[4] == 1)
				{
					rArray.push(30);
					rArray.push(210);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(35);
					rArray.push(215);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(41);
					rArray.push(221);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(45);
					rArray.push(225);
				}
				else if(formArray[4] == 5)
				{
					rArray.push(60);
					rArray.push(240);
				}
			}
			else
			{
				if(formArray[4] == 0)
				{
					rArray.push(333);
					rArray.push(153);
				}
				else if(formArray[4] == 1)
				{
					rArray.push(330);
					rArray.push(150);
				}
				else if(formArray[4] == 2)
				{
					rArray.push(325);
					rArray.push(145);
				}
				else if(formArray[4] == 3)
				{
					rArray.push(319);
					rArray.push(139);
				}
				else if(formArray[4] == 4)
				{
					rArray.push(315);
					rArray.push(135);
				}
				else if(formArray[4] == 5)
				{
					rArray.push(300);
					rArray.push(120);
				}
			}
		}
		
		//グラフは-2π～2πまで移動しうるのでその値も設定しておく
		var checkArray = [];
		
		if(rArray.length == 1)
		{
			checkArray[0] = rArray[0]-360;
			checkArray[1] = rArray[0];
			checkArray[2] = rArray[0]+360;
		}
		else if(rArray.length == 2)
		{
			checkArray[0] = rArray[0]-360;
			checkArray[1] = rArray[1]-360;
			checkArray[2] = rArray[0];
			checkArray[3] = rArray[1];
			checkArray[4] = rArray[0]+360;
			checkArray[5] = rArray[1]+360;
		}
		
		//加えている角度
		var add = addRad[formArray[2]];
		if(formArray[1] == false)
		{
			add = -addRad;
		}
		
		//初期化
		rArray = [];
		
		var j=checkArray.length;
		for(var i=0; i<j; i++)
		{
			var c = checkArray[i]-add;
			
			//0～360内の値のみ
			if(c > 0 && c < 360)
			{
				rArray.push(c);
			}
		}
		
		return rArray;
	}
	catch(e)
	{
		alert("getCrossPointRadius:" + e.toString());
	}
}

//y=〇との交点座標の表示
function showCrossPoint()
{
	var f= true;
	
	if(!$("check3").prop("checked"))
	{
		f = false;
	}
	
	dotLine1.visible = f;
	for(i=0; i<crossText.length; i++)
	{
		crossText[i].visible = f;
	}
}

function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//テキスト無し
		if(str == "")
		{
			return;
		}
		
		//弧度法
		else if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str.substring(0, str.length-1), "16px Times New Roman", "#000000");
					c.addChild(t0_5);
					c.addChild(t0_1);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

function getPointDataString(n, f)
{
	try
	{
		var str;
		
		//数値
		if(f == 0)
		{
			str = n.toString();
		}
		//弧度法
		else if(f == 1)
		{
			var str0 = math.simplify(n/180).toString();
			//空白削除
			str0 = str0.replace(/\s+/g, "");
				
			if(str0 == "0")
			{
				str = "0";
			}
			else if(str0 == "1")
			{
				str = "π";
			}
			else if(str0 == "-1")
			{
				str = "-π";
			}
			else if(str0.indexOf("/") == -1)
			{
				str = str0 + "π";
			}
			//分数
			else
			{
				if(str0.substring(0, 2) == "1/")
				{
					str = "π" + str0.substring(str0.indexOf("/"), str0.length);
				}
				else if(str0.substring(0, 3) == "-1/")
				{
					str = "-π" + str0.substring(str0.indexOf("/"), str0.length);
				}
				else
				{
					str = str0.substring(0, str0.indexOf("/"))+ "π" + str0.substring(str0.indexOf("/"), str0.length);
				}
			}
		}
		//度数法
		else
		{
			str = n.toString() + "°";
		}
		
		return str;
	}
	catch(e)
	{
		alert("getPointDataString:" + e.toString());
	}
}

/*
function changeCrossPointTextPosition()
{
	try
	{
		var margin = 10;
		
		//-π
		lx0.x = cW/2 - baseCycle/2;
		lx0.y = cH/2 + margin;
		
		//-π/2
		lx1.x = cW/2 - baseCycle/4;
		if(slider.prev>=0)
		{
			lx1.y = cH/2 - lx1.getBounds().height - margin;
		}
		else
		{
			lx1.y = cH/2 + margin;
		}
		
		//π/2
		lx2.x = cW/2 + baseCycle/4;
		if(slider.prev >= 0)
		{
			lx2.y = cH/2 + margin;
		}
		else
		{
			lx2.y = cH/2 - lx2.getBounds().height - margin;
		}
		
		//π
		lx3.x = cW/2 + baseCycle/2;
		lx3.y = cH/2 + margin;

		if ( document.getElementById("methodText").innerHTML == "弧度法")
		{
			editPointText(ly0, slider.prev.toString());
			editPointText(ly1, slider.prev.toString());
		}
		else
		{
			editPointText(ly0, Math.round(slider.prev * 180 / Math.PI).toString() + "°");
			editPointText(ly1, Math.round(slider.prev * 180 / Math.PI).toString() + "°");
		}
		
		var pos = ( Math.PI / 4 ) * span;
		var adj = ( slider.prev / 6 ) / 2 * span;
		ly0.x = cW/2 - margin + pos + adj + 10;
		ly1.x = cW/2 - margin - pos + adj + 10;
		
		
		//ly0.y = cH/2 - baseCycle/Math.PI * slider.prev - ly0.getBounds().height/2;
		//ly1.y = cH/2 + baseCycle/Math.PI * slider.prev - ly1.getBounds().height/2;
		ly0.y = cH/2 - ly0.getBounds().height/2 - span - 12;
		ly1.y = cH/2 + ly1.getBounds().height/2 + span - 10;

		if (line0.visible)
		{
			lx0.visible = true;
			lx1.visible = true;
			lx2.visible = true;
			lx3.visible = true;
		}
		else
		{
			lx0.visible = false;
			lx1.visible = false;
			lx2.visible = false;
			lx3.visible = false;
		}
		
	}
	catch(e)
	{
		alert("changeCrossPointTextPosition:" + e.toString());
	}
}
*/

//	+--------------------------+
//	| 弧度法・度数法の切り替え |
//	+--------------------------+
function changeMethodHandler(e)
{
	try
	{
		if(e.currentTarget.innerHTML == "弧度法")
		{
			e.currentTarget.innerHTML = "度数法";
		}
		else
		{
			e.currentTarget.innerHTML = "弧度法";
		}
		
		// θのテキスト編集
		changeMenuRadiusDisplay();
		slider.changeAnimeRadiusDisplay();
		
		changeCrossPoint();
		
		changeScaleText();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeMethodHandler:" + e.toString());
	}
}

//	+----------------------+
//	| グラフスケールの変更 |
//	+----------------------+

function changeGraphScale(sX, sY)
{
	try
	{
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の目盛
		if(sX != null)
		{
			spanX = span * sX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				if(i < cW/2-leftLimit)
				{
					break;
				}
				
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
		}
		
		//y軸の目盛
		if(sY != null)
		{
			spanY = span * sY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

//	+----------------+
//	| グリッドの変更 |
//	+----------------+

function changeGraphGrid(gX, gY)
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の線
		if(gX != null)
		{
			var spanX = span * gX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				if(i < cW/2-leftLimit)
				{
					break;
				}
				
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
		}
		
		
		//y軸の線
		if(gY != null)
		{
			spanY = span * gY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				if(leftLimit != null)
				{
					grid.graphics.moveTo(cW/2-leftLimit, i);
				}
				else
				{
					grid.graphics.moveTo(0, i);
				}
				
				grid.graphics.lineTo(cW, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				if(leftLimit != null)
				{
					grid.graphics.moveTo(cW/2-leftLimit, i);
				}
				else
				{
					grid.graphics.moveTo(0, i);
				}
				
				grid.graphics.lineTo(cW, i);
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

//	+------------------------+
//	|  |
//	+------------------------+
function changeFormulaPositionHandler()
{
	return;
}

//	+--------------+
//	| データセーブ |
//	+--------------+
function saveContent()
{
	try
	{
		var array = [];
		
		// 刻み幅
		array[0] = stepSize;
		
		if(document.getElementById("methodText").innerHTML == "弧度法")
		{
			array[1] = true;
		}
		else
		{
			array[1] = false;
		}
		
		array[2] = configArray.slice();
		
		array[3] = [ document.getElementById("check1").checked
					,document.getElementById("check2").checked
					,document.getElementById("check3").checked
					];
		
		//式のデータ
		array[4] = formArray.slice();
		
		array[5] = dispFlag;
		
		//アニメーションの設定
		array[6] = [slider.min, slider.max, slider.prev];
		array[7] = slider.loopFlag;
		array[8] = slider.loopMode;
		array[9] = slider.speedIndex;
		
		array[10] = $("#result2").css("display");
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

//	+--------------+
//	| データロード |
//	+--------------+
function loadContent(array)
{
	try
	{
		stepSize = array[0];
		
		if(array[1] == true)
		{
			document.getElementById("methodText").innerHTML = "弧度法";
		}
		else
		{
			document.getElementById("methodText").innerHTML = "度数法";
		}
		
		configArray = array[2].slice();
		
		document.getElementById("check1").checked = array[3][0];
		document.getElementById("check2").checked = array[3][1];
		document.getElementById("check3").checked = array[3][2];
		
		dotLine.visible = document.getElementById("check2").checked;
		line0.visible = document.getElementById("check3").checked;
		
		formArray = array[4].slice();
		
		dispFlag = array[5];
		
		if(dispFlag)
		{
			$("#formula1").css("display", "block");
		}
		else
		{
			$("#formula1").css("display", "none");
		}
		
		//スライダーの設定
		slider.min = array[6][0];
		slider.max = array[6][1];
		slider.prev = array[6][2];
		
		slider.loopFlag = array[7];
		slider.loopMode = array[8];
		
		switch(array[8])
		{
			case 0:
				document.getElementById("loopBtn").src = "./img/loopIcon.png";
				break;
			case 1:
				document.getElementById("loopBtn").src = "./img/autoIcon.png";
				break;
			case 2:
				document.getElementById("loopBtn").src = "./img/normalIcon.png";
				break;
		}
		
		slider.speedIndex = array[9];
		
		$("#result2").css("display", array[10]);
		
		document.getElementById("speedConfig").src = "./img/s" +slider.speedArray[array[9]]+ ".png";
		
		setConfigTableNumber("cItem1_0", configArray[1][0], true);
		setConfigTableNumber("cItem1_1", configArray[1][1], false);
		setConfigTableNumber("cItem2_0", configArray[2][0], true);
		setConfigTableNumber("cItem2_1", configArray[2][1], false);
		
		changeScaleText();
		
		slider.changeSliderLine();
		slider.changeSliderPoint();
		slider.changeSliderControl();
		
		// --------
		// 画面表示
		// --------
		
		drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true );

		//数式等の修正
		changeFormula();
		changeAreaFormula();
		changeAddAreaFormula();
		changeYFormula();

		// ドットの描画
		changeAxisPositionHandler();
		changeDotLine();

		// グラフ上のテキスト表示
		changeMenuRadiusDisplay();

		//グラフ上の点
		changeDotRed();

		//y=〇とグラフとの交点
		changeCrossPoint();

		//dragPointの位置修正と表示切替
		changeDragPointPosition();
		changeDragPointDisplay();

		//単位円の表示
		changeCircleGraph();
		

		slider.ss.update();
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

// +----------+
// | リセット |
// +----------+
function resetHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			// 刻み値
			stepSize = 1;
			
			dispFlag = true;
			$("#formula1").css("display", "block");
			
			$("#result2").css("display", "none");
			
			document.getElementById("methodText").innerHTML = "弧度法";
			
			document.getElementById("check1").checked = true;
			document.getElementById("check2").checked = false;
			document.getElementById("check3").checked = false;
			
			line0.visible = false;
			dotLine.visible = false;
			
			// アニメーション・スライダー
			slider.min = defMin;
			slider.max = defMax;
			slider.prev = defNum;
			slider.loopFlag = true;
			slider.loopMode = 0;
			slider.speedIndex = 2;
			document.getElementById("loopBtn").src = "./img/loopIcon.png";
			document.getElementById('speedConfig').src = "./img/s1.png";
			slider.changeAnimeRadiusDisplay();
			
			setRadiusNumber(document.getElementById("tMin"), slider.min);
			setRadiusNumber(document.getElementById("tMax"), slider.max);
			
			slider.changeSliderLine();
			slider.changeSliderPoint();
			slider.changeSliderControl();
			
			resetCapture();
			
			//数式の要素設定
			formArray = [0, true, 3, true, 0];
			
			// グラフ描画
			drawTriangleLine(line0, "#007AC5", baseCycle, -circleRad, cW/2, true );
			
			//数式等の修正
			changeFormula();
			changeAreaFormula();
			changeAddAreaFormula();
			changeYFormula();
			
			// ドットの描画
			changeAxisPositionHandler();
			changeDotLine();
			
			// グラフ上のテキスト表示
			changeMenuRadiusDisplay();
			
			//グラフ上の点
			changeDotRed();
			
			//y=〇とグラフとの交点
			changeCrossPoint();
			
			//dragPointの位置修正と表示切替
			changeDragPointPosition();
			changeDragPointDisplay();
			
			//単位円の表示
			changeCircleGraph();
			
			//設定吹き出し
			configArray[0] = [-30, 360, -10, 10];
			configArray[1] = [90, 1];
			configArray[2] = [null, null];
			
			//目盛の表示切替
			//changeMethodNumberHandler();
			
			changeGraphScale(Math.PI/4, 1);
			
			changeGraphGrid(null, null);
			
			changeScaleText();
			
			slider.changeSliderLine();
			slider.changeSliderControl();
			slider.changeSliderPoint();
			
			// ステージ更新
			slider.ss.update();
			cs.update();
		}
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
