// JavaScript Document

//	=============================
//	  No 054 ： a_2_P197_001.js
//	  p.197　例題3　関数の極値
//	=============================

//	+------+
//	| 変数 |
//	+------+

// キャンバス、ステージ
var cc;
var cs;

// キャンバスの幅、高さ
var bW;
var bH;
var cW;
var cH;
var adjW;			// 調整値
var adjH;			// 調整値

// 中心位置
var centerX;
var centerY;

// Ｘ軸、Ｙ軸
var axisX;
var axisY;

// Ｘ軸、Ｙ軸、原点テキスト
var tx;
var ty;
var t0;

// 軸線
var base;

// 方眼
var grid;

// 刻み幅
var stepSize;

// １目盛りのピクセル数
var span;

// グラフ共通の右下の歯車ボタンで使用する設定データ
var configArray;

//式の係数
var aNum;
var bNum;
var cNum;
var dNum;

var minNum;
var maxNum;

var defA;
var defB;
var defC;
var defD;

var defMin;
var defMax;


var area;
var dotLine;
var line;
var form;

//最大・最小の座標値
var tMinX0;
var tMinX1;
var tMinY;

var tMaxX0;
var tMaxX1;
var tMaxY;

var minPnt0;
var minPnt1;

var maxPnt0;
var maxPnt1;

//極値のデータ
var exData;

//極値を含めた最大・最小の値
var exMinX0;
var exMinX1;
var exMinY;
var exMaxX0;
var exMaxX1;
var exMaxY;

var timer;

//	+----------------+
//	| ロード時の処理 |
//	+----------------+
function loadContentHandler()
{
	try
	{
		// ----------
		// 初期値設定
		// ----------
		
		// １周期のピクセル
		baseCycle = 300;
		
		// 軸の1目盛当たりのピクセル数
		span = 30;
		
		// 刻み幅
		stepSize = 1;
		
		// キャンバス位置調整
		adjW = 130;
		adjH = 110;
		
		// キャンバスサイズ設定
		bW = pageWidth-52;
		bH = pageHeight;
		cW = bW * 3;
		cH = bH * 3;
		document.getElementById("graphBlock").style.width = bW + "px";
		document.getElementById("graphBlock").style.height = bH + "px";
		document.getElementById("graphCanvas").style.left = (-bW + adjW) + "px";
		document.getElementById("graphCanvas").style.top = (-bH + adjH) + "px";
		document.getElementById("graphCanvas").width = cW;
		document.getElementById("graphCanvas").height = cH;
		document.getElementById("graphCanvas").style.position = "absolute";
		
		// 中心位置
		centerX = cW/2;
		centerY = cH/2;
		
		// 区間の値
		defMin = -1;
		defMax = 2;
		
		//数式の係数
		defA = 4;
		defB = -3;
		defC = -6;
		defD = 2;
		
		// ドラッグ関連
		dFlag = true;
		animeFlag = false;
		
		minNum = defMin;
		maxNum = defMax;
		
		aNum = defA;
		bNum = defB;
		cNum = defC;
		dNum = defD;
		
		
		// ステージの作成
		cc = document.getElementById("graphCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		// 背景の作成
		var bg = new createjs.Shape();
		bg.graphics.beginFill("#FFF");
		bg.graphics.drawRect(0, 0, cW, cH);
		bg.graphics.endFill();
		cs.addChild(bg);
		
		area = new createjs.Shape();
		area.x = cW/2;
		area.y = cH/2;
		cs.addChild(area);
		area.visible = false;
		
		// 方眼の作成
		grid = new createjs.Shape();
		cs.addChild(grid);
		
		// 軸と矢印の作成
		base = new createjs.Shape();
		cs.addChild(base);
		axisX = new createjs.Shape();
		cs.addChild(axisX);
		axisY = new createjs.Shape();
		cs.addChild(axisY);
		
		// Ｘ軸、Ｙ軸、原点のテキスト作成
		tx = new createjs.Text("x", "italic 20px Times New Roman", "#000000");
		cs.addChild(tx);
		ty = new createjs.Text("y", "italic 20px Times New Roman", "#000000");
		cs.addChild(ty);
		t0 = new createjs.Text("O", "20px Times New Roman", "#000000");
		cs.addChild(t0);
		
		dotLine = new createjs.Shape();
		dotLine.x = cW/2;
		dotLine.y = cH/2;
		cs.addChild(dotLine);
		
		//グラフの線
		line = new createjs.Shape();
		line.x = cW/2;
		line.y = cH/2;
		cs.addChild(line);
		
		minPnt0 = createPeakPoint();
		minPnt0.x = cW/2;
		minPnt0.y = cH/2;
		cs.addChild(minPnt0);
		
		minPnt1 = createPeakPoint();
		minPnt1.x = cW/2;
		minPnt1.y = cH/2;
		cs.addChild(minPnt1);
		
		maxPnt0 = createPeakPoint();
		maxPnt0.x = cW/2;
		maxPnt0.y = cH/2;
		cs.addChild(maxPnt0);
		
		maxPnt1 = createPeakPoint();
		maxPnt1.x = cW/2;
		maxPnt1.y = cH/2;
		cs.addChild(maxPnt1);
		
		minPnt0.visible = false;
		minPnt1.visible = false;
		maxPnt0.visible = false;
		maxPnt1.visible = false;
		
		tMinX0 = new createjs.Text("", "18px Times New Roman", "#000000");
		tMinX1 = new createjs.Text("", "18px Times New Roman", "#000000");
		tMinY = new createjs.Text("", "18px Times New Roman", "#000000");
		tMaxX0 = new createjs.Text("", "18px Times New Roman", "#000000");
		tMaxX1 = new createjs.Text("", "18px Times New Roman", "#000000");
		tMaxY = new createjs.Text("", "18px Times New Roman", "#000000");
		
		cs.addChild(tMinX0);
		cs.addChild(tMinX1);
		cs.addChild(tMinY);
		cs.addChild(tMaxX0);
		cs.addChild(tMaxX1);
		cs.addChild(tMaxY);
		
		// 式表示用
		form = new createjs.Container();
		cs.addChild(form);
		
		
		$(".lineText").focus(function(){$(this).blur();});
		
		$(".configText").css("display", "inline-block");
		$(".configText").css("width", "40px");
		$(".configText").css("text-align", "center");
		
		$("#minNum").html(minNum);
		$("#maxNum").html(maxNum);
		
		$("#aMin").html(minNum);
		$("#aMax").html(maxNum);
		
		$("#result0").css("display", "none");
		$("#idTable").css("display", "none");
		$("#result2").css("display", "none");
		$("#result3").css("display", "none");
		
		// 設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		setGraphConfig();
		
		// チェックボックス
		document.getElementById("check0").checked = true;
		document.getElementById("check1").checked = false;
		document.getElementById("check2").checked = false;
		document.getElementById("check3").checked = false;
		
		// チェックボックス
		document.getElementById("check0").addEventListener("change", changeCheckHandler);
		document.getElementById("check1").addEventListener("change", changeCheckHandler);
		document.getElementById("check2").addEventListener("change", changeCheckHandler);
		document.getElementById("check3").addEventListener("change", changeCheckHandler);
		
		// 隠しボタン
		document.getElementById("openBtn0_0").addEventListener("click", openResultHandler);
		document.getElementById("openBtn0_1").addEventListener("click", openResultHandler);
		document.getElementById("openBtn2").addEventListener("click", openResultHandler);
		document.getElementById("openBtn3").addEventListener("click", openResultHandler);
		
		cs.addEventListener("mousedown", canvasDragStart);
		
		// 刻み幅
		document.getElementById("stepText").addEventListener("click", openMenuBalloonHandler);
		
		// オプションボタン（数式の設定画面）
		document.getElementById('optionBtn0').addEventListener('click', openOptionHandler);
		document.getElementById('optionClose').addEventListener('click', closeOptionHandler);
		
		// 数式の設定
		document.getElementById("upBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_2").addEventListener("click", changeFormulaHandler);
		document.getElementById("upBtn0_3").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_0").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_1").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_2").addEventListener("click", changeFormulaHandler);
		document.getElementById("downBtn0_3").addEventListener("click", changeFormulaHandler);
		
		// 領域の値の設定
		document.getElementById("upBtn1_0").addEventListener("click", changeAreaHandler);
		document.getElementById("downBtn1_0").addEventListener("click", changeAreaHandler);
		document.getElementById("upBtn1_1").addEventListener("click", changeAreaHandler);
		document.getElementById("downBtn1_1").addEventListener("click", changeAreaHandler);
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		// 軸表示
		drawBaseLine();
		changeAxisPositionHandler();
		
		// 計算処理
		calcData();
		
		// 式の表示
		changeFormula();
		
		// 図形の表示
		drawLine();
		
		drawArea();
		
		// テキストの表示
		drawText();
		
		timer = setTimeout(
			function()
			{
				changeFormula();
				clearTimeout(timer);
			}, 1000);
		
		// オプションメニュー画面
		setModal('optionBlock');
		setModal('spanChange');
		setMenuMode(0, 320);
		$("#controlBlock").css("overflow-x", "auto");		// 横スクロールバーは非表示
		
		// ステージ更新
		cs.update();
		
		// バージョンチェック
		checkVersionHandler("1.0.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function createPeakPoint()
{
	try
	{
		var s = new createjs.Shape();
		s.graphics.setStrokeStyle(0);
		s.graphics.beginStroke("#007AC5");
		s.graphics.beginFill("#007AC5");
		s.graphics.drawCircle(0, 0, 5);
		s.graphics.endFill();
		s.graphics.endStroke();
		s.alpha = 0.5;
		
		return s;
	}
	catch(e)
	{
		alert("createPeakPoint:" + e.toString());
	}
}

function changeFormula()
{
	try
	{
		//メニューの数式
		var mStr = getFormulaString(true);
		changeMathJax("form0_0", mStr, false);
		
		//グラフの数式
		var gStr = getFormulaString(false);
		
		
		changeFormulaContainer(form, gStr, 0,0, "#000000");
		
		//式変形後に位置調整
		var nX0;
		
		if(exData.length > 0)
		{
			nX0 = exData[0]-0.5;
		}
		else
		{
			nX0 = -0.5;
		}

		nX1 = nX0/span;
		
		var nX = cW/2 + nX0 * span - form.getBounds().width-5;
		var nY = cH/2 - span * (aNum * Math.pow(nX0, 3) + bNum * Math.pow(nX0, 2) + cNum * nX0 + dNum);
		
		form.x = nX;
		form.y = nY;
		
		
		//微分後の数式
		var str = "f\'(x)=";
		
		var a = aNum * 3;
		var b = bNum * 2;
		var c = cNum;
		
		if(a == -1)
		{
			str += "-";
		}
		else if(a != 1)
		{
			str += a.toString();
		}
		
		str += "x^2";
		
		if(b != 0)
		{
			if(b == -1)
			{
				str += "-";
			}
			else if(b != 1)
			{
				if(b > 0)
				{
					str += "+";
				}
				
				str += b.toString();
			}
		
			str += "x";
		}
		
		if(c != 0)
		{
			if(c > 0)
			{
				str += "+";
			}
			
			str += c.toString();
		}
		
		changeMathJax("form0_1", str, false);
	}
	catch(e)
	{
		alert("changeFormula:" + e.toString());
	}
}

function getFormulaString(f)
{
	try
	{
		var str;
		
		if(f)
		{
			str = "f(x)=";
		}
		else
		{
			str = "y=";
		}
		
		if(aNum == -1)
		{
			str += "-";
		}
		else if(aNum != 1)
		{
			str += aNum.toString();
		}
		
		if(f)
		{
			str += "x^3";
		}
		else
		{
			str += "x³";
		}
		
		if(bNum != 0)
		{
			if(bNum > 0)
			{
				if(aNum != 0)
				{
					str += "+";
				}
				
				if(bNum != 1)
				{
					str += bNum.toString();
				}
			}
			else
			{
				if(bNum == -1)
				{
					str += "-";
				}
				else
				{
					str += bNum.toString();
				}
			}
		
			if(f)
			{
				str += "x^2";
			}
			else
			{
				str += "x²";
			}
		}
		
		
		if(cNum != 0)
		{
			if(cNum > 0)
			{
				str += "+";

				if(cNum != 1)
				{
					str += cNum.toString();
				}
			}
			else
			{
				if(cNum == -1)
				{
					str += "-";
				}
				else
				{
					str += cNum.toString();
				}
			}
		
			if(f)
			{
				str += "x";
			}
			else
			{
				str += "x";
			}
		}
		
		if(dNum > 0)
		{
			str += "+" + dNum.toString();
		}
		else if(dNum < 0)
		{
			str += dNum.toString();
		}
		
		return str;
	}
	catch(e)
	{
		alert("getFormulaString:" + e.toString());
	}
}

//	+--------------+
//	|  |
//	+--------------+
function changeFormulaPositionHandler(num)
{
	return;
}


//	+----------------------------------------+
//	| ここまでは必要なので削除してはいけない |
//	+----------------------------------------+

//	+--------------------+
//	| ベースラインの描画 |
//	+--------------------+
function drawBaseLine()
{
	try
	{
		// 軸と矢印の描画
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		// Ｘ軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		// Ｙ軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		// Ｘ軸の矢印
		axisX.graphics.beginFill("#000000");
		axisX.graphics.moveTo(-20, 0);
		axisX.graphics.lineTo(-20, -4);
		axisX.graphics.lineTo(-2, 0);
		axisX.graphics.lineTo(-20, 4);
		axisX.graphics.lineTo(-20, 0);
		axisX.graphics.endFill();
		// Ｙ軸の矢印
		axisY.graphics.beginFill("#000000");
		axisY.graphics.moveTo(0, 20);
		axisY.graphics.lineTo(-4, 20);
		axisY.graphics.lineTo(0, 2);
		axisY.graphics.lineTo(4, 20);
		axisY.graphics.lineTo(0, 20);
		axisY.graphics.endFill();
		axisY.graphics.endStroke();
		// Ｘ軸、Ｙ軸の位置
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		numX = -numX.substring(0, numX.length-2);
		numY = -numY.substring(0, numY.length-2);
		axisX.x = numX + bW;
		axisX.y = centerY;
		axisY.x = centerX;
		axisY.y = numY;
		// Ｘ軸、Ｙ軸、原点のテキスト
		tx.x = numX + bW -tx.getBounds().width-5;
		tx.y = cH/2+5;
		ty.x = cW/2+10;
		ty.y = numY + 2;
		t0.x = cW/2+5;
		t0.y = cH/2+5;
	}
	catch(e)
	{
		alert("drawBase:"+e.toString());
	}
}

//	+----------+
//	| 軸の表示 |
//	+----------+
function changeAxisPositionHandler()
{
	try
	{
		var numX = document.getElementById("graphCanvas").style.left;
		var numY = document.getElementById("graphCanvas").style.top;
		
		numX = -numX.substring(0, numX.length-2)/cScale;
		numY = -numY.substring(0, numY.length-2)/cScale;
		
		axisX.x = numX + bW/cScale;
		axisY.y = numY;
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(axisX.x-2, cH/2);
		//y軸
		base.graphics.moveTo(cW/2, axisY.y+2);
		base.graphics.lineTo(cW/2, cH);
		
		//軸のテキスト
		tx.x = axisX.x -tx.getBounds().width-5;
		ty.y = axisY.y + 2;
	}
	catch(e)
	{
		alert("changeAxisPositionHandler:" + e.toString());
	}
}

//	+----------+
//	| 計算処理 |
//	+----------+
function calcData()
{
	try
	{
		/*方程式のx³の係数は0にならない前提*/
		
		var a = aNum * 3;
		var b = bNum * 2;
		var c = cNum;
		
		d0 = (-b-Math.sqrt(b*b-4*a*c))/(2*a);
		d1 = (-b+Math.sqrt(b*b-4*a*c))/(2*a);
		
		var f=-1;
		
		//極値がない場合
		if(b*b-4*a*c < 0)
		{
			exData = [];
			
			f=0;
		}
		//極値が一つ
		else if(d0 == d1)
		{
			exData = [d0];
			f=1;
		}
		else
		{
			if(d0 < d1)
			{
				exData = [d0, d1];
			}
			else
			{
				exData = [d1, d0];
			}
			
			f=2;
		}
		
		//領域の左端の値
		var minAreaY = getFormulaResult(minNum);
		
		//領域の右端の値
		var maxAreaY =getFormulaResult(maxNum);
		
		//極値がない，もしくは１つの場合
		if(f==0 || f == 0)
		{
			if(minAreaY < maxAreaY)
			{
				exMinX0 = minNum;
				exMaxX0 = maxNum;
				
				exMinY = minAreaY;
				exMaxY = maxAreaY;
			}
			else
			{
				exMinX0 = maxNum;
				exMaxX0 = minNum;
				
				exMinY = maxAreaY;
				exMaxY = minAreaY;
			}
			
			//同じ最大・最小のX座標はなし
			exMinX1 = null;
			exMaxX1 = null;
		}
		else if(f==2)
		{
			//ｘの値が小さいほうの極値の値
			dY0 = getFormulaResult(d0);
			
			//ｘの値が大きいほうの極値の値
			dY1 = getFormulaResult(d1);
			
			//極小値
			var eX0;
			var eY0;
			
			//極大値
			var eX1;
			var eY1;
			
			if(dY0 < dY1)
			{
				eX0 = d0;
				eY0 = dY0;
				
				eX0 = d1;
				eY1 = dY1;
			}
			else
			{
				eX0 = d1;
				eY0 = dY1;
				
				eX1 = d0;
				eY1 = dY0;
			}
			
			//極小がエリア内にある場合
			if(eX0 >= minNum && eX0 <= maxNum)
			{
				//両端が同じ値の場合に内側に極小がある場合は極小の値が最小になる
				if(minAreaY == maxAreaY)
				{
					//極小がどちらかの端にある場合
					if(eX0 == minNum || eX0 == maxNum)
					{
						exMinX0 = minNum;
						exMinX1 = maxNum;
						exMinY = minAreaY;
					}
					else
					{
						exMinX0 = eX0;
						exMinX1 = null;
						exMinY = eY0;
					}
				}
				//左端の値が右端の値より小さい場合
				else if(minAreaY < maxAreaY)
				{
					//極小と左端が同じ場合
					if(eY0 == minAreaY)
					{
						//x座標が同じ場合
						if(eX0 == minNum)
						{
							exMinX0 = eX0;
							exMinX1 = null;
							exMinY = eY0;
						}
						else
						{
							exMinX0 = minNum;
							exMinX1 = eX0;
							exMinY = eY0;
						}
					}
					else
					{
						if(eY0 < minAreaY)
						{
							exMinX0 = eX0;
							exMinX1 = null;
							exMinY = eY0;
						}
						else
						{
							exMinX0 = minNum;
							exMinX1 = null;
							exMinY = minAreaY;
						}
					}
				}
				//右端の値が左端の値より小さい場合
				else
				{
					//極小と右端が同じ場合
					if(eY0 == maxAreaY)
					{
						//x座標が同じ場合
						if(eX0 == maxNum)
						{
							exMinX0 = eX0;
							exMinX1 = null;
							exMinY = eY0;
						}
						else
						{
							exMinX0 = eX0;
							exMinX1 = maxNum;
							exMinY = eY0;
						}
					}
					else
					{
						if(eY0 < maxAreaY)
						{
							exMinX0 = eX0;
							exMinX1 = null;
							exMinY = eY0;
						}
						else
						{
							exMinX0 = maxNum;
							exMinX1 = null;
							exMinY = maxAreaY;
						}
					}
				}
			}
			//極小がエリア内にない場合
			else
			{
				if(minAreaY < maxAreaY)
				{
					exMinX0 = minNum;
					exMinY = minAreaY;
				}
				else
				{
					exMinX0 = maxNum;
					exMinY = maxAreaY;
				}
				
				exMinX1 = null;
			}
			
			//極大値がエリア内にある場合
			if(eX1 >= minNum && eX1 <= maxNum)
			{
				//両端が同じ値の場合に内側に極大がある場合は極大が最大になる
				if(minAreaY == maxAreaY)
				{
					//極小がどちらかの端にある場合
					if(eX1 == minNum || eX1 == maxNum)
					{
						exMaxX0 = minNum;
						exMaxX1 = maxNum;
						exMaxY = maxAreaY;
					}
					else
					{
						exMaxX0 = eX1;
						exMaxX1 = null;
						exMaxY = eY1;
					}
				}
				//左端の値が右端の値より大きい場合
				else if(minAreaY > maxAreaY)
				{
					//極大と左端が同じ場合
					if(eY1 == minAreaY)
					{
						//x座標が同じ場合
						if(eX1 == minNum)
						{
							exMaxX0 = eX1;
							exMaxX1 = null;
							exMaxY = eY1;
						}
						else
						{
							exMaxX0 = minNum;
							exMaxX1 = eX1;
							exMaxY = eY1;
						}
					}
					else
					{
						if(eY1 > minAreaY)
						{
							exMaxX0 = eX1;
							exMaxX1 = null;
							exMaxY = eY1;
						}
						else
						{
							exMaxX0 = minNum;
							exMaxX1 = null;
							exMaxY = minAreaY;
						}
					}
				}
				else
				{
					//極大と右端が同じ場合
					if(eY1 == maxAreaY)
					{
						//x座標が同じ場合
						if(eX1 == maxNum)
						{
							exMaxX0 = eX1;
							exMaxX1 = null;
							exMaxY = eY1;
						}
						else
						{
							exMaxX0 = maxNum;
							exMaxX1 = eX1;
							exMaxY = eY1;
						}
					}
					else
					{
						if(eY1 > maxAreaY)
						{
							exMaxX0 = eX1;
							exMaxX1 = null;
							exMaxY = eY1;
						}
						else
						{
							exMaxX0 = maxNum;
							exMaxX1 = null;
							exMaxY = maxAreaY;
						}
					}
				}
			}
			//極大がエリア内にない場合
			else
			{
				if(minAreaY > maxAreaY)
				{
					exMaxX0 = minNum;
					exMaxX1 = null;
					exMaxY = minAreaY;
				}
				else
				{
					exMaxX0 = maxNum;
					exMaxX1 = null;
					exMaxY = maxAreaY;
				}
			}
		}
		
		changeMinMaxPointDisplay();
		
		//増減表切替
		changeTable();
	}
	catch(e)
	{
		alert("calcData:" + e.toString());
	}
}

function changeMinMaxPointDisplay()
{
	try
	{
		if($("#check2").prop("checked"))
		{
			maxPnt0.x = cW/2 + span * exMaxX0;
			maxPnt0.y = cH/2 - span * exMaxY;
			maxPnt0.visible = true;
			
			if(exMaxX1 != null)
			{
				maxPnt1.x = cW/2 + span * exMaxX1;
				maxPnt1.y = cH/2 - span * exMaxY;
				maxPnt1.visible = true;
			}
			else
			{
				maxPnt1.visible = false;
			}
		}
		else
		{
			maxPnt0.visible = false;
			maxPnt1.visible = false;
		}
		
		if($("#check3").prop("checked"))
		{
			minPnt0.x = cW/2 + span * exMinX0;
			minPnt0.y = cH/2 - span * exMinY;
			minPnt0.visible = true;
			
			if(exMinX1 != null)
			{
				minPnt1.x = cW/2 + span * exMinX1;
				minPnt1.y = cH/2 - span * exMinY;
				minPnt1.visible = true;
			}
			else
			{
				minPnt1.visible = false;
			}
		}
		else
		{
			minPnt0.visible = false;
			minPnt1.visible = false;
		}
	}
	catch(e)
	{
		alert("changeMinMaxPointDisplay:" + e.toString());
	}
}

//数式の値
function getFormulaResult(x)
{
	try
	{
		var n = aNum * x * x * x + bNum * x * x + cNum * x + dNum;
		
		return n;
	}
	catch(e)
	{
		alert("getFormulaResult:" + e.toString());
	}
}

//微分した数式の値
function getDifferentialResult(x)
{
	try
	{
		var n = aNum * 3 * x * x + bNum * 2 * x  + cNum;
		
		return n;
	}
	catch(e)
	{
		alert("getDifferentialResult:" + e.toString());
	}
}

function getGraphPointY(x, f)
{
	try
	{
		var pY;
		
		//ポイントでの解
		if(f)
		{
			pY = aNum * Math.pow(x/span, 3) + bNum * Math.pow(x/span, 2) + cNum * (x/span) + dNum;
		}
		//整数値での解
		else
		{
			pY = aNum * Math.pow(x, 3) + bNum * Math.pow(x, 2) + cNum * x + dNum;
		}
		
		pY = -pY * span;
		
		return pY;
	}
	catch(e)
	{
		alert("getGraphPoint:" + e.toString());
	}
}

//	+------------+
//	| 図形の表示 |
//	+------------+
function drawLine()
{
	try
	{
		var g = line.graphics;
		g.clear();
		
		//範囲に合わせた線の描画
		if($("#check1").prop("checked"))
		{
			g.setStrokeStyle(1);
			g.setStrokeDash([5,5]);
			g.beginStroke("#000000");
			
			//境界の左端
			var minX = minNum * span;
			//境界の右端
			var maxX = maxNum * span;
			
			var f0 = false;
			
			for(var i=-cW/2; i<=cW/2; i++)
			{
				pY = getGraphPointY(i, true);
				
				if(i==-cW/2)
				{
					g.moveTo(i, pY);
				}
				else
				{
					g.lineTo(i, pY);
				}
				
				//区間に入る場合
				if(i<= minX && i+1 >= minX && f0 == false)
				{
					var minY = getGraphPointY(minX, true);
					
					g.lineTo(minX, minY);
					g.endStroke();
					
					g.setStrokeDash(null);
					g.beginStroke("#000000");
					g.moveTo(minX, minY);
					
					f0 = true;
				}
				//区間から抜ける場合
				else if(i+1 >= maxX && f0 == true)
				{
					var maxY = getGraphPointY(maxX, true);
					
					g.lineTo(maxX, maxY);
					g.endStroke();
					
					g.setStrokeStyle(1);
					g.setStrokeDash([5,5], 0);
					g.beginStroke("#000000");
					g.moveTo(maxX, maxY);
					
					f0 = false;
				}
			}
			
			g.endStroke();
		}
		else
		{
			var f1 = true;
			
			g.setStrokeStyle(1);
			g.setStrokeDash(null);
			g.beginStroke("#000000");
			
			for(var i=-cW/2; i<=cW/2; i++)
			{
				pY = getGraphPointY(i, true);
				
				if(f1)
				{
					g.moveTo(i, pY);
					f1=false;
				}
				else
				{
					g.lineTo(i, pY);
				}
			}
			
			g.endStroke();
			
		}
	}
	catch(e)
	{
		alert("drawLine:" + e.toString());
	}
}

//	+----------------+
//	| テキストの表示 |
//	+----------------+
function drawText()
{
	try
	{
		if(exMaxX1 == null)
		{
			$("#maxResultX").html(Math.round(exMaxX0 * 100)/100);
	
		}
		else if(exMaxX0 != exMaxX1)
		{
			var xStr = Math.round(exMaxX0 * 100)/100 + ", " + Math.round(exMaxX1 * 100)/100;
			$("#maxResultX").html(xStr);
		}
		
		$("#maxResultY").html(Math.round(exMaxY * 100)/100);
		
		if(exMinX1 == null)
		{
			$("#minResultX").html(Math.round(exMinX0 * 100)/100);
	
		}
		else if(exMinX0 != exMinX1)
		{
			var xStr = Math.round(exMinX0 * 100)/100 + ", " + Math.round(exMinX1 * 100)/100;
			$("#minResultX").html(xStr);
		}
		
		$("#minResultY").html(Math.round(exMinY * 100)/100);
		
		
		//最大値
		if($("#check2").prop("checked") && $("#result2").css("display") == "block")
		{
			var tY;
			
			//最大値のxの値
			if(exMaxY >= 0)
			{
				tY = cH/2 + 5;
			}
			else
			{
				tY = cH/2 - 23;
			}
			
			if(exMaxX0 != 0)
			{
				tMaxX0.text = Math.round(exMaxX0 * 100)/100;

				tMaxX0.x = cW/2 + span * exMaxX0 - tMaxX0.getBounds().width/2;
			}
			else
			{
				tMaxX0.text = "";
			}
			
			tMaxX0.y = tY;
			
			if(exMaxX1 != null && exMaxX1 != 0)
			{
				tMaxX1.text = Math.round(exMaxX1 * 100)/100;
				
				tMaxX1.x = cW/2 + span * exMaxX1 - tMaxX1.getBounds().width/2;
				tMaxX1.y = tY;
			}
			else
			{
				tMaxX1.text = "";
			}
			
			//最大値のyの値
			if(exMaxY != 0)
			{
				tMaxY.text = (Math.round(exMaxY * 100)/100).toString();
				
				if(exMaxX1 != null)
				{
					if(exMaxX0 >= 0 && exMaxX1 >= 0)
					{
						tMaxY.x = cW/2 - tMaxY.getBounds().width - 5;
						
						tMaxY.y = cH/2 - exMaxY * span - 9;
					}
					else if(exMaxX0 <= 0 && exMaxX1 <= 0)
					{
						tMaxY.x = cW/2 + 5;
						
						tMaxY.y = cH/2 - exMaxY * span - 9;
					}
					else
					{
						tMaxY.x = cW/2 - tMaxY.getBounds().width - 5;
						
						if(exMaxY >= 0)
						{
							tMaxY.y = cH/2 - exMaxY * span - 23;
						}
						else
						{
							tMaxY.y = cH/2 - exMaxY * span + 5;
						}
					}
				}
				else
				{
					if(exMaxX0 >= 0)
					{
						tMaxY.x = cW/2 - tMaxY.getBounds().width - 5;
					}
					else
					{
						tMaxY.x = cW/2 + 5;
					}
					
					tMaxY.y = cH/2 - span * exMaxY - 9;
				}
			}
			else
			{
				tMaxY.text = "";
			}
		}
		else
		{
			tMaxX0.text = "";
			tMaxX1.text = "";
			tMaxY.text = "";
		}
		
		//最小値
		if($("#check3").prop("checked") && $("#result3").css("display") == "block")
		{
			var tY;
			
			if(exMinY >= 0)
			{
				tY = cH/2 + 5;
			}
			else
			{
				tY = cH/2 - 23;
			}
			
			if(exMinX0 != 0)
			{
				tMinX0.text = Math.round(exMinX0 * 100)/100;

				tMinX0.x = cW/2 + span * exMinX0 - tMinX0.getBounds().width/2;
			}
			else
			{
				tMinX0.text = "";
			}
			
			tMinX0.y = tY;
			
			if(exMinX1 != null && exMinX1 != 0)
			{
				tMinX1.text = Math.round(exMinX1 * 100)/100;
				
				tMinX1.x = cW/2 + span * exMinX1 - tMinX1.getBounds().width/2;
				tMinX1.y = tY;
			}
			else
			{
				tMinX1.text = "";
			}
			
			
			if(exMinY != 0)
			{
				tMinY.text = (Math.round(exMinY * 100)/100).toString();
				
				if(exMinX1 != null)
				{
					if(exMinX0 >= 0 && exMinX1 >= 0)
					{
						tMinY.x = cW/2 - tMinY.getBounds().width - 5;
						
						tMinY.y = cH/2 - exMinY * span - 9;
					}
					else if(exMinX0 <= 0 && exMinX1 <= 0)
					{
						tMinY.x = cW/2 + 5;
						
						tMinY.y = cH/2 - exMinY * span - 9;
					}
					else
					{
						tMinY.x = cW/2 - tMinY.getBounds().width - 5;
						
						if(exMinY >= 0)
						{
							tMinY.y = cH/2 - exMinY * span - 23;
						}
						else
						{
							tMinY.y = cH/2 - exMinY * span + 5;
						}
					}
				}
				else
				{
					if(exMinX0 >= 0)
					{
						tMinY.x = cW/2 - tMinY.getBounds().width - 5;
					}
					else
					{
						tMinY.x = cW/2 + 5;
					}
					
					tMinY.y = cH/2 - span * exMinY - 9;
				}
			}
			else
			{
				tMinY.text = "";
			}
		}
		else
		{
			tMinX0.text = "";
			tMinX1.text = "";
			tMinY.text = "";
		}
		
		drawDotLine();
	}
	catch(e)
	{
		alert("drawText:" + e.toString());
	}
}

function changeAxisTextDisplay(tX, tY, nX, nY)
{
	try
	{
		if(nX != 0)
		{
			tX.text = Math.round(nX * 100)/100;
			tX.x = cW/2 + nX * span - tX.getBounds().width/2;
			
			//x軸の下
			if(nY >= 0)
			{
				tX.y = cH/2 + 5;
			}
			else
			{
				tX.y = cH/2 - 23;
			}
		}
		else
		{
			tX.text = "";
		}
		
		if(nY != 0)
		{
			tY.text = Math.round(nY * 100)/100;
			tY.y = cH/2 - nY * span - tY.getBounds().height/2;
			
			//y軸の左側
			if(nX >= 0)
			{
				tY.x = cW/2 - tY.getBounds().width - 5;
			}
			else
			{
				tY.x = cW/2 + 5;
			}
		}
		else
		{
			tY.text = "";
		}
	}
	catch(e)
	{
		alert("changeAxisTextDisplay:" + e.toString());
	}
}

function drawDotLine()
{
	try
	{
		var g = dotLine.graphics;
		g.clear();
		g.setStrokeStyle(1);
		g.setStrokeDash([5,5]);
		g.beginStroke("#000000");
		
		if($("#check2").prop("checked"))
		{
			if(exMaxY != 0)
			{
				if(exMaxX1 == null)
				{
					if(exMaxX0 != 0)
					{
						g.moveTo(span * exMaxX0, 0);
						g.lineTo(span * exMaxX0, -span * exMaxY);
						g.lineTo(0, -span * exMaxY);
					}
				}
				else
				{
					if(exMaxX0 >= 0 && exMaxX1 >= 0)
					{
						if(exMaxX0 < exMaxX1)
						{
							g.moveTo(span * exMaxX1, 0);
							g.lineTo(span * exMaxX1, -span * exMaxY);
							g.lineTo(0, -span * exMaxY);
							
							g.moveTo(span * exMaxX0, 0);
							g.lineTo(span * exMaxX0, -span * exMaxY);
						}
						else
						{
							g.moveTo(span * exMaxX0, 0);
							g.lineTo(span * exMaxX0, -span * exMaxY);
							g.lineTo(0, -span * exMaxY);
							
							g.moveTo(span * exMaxX1, 0);
							g.lineTo(span * exMaxX1, -span * exMaxY);
						}
					}
					else if(exMaxX0 <= 0 && exMaxX1 <= 0)
					{
						if(exMaxX0 < exMaxX1)
						{
							g.moveTo(span * exMaxX0, 0);
							g.lineTo(span * exMaxX0, -span * exMaxY);
							g.lineTo(0, -span * exMaxY);
							
							g.moveTo(span * exMaxX1, 0);
							g.lineTo(span * exMaxX1, -span * exMaxY);
						}
						else
						{
							g.moveTo(span * exMaxX1, 0);
							g.lineTo(span * exMaxX1, -span * exMaxY);
							g.lineTo(0, -span * exMaxY);
							
							g.moveTo(span * exMaxX0, 0);
							g.lineTo(span * exMaxX0, -span * exMaxY);
						}
					}
					else
					{
						g.moveTo(span * exMaxX0, 0);
						g.lineTo(span * exMaxX0, -span * exMinY);
						g.lineTo(span * exMaxX1, -span * exMinY);
						g.lineTo(span * exMaxX1, 0);
					}
				}
			}
		}
		
		if($("#check3").prop("checked"))
		{
			if(exMinY != 0)
			{
				if(exMinX1 == null)
				{
					if(exMinX0 != 0)
					{
						g.moveTo(span * exMinX0, 0);
						g.lineTo(span * exMinX0, -span * exMinY);
						g.lineTo(0, -span * exMinY);
					}
				}
				else
				{
					if(exMinX0 >= 0 && exMinX1 >= 0)
					{
						if(exMinX0 < exMinX1)
						{
							g.moveTo(span * exMinX1, 0);
							g.lineTo(span * exMinX1, -span * exMinY);
							g.lineTo(0, -span * exMinY);
							
							g.moveTo(span * exMinX0, 0);
							g.lineTo(span * exMinX0, -span * exMaxY);
						}
						else
						{
							g.moveTo(span * exMinX0, 0);
							g.lineTo(span * exMinX0, -span * exMinY);
							g.lineTo(0, -span * exMinY);
							
							g.moveTo(span * exMinX1, 0);
							g.lineTo(span * exMinX1, -span * exMinY);
						}
					}
					else if(exMinX0 <= 0 && exMinX1 <= 0)
					{
						if(exMinX0 < exMinX1)
						{
							g.moveTo(span * exMinX0, 0);
							g.lineTo(span * exMinX0, -span * exMinY);
							g.lineTo(0, -span * exMinY);
							
							g.moveTo(span * exMinX1, 0);
							g.lineTo(span * exMinX1, -span * exMinY);
						}
						else
						{
							g.moveTo(span * exMinX1, 0);
							g.lineTo(span * exMinX1, -span * exMinY);
							g.lineTo(0, -span * exMinY);
							
							g.moveTo(span * exMinX0, 0);
							g.lineTo(span * exMinX0, -span * exMinY);
						}
					}
					else
					{
						g.moveTo(span * exMinX0, 0);
						g.lineTo(span * exMinX0, -span * exMinY);
						g.lineTo(span * exMinX1, -span * exMinY);
						g.lineTo(span * exMinX1, 0);
					}
				}
			}
		}
		
		g.endStroke();
	}
	catch(e)
	{
		alert("drawDotLine:" + e.tostring());
	}
}

// +------------+
// | 数式の編集 |
// +------------+
function changeFormulaContainer(frm, str, x, y, col)
{
	if ( str == "" )	{	return;		}
	
	array = [ "x", "y", "k" ];			// 斜体にしたい文字をここにセットする
	
	var color;
	switch( col )
	{
		case "blue":
			color = "#007AC5";
			break;
		case "red":
			color = "#FF0000";
			break;
		default:
			color = "#000000";
			break;
	}
	
	changeFormulaStringContainer(frm, str, array, 18, "", color);
	frm.x = x;
	frm.y = y;
	frm.visible = true;
}

// +------------------------+
// | テキストの表示位置計算 |
// +------------------------+
function getFormulaPosition()
{
	try
	{
		
	}
	catch(e)
	{
		alert("getFormulaPosition:" + e.toString());
	}
}

//	+----------+
//	| 値の入力 |
//	+----------+
function changeAreaHandler(e)
{
	try
	{
		var f=-1;
		var t0;
		var t1;
		var n;
		
		switch(e.currentTarget.id)
		{
			case "upBtn1_0":
				if(minNum+stepSize<maxNum)
				{
					f=0;
					t0 = "aMin";
					t1 = "minNum";
					n=minNum+stepSize;
				}
				break;
				
			case "downBtn1_0":
				f=0;
				t0 = "aMin";
				t1 = "minNum";
				n=minNum-stepSize;
				break;
				
			case "upBtn1_1":
				f=1;
				t0 = "aMax";
				t1 = "maxNum";
				n=maxNum+stepSize;
				break;
				
			case "downBtn1_1":
				if(maxNum - stepSize > minNum)
				{
					f=1;
					t0 = "aMax";
					t1 = "maxNum";
					n=maxNum-stepSize;
				}
				break;
		}
		
		if(f!=-1)
		{
			n = Math.round(n * 10000)/10000;
			
			$("#"+t0).html(n);
			$("#"+t1).html(n);
			
			if(f==0)
			{
				minNum=n;
			}
			else
			{
				maxNum=n;
			}
			
			calcData();
			
			drawArea();
			
			drawLine();
			
			drawText();
			
			cs.update();
		}
	}
	catch(e)
	{
		alert("changeAreaHandler:" + e.toString());
	}
}

function drawArea()
{
	try
	{
		area.graphics.clear();
		area.graphics.setStrokeStyle(0);
		area.graphics.beginStroke("#FDE9BC");
		area.graphics.beginFill("#FDE9BC");
		area.graphics.drawRect(minNum*span, -cH/2, (maxNum-minNum)*span, cH);
		area.graphics.endFill();
		area.graphics.endStroke();
	}
	catch(e)
	{
		alert("drawArea:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面オープン |
// +----------------------------+
function openOptionHandler(e)
{
	try
	{
		//式の値を設定
		document.getElementById('text0_0').value = aNum;
		document.getElementById('text0_1').value = bNum;
		document.getElementById('text0_2').value = cNum;
		document.getElementById('text0_3').value = dNum;
		
		showModal('optionBlock');
	}
	catch(e)
	{
		alert('openOptionHandler:' + e.toString());
	}
}

// +----------------+
// | 式の値変更入力 |
// +----------------+
function changeFormulaHandler(e)
{
	try
	{
		var str = e.currentTarget.id;
		str = str.substring(str.length-3, str.length);
		
		var elm = document.getElementById("text"+str);
		
		var num = parseFloat(elm.value);
		
		if(e.currentTarget.id.indexOf("upBtn") != -1)
		{
			num=Math.round((num+stepSize)*10000)/10000;

			if(str == "0_0" && num==0)
			{
				num=stepSize;
			}
		}
		else
		{
			num=Math.round((num-stepSize)*10000)/10000;

			if(str == "0_0" && num==0)
			{
				num=-stepSize;
			}
		}
		
		elm.value = num;
	}
	catch(e)
	{
		alert("changeFormulaHandler:" + e.toString());
	}
}

// +----------------------------+
// | 式の値変更入力画面クローズ |
// +----------------------------+
function closeOptionHandler(e)
{
	try
	{
		aNum = parseFloat(document.getElementById("text0_0").value);
		bNum = parseFloat(document.getElementById("text0_1").value);
		cNum = parseFloat(document.getElementById("text0_2").value);
		dNum = parseFloat(document.getElementById("text0_3").value);
		
		calcData();
		
		changeFormula();
		drawLine();
		drawText();
		
		cs.update();
		
		closeModal();
	}
	catch(e)
	{
		alert("closeOptionHandler:" + e.toString());
	}
}

//	+------------------------------+
//	| チェックボックスのオン・オフ |
//	+------------------------------+
function changeCheckHandler(e)
{
	try
	{
		var str = e.currentTarget.id;
		
		if(str == "check0")
		{
			line.visible = e.currentTarget.checked;
			form.visible = e.currentTarget.checked;
		}
		else if(str == "check1")
		{
			area.visible = e.currentTarget.checked;
			drawLine();
		}
		else if(str == "check2")
		{
			changeMinMaxPointDisplay();
			
			drawText();
		}
		else if(str == "check3")
		{
			changeMinMaxPointDisplay();
			
			drawText();
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}


//	+------------------------+
//	| 隠しボタンのオン・オフ |
//	+------------------------+
function openResultHandler(e)
{
	try
	{
		switch (e.currentTarget.id)
		{
			case "openBtn0_0":
				if($("#result0").css("display") == "block")
				{
					$("#result0").css("display", "none");
				}
				else
				{
					$("#result0").css("display", "block");
				}
				break;
				
			case "openBtn0_1":
				if($("#idTable").css("display") == "table")
				{
					$("#idTable").css("display", "none");
				}
				else
				{
					$("#idTable").css("display", "table");
				}
				break;
				
			case "openBtn2":
				if($("#result2").css("display") == "block")
				{
					$("#result2").css("display", "none");
				}
				else
				{
					$("#result2").css("display", "block");
				}
				drawText();
				break;
				
			case "openBtn3":
				if($("#result3").css("display") == "block")
				{
					$("#result3").css("display", "none");
				}
				else
				{
					$("#result3").css("display", "block");
				}
				drawText();
				break;
		}
		
		cs.update();
	}
	catch(e)
	{
		alert("changeCheckHandler:" + e.toString());
	}
}

//増減表の変更
function changeTable()
{
	try
	{
		/*
		他コンテンツへの流用を考慮してセルのID名の数字の振り方を変則にしているので注意
		*/
		
		//エリアの両端の値
		//左端
		$("#td0_6").html(minNum);
		$("#td1_6").html(getDifferentialString(minNum));
		$("#td2_6").html(Math.round(getFormulaResult(minNum)*100)/100);
		
		
		//極値がない
		if(exData.length <= 1)
		{
				$("#td1_1").html(getDifferentialString((minNum+maxNum)/2));
				changeArrowImage("img2_1", (minNum+maxNum)/2);
				
				$("#td0_2").html(maxNum);
				$("#td1_2").html(getDifferentialString(maxNum));
				$("#td2_2").html(Math.round(getFormulaResult(maxNum)*100)/100);

				//セルの表示切替
				//極値
				changeCellVisibility(2, true);
				
				changeCellVisibility(3, false);
				
				//極値
				changeCellVisibility(4, false);
				changeCellVisibility(5, false);
				
				//右端
				changeCellVisibility(7, false);
		}
		//極値が２つ
		else if(exData.length == 2)
		{
			//極値がエリアの端に含むか，エリア内にない場合
			if((maxNum <= exData[0]) || (minNum >= exData[1]))
			{
				$("#td1_1").html(getDifferentialString((minNum+maxNum)/2));
				changeArrowImage("img2_1", (minNum+maxNum)/2);
				
				$("#td0_2").html(maxNum);
				$("#td1_2").html(getDifferentialString(maxNum));
				$("#td2_2").html(Math.round(getFormulaResult(maxNum)*100)/100);
				
				//セルの表示切替
				//極値
				changeCellVisibility(2, true);
				
				changeCellVisibility(3, false);
				
				//極値
				changeCellVisibility(4, false);
				changeCellVisibility(5, false);
				
				//右端
				changeCellVisibility(7, false);
			}
			//範囲の内側に極値が両方収まる場合
			else if((minNum < exData[0]) && (exData[1] < maxNum))
			{
				$("#td1_1").html(getDifferentialString((minNum+exData[0])/2));
				changeArrowImage("img2_1", (minNum+exData[0])/2);
				
				$("#td0_2").html(Math.round(exData[0] * 100)/100);
				$("#td1_2").html("0");
				$("#td2_2").html(Math.round(getFormulaResult(exData[0])*100)/100);
				
				$("#td1_3").html(getDifferentialString((exData[0]+exData[1])/2));
				changeArrowImage("img2_3", (exData[0]+exData[1])/2);
				
				$("#td0_4").html(Math.round(exData[1] * 100)/100);
				$("#td1_4").html("0");
				$("#td2_4").html(Math.round(getFormulaResult(exData[1])*100)/100);
				
				$("#td1_5").html(getDifferentialString((exData[1]+maxNum)/2));
				changeArrowImage("img2_5", (exData[1]+maxNum)/2);
				
				$("#td0_7").html(maxNum);
				$("#td1_7").html(getDifferentialString(maxNum));
				$("#td2_7").html(Math.round(getFormulaResult(maxNum)*100)/100);
				
				
				//セルの表示切替
				//極値
				changeCellVisibility(2, true);
				changeCellVisibility(3, true);
				//極値
				changeCellVisibility(4, true);
				changeCellVisibility(5, true);
				
				changeCellVisibility(7, true);
			}
			//左の極値が無効になる場合
			else if(minNum >=exData[0])
			{
				//範囲が極値の内側に収まる場合
				if(maxNum <= exData[1])
				{
					$("#td1_1").html(getDifferentialString((minNum+maxNum)/2));
					changeArrowImage("img2_1", (minNum+maxNum)/2);
					
					$("#td0_2").html(maxNum);
					$("#td1_2").html(getDifferentialString(maxNum));
					$("#td2_2").html(Math.round(getFormulaResult(maxNum)*100)/100);
					
					//セルの表示切替
					//極値
					changeCellVisibility(2, true);
					
					
					changeCellVisibility(3, false);
					//極値
					changeCellVisibility(4, false);
					changeCellVisibility(5, false);
					
					
					changeCellVisibility(7, false);
				}
				else
				{
					$("#td1_1").html(getDifferentialString((minNum+exData[1])/2));
					changeArrowImage("img2_1", (minNum+exData[1])/2);
					
					$("#td0_2").html(Math.round(exData[1] * 100)/100);
					$("#td1_2").html("0");
					$("#td2_2").html(Math.round(getFormulaResult(exData[1])*100)/100);
					
					$("#td1_3").html(getDifferentialString((exData[1]+maxNum)/2));
					changeArrowImage("img2_3", (exData[1]+maxNum)/2);
					
					$("#td0_4").html(maxNum);
					$("#td1_4").html(getDifferentialString(maxNum));
					$("#td2_4").html(Math.round(getFormulaResult(maxNum)*100)/100);
					
					//セルの表示切替
					//極値
					changeCellVisibility(2, true);
					changeCellVisibility(3, true);
					//極値
					changeCellVisibility(4, true);
					
					changeCellVisibility(5, false);
					
					changeCellVisibility(7, false);
				}
			}
			//右の極値が無効になる場合
			else if(maxNum <= exData[1])
			{
				//範囲が極値の内側に収まる場合
				if(minNum >= exData[0])
				{
					$("#td1_1").html(getDifferentialString((minNum+maxNum)/2));
					changeArrowImage("img2_1", (minNum+maxNum)/2);
					
					$("#td0_2").html(maxNum);
					$("#td1_2").html(getDifferentialString(maxNum));
					$("#td2_2").html(Math.round(getFormulaResult(maxNum)*100)/100);
					
					//セルの表示切替
					///極値
					changeCellVisibility(2, true);
					
					changeCellVisibility(3, false);
					//極値
					changeCellVisibility(4, false);
					changeCellVisibility(5, false);
					
					changeCellVisibility(7, false);
				}
				else
				{
					$("#td1_1").html(getDifferentialString((minNum+exData[0])/2));
					changeArrowImage("img2_1", (minNum+exData[0])/2);
				
					$("#td0_2").html(Math.round(exData[0] * 100)/100);
					$("#td1_2").html("0");
					$("#td2_2").html(Math.round(getFormulaResult(exData[0])*100)/100);
					
					$("#td1_3").html(getDifferentialString((exData[0]+maxNum)/2));
					changeArrowImage("img2_3", (exData[0]+maxNum)/2);
					
					$("#td0_4").html(maxNum);
					$("#td1_4").html(getDifferentialString(maxNum));
					$("#td2_4").html(Math.round(getFormulaResult(maxNum)*100)/100);
					
					//セルの表示切替
					//極値
					changeCellVisibility(2, true);
					changeCellVisibility(3, true);
					//極値
					changeCellVisibility(4, true);
					
					changeCellVisibility(5, false);
					
					changeCellVisibility(7, false);
				}
			}
		}
	}
	catch(e)
	{
		alert("changeTable:" + e.toString());
	}
}

function changeCellVisibility(n, f)
{
	var str;
	
	if(f)
	{
		str = "visible";
	}
	else
	{
		str = "collapse";
	}
	
	$("#row"+n).css("visibility", str);
	
	for(var i=0; i<3; i++)
	{
		$("#td"+i+"_"+n).css("visibility", str);
	}
}

function getDifferentialString(x)
{
	try
	{
		var n = getDifferentialResult(x);
		
		if(n == 0)
		{
			return "0";
		}
		else if(n > 0)
		{
			return "+";
		}
		else
		{
			return "-";
		}
	}
	catch(e)
	{
		alert("getDifferentialString:" + e.toString());
	}
}

function changeArrowImage(id, n)
{
	try
	{
		var f = getDifferentialResult(n);
		
		if(f > 0)
		{
			$("#"+id).attr("src", "./img/arrowUp.png");
		}
		else
		{
			$("#"+id).attr("src", "./img/arrowDown.png");
		}
	}
	catch(e)
	{
		alert("chagneArrowImage:" + e.toString());
	}
}

//	+--------------------------+
//	| キャンバスのドラッグ開始 |
//	+--------------------------+
function canvasDragStart(e)
{
	if(dFlag)
	{
		prevX = e.stageX;
		prevY = e.stageY;
		
		if(ictMode)
		{
			$(window).on("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.addEventListener('touchend', dragStop);
		}
		else
		{
			document.addEventListener('mouseup', dragStop);
		}
		
		e.currentTarget.addEventListener("pressmove", canvasDragMove);
		e.currentTarget.addEventListener("pressup", canvasDragStop);
	}
}

//	+----------------------+
//	| キャンバスのドラッグ |
//	+----------------------+
function canvasDragMove(e)
{
	try
	{
		var p = $("#graphCanvas").position();
		
		//座標の変化量
		var sX;
		var sY;
		
		if(cScale >= 1)
		{
			sX = e.stageX - prevX;
			sY = e.stageY - prevY;
		}
		else
		{
			sX = (e.stageX - prevX) * cScale;
			sY = (e.stageY - prevY) * cScale;
		}
		
		//移動限界
		var limitX = cW * 1/3 - cW * cScale;
		var limitY = cH * 1/3 - cH * cScale;
		
		//Xの差分移動
		if(p.left + sX >= 0)
		{
			document.getElementById("graphCanvas").style.left = "0px";
			
			prevX = e.stageX;
		}
		else if(p.left + sX <= limitX)
		{
			document.getElementById("graphCanvas").style.left = limitX + "px";
			
			prevX = e.stageX;
		}
		else
		{
			document.getElementById("graphCanvas").style.left = (p.left + sX) + "px";
		}
		
		//Yの差分移動
		if(p.top + sY >= 0)
		{
			document.getElementById("graphCanvas").style.top = "0px";
			
			prevY = e.stageY;
		}
		else if(p.top + sY <= limitY)
		{
			document.getElementById("graphCanvas").style.top = limitY + "px";
			
			prevY = e.stageY;
		}
		else
		{
			document.getElementById("graphCanvas").style.top = (p.top + sY) + "px";
		}
		
		changeAxisPositionHandler();
		changeGraphScale(configArray[1][0], configArray[1][1]);
		cs.update();
	}
	catch(e)
	{
		alert("canvasDragMove:" + e.toString());
	}
	
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function canvasDragStop(e)
{
	e.currentTarget.removeEventListener("pressmove", canvasDragMove);
	e.currentTarget.removeEventListener("pressup", canvasDragStop);
}

//	+--------------------------+
//	| キャンバスのドラッグ終了 |
//	+--------------------------+
function dragStop(e)
{
	try
	{
		if(ictMode)
		{
			$(window).off("touchend mouseup", dragStop);
		}
		else if(mFlag)
		{
			document.removeEventListener('touchend', dragStop);
		}
		else
		{
			document.removeEventListener('mouseup', dragStop);
		}
	}
	catch(e)
	{
		alert(e.toString());	
	}
}

//	+----------------------+
//	| 刻み幅の設定画面表示 |
//	+----------------------+
function openMenuBalloonHandler(e)
{
	try
	{
		var inner;
		var data;
		if ( e.currentTarget.id == "stepText" )
		{
			inner = [0.1, 0.2, 0.5, 1, 2, 5, 10];
			data = [0.1, 0.2, 0.5, 1, 2, 5, 10];
		}
		openSelectBalloon("selectBalloon_menu", "menuBlock", e.currentTarget.id, inner, data, changeStepSize);
	}
	catch(e)
	{
		alert("openMenuBalloonHandler:"+e.toString());
	}
}

//	+--------------+
//	| 刻み幅の変更 |
//	+--------------+
function changeStepSize(id, num)
{
	try
	{
		stepSize = num;
		var n;
		
		// 設定した刻み幅の倍数に変更
		n   = Math.round(aNum/num) * num;
		aNum = Math.round(n * 100)/100;
		
		if(aNum == 0)
		{
			aNum = stepSize;
		}
		
		n   = Math.round(bNum/num) * num;
		bNum = Math.round(n * 100)/100;
		
		n   = Math.round(cNum/num) * num;
		cNum = Math.round(n * 100)/100;
		
		n   = Math.round(dNum/num) * num;
		dNum = Math.round(n * 100)/100;
		
		n   = Math.round(minNum/num) * num;
		minNum = Math.round(n * 100)/100;
		
		n   = Math.round(maxNum/num) * num;
		maxNum = Math.round(n * 100)/100;
		
		if(maxNum <= minNum)
		{
			maxNum = Math.round((minNum + num)/num) * num;
		}
		
		$("#aMin").html(minNum);
		$("#minNum").html(minNum);
		
		$("#aMax").html(maxNum);
		$("#maxNum").html(maxNum);
		
		// 計算処理
		calcData();
		
		// 式の表示
		changeFormula();
		
		//区間の描画
		drawArea();
		
		// 図形の表示
		drawLine();
		
		// テキストの表示
		drawText();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeStepSize:" + e.toString());
	}
}


//	+--------------+
//	| スケール変更 |
//	+--------------+
function changeGraphScale(sX, sY)
{
	try
	{
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		//x軸
		base.graphics.moveTo(0, cH/2);
		base.graphics.lineTo(cW, cH/2);
		
		//y軸
		base.graphics.moveTo(cW/2, 0);
		base.graphics.lineTo(cW/2, cH);
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の目盛
		if(sX != null)
		{
			var spanX = span * sX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				base.graphics.moveTo(i, cH/2-5);
				base.graphics.lineTo(i, cH/2+5);
			}
		}
		
		
		//y軸の目盛
		if(sY != null)
		{
			spanY = span * sY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				base.graphics.moveTo(cW/2-5, i);
				base.graphics.lineTo(cW/2+5, i);
			}
		}
	}
	catch(e)
	{
		alert("changeGraphScale:" + e.toString());
	}
}

//	+--------------+
//	| グリッド変更 |
//	+--------------+
function changeGraphGrid(gX, gY)
{
	try
	{
		grid.graphics.clear();
		grid.graphics.setStrokeStyle(0.5);
		grid.graphics.beginStroke("#00A0FF");
		
		var i;
		
		var spanX;
		var spanY;
		
		//x軸の線
		if(gX != null)
		{
			var spanX = span * gX;
			for(i = cW/2-spanX; i>0; i=i-spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
			
			for(i = cW/2+spanX; i<cW; i=i+spanX)
			{
				grid.graphics.moveTo(i, 0);
				grid.graphics.lineTo(i, cH);
			}
		}
		
		
		//y軸の線
		if(gY != null)
		{
			spanY = span * gY;
			for(i = cH/2-spanY; i>0; i=i-spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
			
			for(i = cH/2+spanY; i<cH; i=i+spanY)
			{
				grid.graphics.moveTo(0, i);
				grid.graphics.lineTo(cW, i);
			}
		}
	}
	catch(e)
	{
		alert('changeGraphGrid:' + e.toString());
	}
}

//	+----------------+
//	| グラフ目盛作成 |
//	+----------------+
function createPointText(str)
{
	try
	{
		var c = new createjs.Container();
		
		if(str != "")
		{
			changePointText(c, str);
		}
		
		return c;
	}
	catch(e)
	{
		alert("createPointText:" + e.toString());
	}
}

//	+----------------+
//	| グラフ目盛変更 |
//	+----------------+
function changePointText(c, str)
{
	try
	{
		//削除
		if(c.getNumChildren() > 0)
		{
			c.removeAllChildren();
		}
		
		//弧度法
		if(str.indexOf("π") != -1)
		{
			//頭文字がマイナスの場合
			if(str.substring(0, 1) == "-")
			{
				var t0_0 = new createjs.Text("-", "16px Times New Roman", "#000000");
				c.addChild(t0_0);
				str = str.substring(1, str.length);
			}
			
			//πが頭にある場合
			if(str.indexOf("π") == 0)
			{
				var t0_1 = new createjs.Text("π", "Italic 16px Times New Roman", "#000000");
				
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_2 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_0 = createEaselFrac(t0_1, t0_2);
					c.addChild(cFrac0_0);
				}
				else
				{
					c.addChild(t0_1);
				}
			}
			else
			{
				//分数の場合
				if(str.indexOf("/") != -1)
				{
					var t0_3 = new createjs.Text(str.substring(0, str.indexOf("/")), "16px Times New Roman", "#000000");
					var t0_4 = new createjs.Text(str.substring(str.indexOf("/")+1, str.length), "16px Times New Roman", "#000000");
					var cFrac0_1 = createEaselFrac(t0_3, t0_4);
					c.addChild(cFrac0_1);
				}
				else
				{
					var t0_5 = new createjs.Text(str, "16px Times New Roman", "#000000");
					c.addChild(t0_5);
				}
			}
		}
		//度数法 もしくは　数値
		else
		{
			var t1_0 = new createjs.Text(str, "16px Times New Roman", "#000000");
			c.addChild(t1_0);
		}
		
		var w = 0;
		var h = 0;
		
		var leng = c.getNumChildren();
		
		for(var i=0; i<leng; i++)
		{
			var b = c.getChildAt(i).getBounds();
			w += b.width;
			if(h < b.height)
			{
				h = b.height;
			}
		}
		
		h = h/2;
		
		var n = -w/2;
		for(i=0; i<leng; i++)
		{
			var t = c.getChildAt(i);
			
			t.x = n;
			n += t.getBounds().width;
			
			t.y = h-t.getBounds().height/2;
		}
	}
	catch(e)
	{
		alert("changePointText:" + str + "-" + e.toString());
	}
}

// +----------+
// | 状態保存 |
// +----------+
function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [aNum, bNum, cNum, dNum];
		array[1] = [minNum, maxNum];
		
		array[2] = [];
		array[2][0] = $("#check0").prop("checked");
		array[2][1] = $("#check1").prop("checked");
		array[2][2] = $("#check2").prop("checked");
		array[2][3] = $("#check3").prop("checked");
		
		array[3] = [];
		array[3][0] = $("#result0").css("display");
		array[3][1] = $("#idTable").css("display");
		array[3][2] = $("#result2").css("display");
		array[3][3] = $("#result3").css("display");
		
		array[4] = configArray.slice();
		
		array[5] = stepSize;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

// +----------+
// | 状態読込 |
// +----------+
function loadContent(array)
{
	try
	{
		aNum = array[0][0];
		bNum = array[0][1];
		cNum = array[0][2];
		dNum = array[0][3];
		
		minNum = array[1][0];
		maxNum = array[1][1];
		
		$("#check0").prop("checked", array[2][0]);
		$("#check1").prop("checked", array[2][1]);
		$("#check2").prop("checked", array[2][2]);
		$("#check3").prop("checked", array[2][3]);
		
		$("#result0").css("display", array[3][0]);
		$("#idTable").css("display", array[3][1]);
		$("#result2").css("display", array[3][2]);
		$("#result3").css("display", array[3][3]);
		
		$("aMin").html(minNum);
		$("minNum").html(minNum);
		
		$("aMax").html(maxNum);
		$("maxNum").html(maxNum);
		
		form.visible = array[2][0];
		line.visible = array[2][0];
		
		area.visible = array[2][1];
		
		// 計算処理
		calcData();
		
		// 式の表示
		changeFormula();
		
		//区間の描画
		drawArea();
		
		// 図形の表示
		drawLine();
		
		// テキストの表示
		drawText();
		
		configArray = array[4].slice();
		
		setConfigTableNumber("cItem1_0", configArray[1][0], true);
		setConfigTableNumber("cItem1_1", configArray[1][1], false);
		setConfigTableNumber("cItem2_0", configArray[2][0], true);
		setConfigTableNumber("cItem2_1", configArray[2][1], false);
		
		changeScaleText();
		
		stepSize = array[5];
		
		$("#stepSize").html(stepSize);
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

// +----------+
// | リセット |
// +----------+
function resetHandler(e)
{
	try
	{
		stepSize = 1;
		
		$("#stepSize").html(1);
		
		//設定吹き出し
		configArray = [];
		configArray[0] = [-30, 360, -10, 10];
		configArray[1] = [null, null];
		configArray[2] = [null, null];
		
		//目盛の表示切替
		changeMethodNumberHandler();

		changeScaleText();

		changeGraphScale(null, null);

		changeGraphGrid(null, null);

		aNum = defA;
		bNum = defB;
		cNum = defC;
		dNum = defD;
		
		minNum = defMin;
		maxNum = defMax;
		
		$("#minNum").html(defMin);
		$("#maxNum").html(defMax);
		
		$("#aMin").html(defMin);
		$("#aMax").html(defMax);
		
		$("#result0").css("display", "none");
		$("#idTable").css("display", "none");
		$("#result2").css("display", "none");
		$("#result3").css("display", "none");
		
		$("#check0").prop("checked", true);
		$("#check1").prop("checked", false);
		$("#check2").prop("checked", false);
		$("#check3").prop("checked", false);
		
		line.visible = true;
		form.visible = true;
		
		area.visible = false;
		
		// 計算処理
		calcData();
		
		// 式の表示
		changeFormula();
		
		//区間の描画
		drawArea();
		
		// 図形の表示
		drawLine();
		
		// テキストの表示
		drawText();
		
		// ステージ更新
		cs.update();
	}
	catch(e)
	{
		alert('resetHandler:' + e.toString());
	}
}
